/**

        project     PAFEE
 *      @file:     pafee_stdio.h
 *      @author:   Technocrats
 *      @brief:    Structure tool define header

*/

#ifndef _PAFEE_STDIO_H_INCLUDED
#define _PAFEE_STDIO_H_INCLUDED

#ifdef PAFEE_LIB_STDIO_ENABLE

#ifdef __cplusplus
extern "C" {
#endif

/**
 * @brief  stdio::sprintf function
 * @param  convert string
 * @return result
 * @retval if false result=0
 * @retval if true  result=num
 */
int pafee_sprintf(
	char *convertString,
	const char *pFormat,
	...
);
#ifdef __cplusplus
}
#endif


#else // PAFEE_LIB_STDIO_ENABLE

#include <stdio.h>
#define pafee_sprintf   sprintf
#if 0
#define pafee_snprintf  snprintf
#endif

#endif // PAFEE_LIB_STDIO_ENABLE


#ifdef __cplusplus
extern "C" {
#endif
/**
 * @brief  stdio.snprintf function
 * @param  convert string
 * @return result
 * @retval if false result=0
 * @retval if true  result=num
 */
int pafee_snprintf(
	char *convertString,
	const unsigned int maxSize,
	const char *pFormat,
	...
);

#ifdef __cplusplus
}
#endif

#endif /* _PAFEE_STDIO_H_INCLUDED */
