/**

        project     PAFEE
 *      @file:     pafee_stdlib.h
 *      @author:   Technocrats
 *      @brief:    Structure tool define header

*/

#ifndef _PAFEE_STDLIB_H_INCLUDED
#define _PAFEE_STDLIB_H_INCLUDED

#ifdef PAFEE_LIB_STDLIB_ENABLE

#ifdef __cplusplus
extern "C" {
#endif

/**
 * @brief  stdlib::atoi function
 * @param  convert string
 * @return result
 * @retval if false result=0
 * @retval if true  result=num
 */
int pafee_atoi(
	const char *convertString
);

/**
 * @brief  stdlib::atol function
 * @param  convert string
 * @return result
 * @retval if false result=0
 * @retval if true  result=num
 */
long pafee_atol(
	const char *convertString
);

/**
 * @brief  string to long integer
 * @param  convert string
 * @return result
 * @retval if false result=0
 * @retval if true  result=num
 */
long pafee_strtol(
	const char * restrictString,
	char ** restrictEnd,
	int base
);

/**
 * @brief  string to unsigned long integer
 * @param  convert string
 * @return result
 * @retval if false result=0
 * @retval if true  result=num
 */
unsigned long pafee_strtoul(
	const char * restrictString,
	char ** restrictEnd,
	int base
);

#ifdef __cplusplus
}
#endif

#else // PAFEE_LIB_STDLIB_ENABLE
#include <stdlib.h>
#define pafee_atoi atoi
#define pafee_atol atol
#define pafee_strtol strtol
#define pafee_strtoul strtoul
#endif // PAFEE_LIB_STDLIB_ENABLE


#endif /* _PAFEE_STDLIB_H_INCLUDED */
