//#define OVERFLOW_TEST

#include <stdio.h>  // for "printf()"
#include "pafee_string.h"

void pafee_string_test1(void);
void pafee_string_test2(void);

int main(int argc, char* argv[])
{
	pafee_string_test1();
//	pafee_string_test2();

	printf("Hello World!\n");
	return 0;
}

void pafee_string_test2(
	void
)
{
	char buf[64] = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ#";
	const char* cbuf = buf;
	char target[8] = "xxxxxxx";
	const void *retbuf;

	printf("\n////////pafee_strchr\n\n");
	
	printf("buf: %s\n", cbuf);
	retbuf = pafee_strchr(cbuf, 'A');
	printf("ret: %s\n", retbuf);
	retbuf = pafee_strchr(cbuf, 32545);
	if(retbuf == NULL)
	{
		printf("ret: NULL\n");
	}
	else
	{
		printf("ret: %s\n", retbuf);
	}
	
	retbuf = pafee_strchr(target, 'x');
	if(retbuf == NULL)
	{
		printf("ret: NULL\n");
	}
	else
	{
		printf("ret: %s\n", retbuf);
	}

	retbuf = pafee_strchr(target, 'A');
	if(retbuf == NULL)
	{
		printf("ret: NULL\n");
	}
	else
	{
		printf("ret: %s\n", retbuf);
	}

#ifdef OVERFLOW_TEST
	retbuf = pafee_strchr(cbuf, '\0');
	if(retbuf == NULL)
	{
		printf("ret: NULL\n");
	}
	else
	{
		printf("ret: %s\n", retbuf);
	}
#endif

}

void pafee_string_test1(
	void
)
{
	char buf[64] = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ#";
	char *buf2 = buf+16;
	char *buf3 = buf+32;
	char target[8] = "xxxxxxx";
	char freebuf[32] = "\0";
	char init[64];
	int result = 0;
	void *retbuf;
	
	pafee_memcpy(init, buf, 64);
	printf("\n////////pafee_memcmp\n\n");

	result = pafee_memcmp(target, buf, 7);
	printf("%d\n", result);
	result = pafee_memcmp(target, buf, 0);
	printf("%d\n", result);
	result = pafee_memcmp(target, buf, 15);
	printf("%d\n", result);

	printf("\n////////pafee_memcpy\n\n");

	printf("buf: %s\n", buf);
	printf("%s\n", target);
	retbuf = pafee_memcpy(buf, target, 0);
	printf("buf: %s\n", buf);
	printf("%s\n", target);
	printf("ret: %s\n", retbuf);
	retbuf = pafee_memcpy(buf, target, 2);
	printf("buf: %s\n", buf);
	printf("%s\n", target);
	printf("ret: %s\n", retbuf);
	retbuf = pafee_memcpy(buf2, buf, 8);
	printf("buf: %s\n", buf);
	printf("ret: %s\n", retbuf);
	retbuf = pafee_memcpy(buf3, buf2, 20);
	printf("buf: %s\n", buf);
	printf("ret: %s\n", retbuf);
#ifdef OVERFLOW_TEST
	retbuf = pafee_memcpy(buf3, buf, 36);
	printf("buf: %s\n", buf);
	printf("ret: %s\n", retbuf);
#endif
	
	printf("\n////////pafee_memmove\n\n");
	pafee_memcpy(buf, init, 64);
	
	printf("buf: %s\n", buf);
	printf("%s\n", target);
	retbuf = pafee_memmove(buf, target, 0);
	printf("buf: %s\n", buf);
	printf("%s\n", target);
	printf("ret: %s\n", retbuf);
	retbuf = pafee_memmove(buf, target, 2);
	printf("buf: %s\n", buf);
	printf("%s\n", target);
	printf("ret: %s\n", retbuf);
	retbuf = pafee_memmove(buf2, buf, 8);
	printf("buf: %s\n", buf);
	printf("ret: %s\n", retbuf);
	retbuf = pafee_memmove(buf3, buf2, 20);
	printf("buf: %s\n", buf);
	printf("ret: %s\n", retbuf);
#ifdef OVERFLOW_TEST
	retbuf = pafee_memmove(buf3, buf, 36);
	printf("buf: %s\n", buf);
	printf("ret: %s\n", retbuf);
#endif
	
	printf("\n////////pafee_memset\n\n");
	pafee_memcpy(buf, init, 64);

	printf("buf: %s\n", buf);
	retbuf = pafee_memset(buf, 0x40, 24);
	printf("buf: %s\n", buf);
	printf("ret: %s\n", retbuf);
	retbuf = pafee_memset(buf, 0x25, 13);
	printf("buf: %s\n", buf);
	printf("ret: %s\n", retbuf);
#ifdef OVERFLOW_TEST
	retbuf = pafee_memset(buf, 0x24, 65);
	printf("buf: %s\n", buf);
	printf("ret: %s\n", retbuf);
#endif
	
	printf("\n////////pafee_strcat\n\n");
	pafee_memcpy(buf, init, 64);
	
	printf("buf: %s\n", buf);
	retbuf = pafee_strcat(freebuf, buf3);
	printf("buf: %s\n", freebuf);
	printf("ret: %s\n", retbuf);
	
#ifdef OVERFLOW_TEST
	retbuf = pafee_strcat(freebuf, target);
	printf("buf: %s\n", freebuf);
	printf("ret: %s\n", retbuf);
#endif
	printf("ret: %s\n", target);

	
	printf("\n////////pafee_strncat\n\n");
	pafee_memcpy(buf, init, 64);
	pafee_memset(freebuf, '\0', sizeof(freebuf));
	
	printf("buf: %s\n", buf);
	retbuf = pafee_strncat(freebuf, target, 5);
	printf("buf: %s\n", freebuf);
	printf("ret: %s\n", retbuf);
	
	retbuf = pafee_strncat(freebuf, target, 0);
	printf("buf: %s\n", freebuf);
	printf("ret: %s\n", retbuf);
	
	retbuf = pafee_strncat(freebuf, target, 10);
	printf("buf: %s\n", freebuf);
	printf("ret: %s\n", retbuf);

#ifdef OVERFLOW_TEST
	retbuf = pafee_strncat(freebuf, target, 13);
	printf("buf: %s\n", freebuf);
	printf("ret: %s\n", retbuf);

	retbuf = pafee_strncat(freebuf, target, -3);
	printf("buf: %s\n", freebuf);
	printf("ret: %s\n", retbuf);
#endif

	printf("\n////////pafee_strcpy\n\n");
	pafee_memcpy(buf, init, 64);
	
	printf("buf: %s\n", buf);
	retbuf = pafee_strcpy(buf, target);
	printf("buf: %s\n", buf);
	printf("ret: %s\n", retbuf);

	retbuf = pafee_strcpy(buf3, target);
	printf("buf: %s\n", buf);
	printf("ret: %s\n", retbuf);
	
	retbuf = pafee_strcpy(buf2, buf3);
	printf("buf: %s\n", buf);
	printf("ret: %s\n", retbuf);
	
	printf("\n////////pafee_strncpy\n\n");
	pafee_memcpy(buf, init, 64);
	
	printf("buf: %s\n", buf);
	retbuf = pafee_strncpy(buf, target, 7);
	printf("buf: %s\n", buf);
	printf("ret: %s\n", retbuf);

	retbuf = pafee_strncpy(buf3, target, 30);
	printf("buf: %s\n", buf);
	printf("ret: %s\n", retbuf);

	retbuf = pafee_strncpy(buf2, buf3, 10);
	printf("buf: %s\n", buf);
	printf("ret: %s\n", retbuf);
#ifdef OVERFLOW_TEST
	retbuf = pafee_strncpy(buf2, buf3, 36);
	printf("buf: %s\n", buf);
	printf("ret: %s\n", retbuf);
#endif
	
	printf("\n////////pafee_strlen\n\n");
	pafee_memcpy(buf, init, 64);
	
	result = pafee_strlen(buf);
	printf("%d\n", result);
	
	result = pafee_strlen(buf3);
	printf("%d\n", result);

	result = pafee_strlen(target);
	printf("%d\n", result);
	
	result = pafee_strlen("\0");
	printf("%d\n", result);
	
	printf("\n////////pafee_strcmp\n\n");
	pafee_memcpy(buf, init, 64);
	
	result = pafee_strcmp(buf, target);
	printf("%d\n", result);
	result = pafee_strcmp(buf, buf3);
	printf("%d\n", result);
	result = pafee_strcmp(buf, init);
	printf("%d\n", result);
	result = pafee_strcmp("\0", init);
	printf("%d\n", result);
	
	printf("\n////////pafee_strstr\n\n");
	pafee_memcpy(buf, init, 64);
	
	printf("buf: %s\n", buf);
	retbuf = pafee_strstr(buf, "A");
	printf("ret: %s\n", retbuf);
	
	retbuf = pafee_strstr(buf, buf3);
	printf("ret: %s\n", retbuf);

	retbuf = pafee_strstr(target, "A");
	if(retbuf == NULL)
	{
		printf("ret: NULL\n");
	}
	else
	{
		printf("ret: %s\n", retbuf);
	}

	retbuf = pafee_strstr(buf, "aba");
	if(retbuf == NULL)
	{
		printf("ret: NULL\n");
	}
	else
	{
		printf("ret: %s\n", retbuf);
	}
	
	printf("\n////////pafee_strrstr\n\n");
	pafee_memcpy(buf, init, 64);
	
	printf("buf: %s\n", buf);
	retbuf = pafee_strrstr(buf, "xyz");
	printf("ret: %s\n", retbuf);
	
	retbuf = pafee_strrstr(buf, buf3);
	printf("ret: %s\n", retbuf);

	retbuf = pafee_strrstr(target, "A");
	if(retbuf == NULL)
	{
		printf("ret: NULL\n");
	}
	else
	{
		printf("ret: %s\n", retbuf);
	}

	retbuf = pafee_strrstr(buf, "aba");
	if(retbuf == NULL)
	{
		printf("ret: NULL\n");
	}
	else
	{
		printf("ret: %s\n", retbuf);
	}
	
	printf("\n////////pafee_strchr\n\n");
	pafee_memcpy(buf, init, 64);
	
	printf("buf: %s\n", buf);
	retbuf = pafee_strchr(buf, 'A');
	printf("ret: %s\n", retbuf);
	retbuf = pafee_strchr(buf, 32545);
	if(retbuf == NULL)
	{
		printf("ret: NULL\n");
	}
	else
	{
		printf("ret: %s\n", retbuf);
	}
	
	retbuf = pafee_strchr(target, 'x');
	if(retbuf == NULL)
	{
		printf("ret: NULL\n");
	}
	else
	{
		printf("ret: %s\n", retbuf);
	}

	retbuf = pafee_strchr(target, 'A');
	if(retbuf == NULL)
	{
		printf("ret: NULL\n");
	}
	else
	{
		printf("ret: %s\n", retbuf);
	}

#ifdef OVERFLOW_TEST
	retbuf = pafee_strchr(buf, '\0');
	if(retbuf == NULL)
	{
		printf("ret: NULL\n");
	}
	else
	{
		printf("ret: %s\n", retbuf);
	}
#endif

	printf("\n////////pafee_strrchr\n\n");
	pafee_memcpy(buf, init, 64);
	
	printf("buf: %s\n", buf);
	retbuf = pafee_strrchr(buf, 'A');
	printf("ret: %s\n", retbuf);
	retbuf = pafee_strrchr(buf, 32545);
	if(retbuf == NULL)
	{
		printf("ret: NULL\n");
	}
	else
	{
		printf("ret: %s\n", retbuf);
	}
	
	retbuf = pafee_strrchr(target, 'x');
	if(retbuf == NULL)
	{
		printf("ret: NULL\n");
	}
	else
	{
		printf("ret: %s\n", retbuf);
	}

	retbuf = pafee_strrchr(target, 'A');
	if(retbuf == NULL)
	{
		printf("ret: NULL\n");
	}
	else
	{
		printf("ret: %s\n", retbuf);
	}

#ifdef OVERFLOW_TEST
	retbuf = pafee_strrchr(buf, '\0');
	if(retbuf == NULL)
	{
		printf("ret: NULL\n");
	}
	else
	{
		printf("ret: %s\n", retbuf);
	}
#endif
}