#include <stdio.h>
#include <list>
#include <assert.h>
#include "PafeeListT.h"

int main()
{
	{
		//STATISTICS
		int addCount=0;
		int deleteCount=0;
		int maxElementCount=0;
		int presentElementCount=0;
#ifdef PAFEE_STATISTICS_ENABLE
		Pafee::ListT<int>::STATISTICS statisticsRtn;
#endif

		Pafee::ListT<int> myListt01;
		assert(myListt01.IsEmpty());
		assert(myListt01.GetCount()==0);	
		int Count=0;
		//AddBack Test with IsEmpty GetCount
		int i;
		for(i=0;i<10;i++)
		{
			assert(myListt01.AddBack(i));
			Count++;
			//
			addCount++;
			maxElementCount++;
			presentElementCount++;
			//
			assert(myListt01.IsEmpty()==false);
			assert(myListt01.GetCount()==Count);		
		}
#ifdef PAFEE_STATISTICS_ENABLE
		myListt01.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

		//GetAt GetNext Test
		Pafee::ListT<int>::POSITION pos = myListt01.GetFrontPosition();
		int dataAt,data;
		for(i=0;i<10;i++)
		{
			myListt01.GetAt(pos,dataAt);
			data = myListt01.GetNext(pos);
			assert(dataAt==i);
			assert(data==i);	
		}
		//GetAt GetPrevious Test
		pos = myListt01.GetBackPosition();
		for(i=10;i>0;)
		{
			--i;
			myListt01.GetAt(pos,dataAt);
			data = myListt01.GetPrevious(pos);
			assert(dataAt==i);
			assert(data==i);	
		}

		//RemoveFront Test
		for(i=0;i<10;i++)
		{
			assert(myListt01.GetFront()==i);
			assert(myListt01.GetBack()==9);
			myListt01.RemoveFront();
			Count--;
			//
			deleteCount++;
			presentElementCount--;
			//
			assert(myListt01.GetCount()==Count);		
		}

#ifdef PAFEE_STATISTICS_ENABLE
		myListt01.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

		//AddFront Test
		assert(myListt01.GetCount()==0);		
		for( i=0;i<10;i++)
		{
			assert(myListt01.AddFront(i));
			Count++;
			//
			addCount++;
	//		maxElementCount++;
			presentElementCount++;
			//
			assert(myListt01.GetCount()==Count);		
		}
#ifdef PAFEE_STATISTICS_ENABLE
		myListt01.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

		pos = myListt01.GetFrontPosition();
		//RemoveBack Test
		pos = myListt01.GetFrontPosition();	
		int vCount=10;
		i=0;
		while(1)
		{
			vCount--;
			i++;
			myListt01.RemoveBack();
			if (myListt01.GetCount()==0)
			{
				Count--;
				//
				deleteCount++;
				presentElementCount--;
				//
				break;
			}
			Count--;
			//
			deleteCount++;
	//		maxElementCount++;
			presentElementCount--;
			//
			assert(myListt01.GetCount()==Count);
			assert(myListt01.GetFront()==9);
			assert(myListt01.GetBack()==i);
		}
#ifdef PAFEE_STATISTICS_ENABLE
		myListt01.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

		assert(myListt01.GetCount()==0);		
		//SetAt Test
//		int c = Count;
		for( i=0;i<10;i++)
		{
			assert(myListt01.AddFront(i));
			addCount++;
	//		maxElementCount++;
			presentElementCount++;

			Count++;
			assert(myListt01.GetCount()==Count);		
		}
		pos = myListt01.GetFrontPosition();
		for(i=10;i>0;)
		{
			--i;
			myListt01.GetAt(pos,dataAt);
			myListt01.SetAt(pos,dataAt*10);
			data = myListt01.GetNext(pos);
			assert(dataAt==i);
			assert(data==i*10);	
		}
		//GetBackPosition,RemoveAtTest
		pos = myListt01.GetBackPosition();
		for(i=0;i<10;i++)
		{
			int vabk = myListt01.GetBack();
			pos = myListt01.GetBackPosition();
			int vabkAt;
			myListt01.GetAt(pos, vabkAt);
			assert(vabkAt == vabk);
			myListt01.RemoveAt(pos);
			deleteCount++;
	//		maxElementCount++;
			presentElementCount--;
		}

#ifdef PAFEE_STATISTICS_ENABLE
		myListt01.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

		assert(myListt01.IsEmpty());
		assert(myListt01.GetCount()==0);	
		//RemoveAll Test
		for( i=0;i<10;i++)
		{
			assert(myListt01.AddFront(i));
			addCount++;
			presentElementCount++;
		}
		myListt01.RemoveAll();
		deleteCount+=10;
		presentElementCount-=10;
		assert(myListt01.IsEmpty());
		assert(myListt01.GetCount()==0);	

#ifdef PAFEE_STATISTICS_ENABLE
		myListt01.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif
	}
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
	{
		//STATISTICS
		int addCount=0;
		int deleteCount=0;
		int maxElementCount=0;
		int presentElementCount=0;
#ifdef PAFEE_STATISTICS_ENABLE
		Pafee::ListT<int>::STATISTICS statisticsRtn;
#endif

		Pafee::ListT<int> myListt00;
		assert(myListt00.IsEmpty());
		assert(myListt00.GetCount()==0);	
		int Count=0;
		//AddBack Test with IsEmpty GetCount
		int i;
		for(i=0;i<10;i++)
		{
			assert(myListt00.AddBack(i));
			Count++;
			//
			addCount++;
			maxElementCount++;
			presentElementCount++;
			//
			assert(myListt00.IsEmpty()==false);
			assert(myListt00.GetCount()==Count);		
		}
#ifdef PAFEE_STATISTICS_ENABLE
		myListt00.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif


		//Pafee::ListT<int> myListt01=myListt00;
		Pafee::ListT<int> myListt01;
		myListt01=myListt00;

		//GetAt GetNext Test
		Pafee::ListT<int>::POSITION pos = myListt01.GetFrontPosition();
		int dataAt,data;
		for(i=0;i<10;i++)
		{
			myListt01.GetAt(pos,dataAt);
			data = myListt01.GetNext(pos);
			assert(dataAt==i);
			assert(data==i);	
		}
		//GetAt GetPrevious Test
		pos = myListt01.GetBackPosition();
		for(i=10;i>0;)
		{
			--i;
			myListt01.GetAt(pos,dataAt);
			data = myListt01.GetPrevious(pos);
			assert(dataAt==i);
			assert(data==i);	
		}

		//RemoveFront Test
		for(i=0;i<10;i++)
		{
			assert(myListt01.GetFront()==i);
			assert(myListt01.GetBack()==9);
			myListt01.RemoveFront();
			Count--;
			//
			deleteCount++;
			presentElementCount--;
			//
			assert(myListt01.GetCount()==Count);		
		}

#ifdef PAFEE_STATISTICS_ENABLE
		myListt01.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

		//AddFront Test
		assert(myListt01.GetCount()==0);		
		for( i=0;i<10;i++)
		{
			assert(myListt01.AddFront(i));
			Count++;
			//
			addCount++;
	//		maxElementCount++;
			presentElementCount++;
			//
			assert(myListt01.GetCount()==Count);		
		}
#ifdef PAFEE_STATISTICS_ENABLE
		myListt01.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

		pos = myListt01.GetFrontPosition();
		//RemoveBack Test
		pos = myListt01.GetFrontPosition();	
		int vCount=10;
		i=0;
		while(1)
		{
			vCount--;
			i++;
			myListt01.RemoveBack();
			if (myListt01.GetCount()==0)
			{
				Count--;
				//
				deleteCount++;
				presentElementCount--;
				//
				break;
			}
			Count--;
			//
			deleteCount++;
	//		maxElementCount++;
			presentElementCount--;
			//
			assert(myListt01.GetCount()==Count);
			assert(myListt01.GetFront()==9);
			assert(myListt01.GetBack()==i);
		}
#ifdef PAFEE_STATISTICS_ENABLE
		myListt01.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

		assert(myListt01.GetCount()==0);		
		//SetAt Test
//		int c = Count;
		for( i=0;i<10;i++)
		{
			assert(myListt01.AddFront(i));
			addCount++;
	//		maxElementCount++;
			presentElementCount++;

			Count++;
			assert(myListt01.GetCount()==Count);		
		}
		pos = myListt01.GetFrontPosition();
		for(i=10;i>0;)
		{
			--i;
			myListt01.GetAt(pos,dataAt);
			myListt01.SetAt(pos,dataAt*10);
			data = myListt01.GetNext(pos);
			assert(dataAt==i);
			assert(data==i*10);	
		}
		//GetBackPosition,RemoveAtTest
		pos = myListt01.GetBackPosition();
		for(i=0;i<10;i++)
		{
			int vabk = myListt01.GetBack();
			pos = myListt01.GetBackPosition();
			int vabkAt;
			myListt01.GetAt(pos, vabkAt);
			assert(vabkAt == vabk);
			myListt01.RemoveAt(pos);
			deleteCount++;
	//		maxElementCount++;
			presentElementCount--;
		}

#ifdef PAFEE_STATISTICS_ENABLE
		myListt01.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

		assert(myListt01.IsEmpty());
		assert(myListt01.GetCount()==0);	
		//RemoveAll Test
		for( i=0;i<10;i++)
		{
			assert(myListt01.AddFront(i));
			addCount++;
			presentElementCount++;
		}
		myListt01.RemoveAll();
		deleteCount+=10;
		presentElementCount-=10;
		assert(myListt01.IsEmpty());
		assert(myListt01.GetCount()==0);	

#ifdef PAFEE_STATISTICS_ENABLE
		myListt01.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif
	}




	return 0;
}
