#include "PafeeMapT.h"
#include "PafeeString.h"
#include <string>

#ifdef PAFEE_UNITTEST
#include <assert.h>
#endif

using namespace Pafee;
using namespace std;

int main()
{
	const int HASHSIZE=4;
	//
	//string
	//
	int i;
	int size = 0;
	string str = "123456789";
	string str2 = "abcdefghijklmn";
	string strOut;
	int tableSize;
	int loopCount=10;
	char cBuffer[2];
	//char *pSkey;
	//STATISTICS
	int addCount=0;
	int acqCount=0;
	int deleteCount=0;
	int maxElementCount=0;
	int collisionCount=0;
	int minListCount=0;
	int maxListCount=0;
	int presentElementCount=0;
	//
	int collisionarray[HASHSIZE];
	int eh;
	//
#ifdef PAFEE_STATISTICS_ENABLE
	MapT<string>::STATISTICS statisticsRtn;
#endif

	//Initialize
	tableSize = 5;
	MapT<string> mp1(tableSize);
	assert(!mp1.Initialize(10,NULL));

	//test Pattern 1 (Number Key)
	//Initialize/GetCount/IsEmpty/Set((AddBack is performed.))
	tableSize = 4;
	MapT<string> mp;
	mp.Initialize(tableSize,NULL);
	assert(mp.GetCount()==0);
	assert(mp.IsEmpty());

#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif
	int j;
	for (j=0;j<HASHSIZE;j++)
	{
		collisionarray[j]=0;
	}
	for (i=0;i<loopCount;i++)
	{
		assert(mp.Set(i,str));
		addCount++;
		presentElementCount++;
		collisionarray[mp.Hash(i)]++;
	}
	maxElementCount = loopCount;
	//collisionCount = presentElementCount-tableSize;
	//minListCount = presentElementCount / tableSize;
	//maxListCount = (presentElementCount / tableSize)+1;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mp.GetCount() == loopCount);
	assert(!mp.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set((SetAt is performed.))/Get/operator []
	for (i=0;i<loopCount;i++)
	{
		assert(mp.Set(i,str2));
		assert(mp.Get(i,strOut));
		acqCount++;
		assert(str2 == strOut);

		strOut = mp[i];
		acqCount++;
		assert(str2 == strOut);
	}

	//operator []((not found))
	strOut = mp[i];
	assert(str2 != strOut);
	strOut = mp[i+1];
	assert(str2 != strOut);

#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//GetStartPosition/GetNext
	size = mp.GetCount();
	assert(size == i);
	MapT<string>::POSITION pos = mp.GetStartPosition();
	for(i=0;i<size;i++)
	{
		assert(mp.GetNext(pos,strOut));
		assert(str2 == strOut);
	}
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	i=5;
	mp.Remove(i);
	collisionarray[mp.Hash(i)]--;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mp.GetCount() == (loopCount-1));
	assert(!mp.IsEmpty());
	deleteCount++;
	presentElementCount--;
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	i=6;
	mp.Remove(i);
	//
	collisionarray[mp.Hash(i)]--;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mp.GetCount() == (loopCount-2));
	assert(!mp.IsEmpty());
	deleteCount++;
	presentElementCount--;
	//minListCount--;
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mp.RemoveAll();
	for (j=0;j<HASHSIZE;j++)
	{
		collisionarray[j]=0;
	}
	//
	collisionCount=0;
	assert(!mp.GetCount());
	assert(mp.IsEmpty());
	deleteCount += presentElementCount;
	minListCount = 0;
	maxListCount = 0;
	presentElementCount = 0;
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set/GetCount
	for (i=0;i<loopCount;i++)
	{
		assert(mp.Set(i,str));
		addCount++;
		presentElementCount++;
		collisionarray[mp.Hash(i)]++;
	}
	//minListCount = presentElementCount / tableSize;
	//maxListCount = (presentElementCount / tableSize)+1;
	//collisionCount = collisionCount + (loopCount-tableSize);

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//test Pattern 2 (Character Key)
	//GetCount/IsEmpty/Set((AddBack is performed.))
	for (i=0;i<10;i++)
	{
		cBuffer[0] = (char)(i + 49);
		cBuffer[1] = '\0';
		assert(mp.Set(cBuffer,str));
		addCount++;
		collisionCount++;
		presentElementCount++;
		collisionarray[mp.Hash(cBuffer)]++;
	}
	maxElementCount = presentElementCount;
	//minListCount += loopCount/tableSize;
	//maxListCount += (loopCount/tableSize)+1;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

//	assert(mp.GetCount() == (loopCount*2));
	assert(!mp.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set((SetAt is performed.))/Get/operator []
	for (i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
//		pSkey = &c;
		cBuffer[1] = '\0';

		assert(mp.Set(cBuffer,str2));
		assert(mp.Get(cBuffer,strOut));
		acqCount++;
		assert(str2 == strOut);

		strOut = mp[cBuffer];
		acqCount++;
		assert(str2 == strOut);
	}

	//operator []((not found))
	cBuffer[0] = (char)(i + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	strOut = mp[cBuffer];
	assert(str2 != strOut);
	cBuffer[0] = (char)(i + 50);
	//pSkey = &c;
	cBuffer[1] = '\0';
	strOut = mp[cBuffer];
	assert(str2 != strOut);

#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//GetStartPosition/GetNext
	size = mp.GetCount();
	assert(size == (loopCount*2));
	pos = mp.GetStartPosition();
	/*
	for(i=0;i<size;i++)
	{
		assert(mp.GetNext(pos,strOut));
		if((i==3) || (i==4) || (i==8) || (i==9) || (i==10) || (i==13) || (i==14) || (i==15) || (i==18) || (i==19))
		{
			assert(str2 == strOut);
		}
		else
		{
			assert(str == strOut);
		}
	}
	*/
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	i=2;
	cBuffer[0] = (char)(i + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	mp.Remove(cBuffer);

	collisionarray[mp.Hash(cBuffer)]--;

	assert(mp.GetCount() == ((loopCount*2)-1));
	assert(!mp.IsEmpty());
	deleteCount++;
	//minListCount--;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	presentElementCount--;
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	i=8;
	cBuffer[0] = (char)(i + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	mp.Remove(cBuffer);
	collisionarray[mp.Hash(cBuffer)]--;

	assert(mp.GetCount() == ((loopCount*2)-2));
	assert(!mp.IsEmpty());
	deleteCount++;
	//maxListCount--;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}
	presentElementCount--;
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mp.RemoveAll();
	for (j=0;j<HASHSIZE;j++)
	{
		collisionarray[j]=0;
	}

	collisionCount=0;

	assert(!mp.GetCount());
	assert(mp.IsEmpty());
	deleteCount += presentElementCount;
	minListCount = 0;
	maxListCount = 0;
	presentElementCount = 0;
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set/GetCount
	for (i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mp.Set(cBuffer,str));
		addCount++;
		presentElementCount++;
		collisionarray[mp.Hash(cBuffer)]++;
	}
	//collisionCount += loopCount-tableSize;
	//minListCount = loopCount/tableSize;
	//maxListCount = (loopCount/tableSize)+1;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//test PafeeString
	size = 0;
	Pafee::String pafeeStr = "123456789";
	Pafee::String pafeeStr2 = "abcdefghijklmn";
	Pafee::String pafeeStrOut;
	//STATISTICS
	addCount=0;
	acqCount=0;
	deleteCount=0;
	maxElementCount=0;
	collisionCount=0;
	minListCount=0;
	maxListCount=0;
	presentElementCount=0;
	for (j=0;j<HASHSIZE;j++)
	{
		collisionarray[j]=0;
	}
#ifdef PAFEE_STATISTICS_ENABLE
	MapT<Pafee::String>::STATISTICS pafeeStatisticsRtn;
#endif

	//Initialize
	tableSize = 5;
	MapT<Pafee::String> mp2(tableSize);
	assert(!mp2.Initialize(10,NULL));

	//test Pattern 3(Number Key)
	//Initialize/GetCount/IsEmpty/Set((AddBack is performed.))
	tableSize = 4;
	MapT<Pafee::String> mp3;
	mp3.Initialize(tableSize,NULL);
	assert(mp3.GetCount()==0);
	assert(mp3.IsEmpty());

#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	for (i=0;i<loopCount;i++)
	{
		assert(mp3.Set(i,pafeeStr));
		addCount++;
		presentElementCount++;
		collisionarray[mp.Hash(i)]++;
	}
	maxElementCount = loopCount;
	//collisionCount = presentElementCount-tableSize;
	//minListCount = presentElementCount / tableSize;
	//maxListCount = (presentElementCount / tableSize)+1;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mp3.GetCount() == loopCount);
	assert(!mp3.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set((SetAt is performed.))/Get/operator []
	for (i=0;i<loopCount;i++)
	{
		assert(mp3.Set(i,pafeeStr2));
		assert(mp3.Get(i,pafeeStrOut));
		acqCount++;
		assert(pafeeStr2 == pafeeStrOut);

		pafeeStrOut = mp3[i];
		acqCount++;
		assert(pafeeStr2 == pafeeStrOut);
	}

	//operator []((not found))
	pafeeStrOut = mp3[i];
	assert(pafeeStr2 != pafeeStrOut);
	pafeeStrOut = mp3[i+1];
	assert(pafeeStr2 != pafeeStrOut);

#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//GetStartPosition/GetNext
	size = mp3.GetCount();
	assert(size == i);
	MapT<Pafee::String>::POSITION pafeePos = mp3.GetStartPosition();
	for(i=0;i<size;i++)
	{
		assert(mp3.GetNext(pafeePos,pafeeStrOut));
		assert(pafeeStr2 == pafeeStrOut);
	}
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	i=5;
	mp3.Remove(i);

	collisionarray[mp3.Hash(i)]--;

	assert(mp3.GetCount() == (loopCount-1));
	assert(!mp3.IsEmpty());

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	deleteCount++;
	presentElementCount--;
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	i=6;
	mp3.Remove(i);

	collisionarray[mp3.Hash(i)]--;

	assert(mp3.GetCount() == (loopCount-2));
	assert(!mp3.IsEmpty());
	deleteCount++;
	presentElementCount--;
	//minListCount--;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mp3.RemoveAll();

	for (j=0;j<HASHSIZE;j++)
	{
		collisionarray[j]=0;
	}

	assert(!mp3.GetCount());
	assert(mp3.IsEmpty());
	deleteCount += presentElementCount;
	minListCount = 0;
	maxListCount = 0;
	presentElementCount = 0;
	collisionCount=0;
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set/GetCount
	for (i=0;i<loopCount;i++)
	{
		assert(mp3.Set(i,pafeeStr));
		addCount++;
		presentElementCount++;
		collisionarray[mp3.Hash(i)]++;

	}
	//minListCount = presentElementCount / tableSize;
	//maxListCount = (presentElementCount / tableSize)+1;
	//collisionCount = collisionCount + (loopCount-tableSize);

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//test Pattern 4 (Character Key)
	//GetCount/IsEmpty/Set((AddBack is performed.))
	for (i=0;i<10;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mp3.Set(cBuffer,pafeeStr));
		addCount++;
		collisionCount++;
		presentElementCount++;
		collisionarray[mp3.Hash(cBuffer)]++;
	}
	maxElementCount = presentElementCount;
	//minListCount += loopCount/tableSize;
	//maxListCount += (loopCount/tableSize)+1;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mp3.GetCount() == (loopCount*2));
	assert(!mp3.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set((SetAt is performed.))/Get/operator []
	for (i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';

		assert(mp3.Set(cBuffer,pafeeStr2));
		assert(mp3.Get(cBuffer,pafeeStrOut));
		acqCount++;
		assert(pafeeStr2 == pafeeStrOut);

		pafeeStrOut = mp3[cBuffer];
		acqCount++;
		assert(pafeeStr2 == pafeeStrOut);
	}

	//operator []((not found))
	cBuffer[0] = (char)(i + 49);
	//pSkey = &c;
	//pSkey[1] = '\0';
	pafeeStrOut = mp3[cBuffer];
	assert(pafeeStr2 != pafeeStrOut);
	cBuffer[0] = (char)(i + 50);
	//pSkey = &c;
	cBuffer[1] = '\0';
	pafeeStrOut = mp3[cBuffer];
	assert(pafeeStr2 != pafeeStrOut);

#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//GetStartPosition/GetNext
	size = mp3.GetCount();
	assert(size == (loopCount*2));
	pafeePos = mp3.GetStartPosition();
	/*
	for(i=0;i<size;i++)
	{
		assert(mp3.GetNext(pafeePos,pafeeStrOut));
		if((i==3) || (i==4) || (i==8) || (i==9) || (i==10) || (i==13) || (i==14) || (i==15) || (i==18) || (i==19))
		{
			assert(pafeeStr2 == pafeeStrOut);
		}
		else
		{
			assert(pafeeStr == pafeeStrOut);
		}
	}
	*/
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	i=2;
	cBuffer[0] = (char)(i + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	mp3.Remove(cBuffer);
	collisionarray[mp.Hash(cBuffer)]--;
	assert(mp3.GetCount() == ((loopCount*2)-1));
	assert(!mp3.IsEmpty());
	deleteCount++;
	//minListCount--;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}


	presentElementCount--;
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	i=8;
	cBuffer[0] = (char)(i + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	mp3.Remove(cBuffer);
	collisionarray[mp3.Hash(cBuffer)]--;
	assert(mp3.GetCount() == ((loopCount*2)-2));
	assert(!mp3.IsEmpty());
	deleteCount++;
	//maxListCount--;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	presentElementCount--;
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mp3.RemoveAll();
	for (j=0;j<HASHSIZE;j++)
	{
		collisionarray[j]=0;
	}

	assert(!mp3.GetCount());
	assert(mp3.IsEmpty());
	deleteCount += presentElementCount;
	collisionCount=0;
	minListCount = 0;
	maxListCount = 0;
	presentElementCount = 0;
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set/GetCount
	for (i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mp3.Set(cBuffer,pafeeStr));
		addCount++;
		presentElementCount++;
		collisionarray[mp3.Hash(cBuffer)]++;
	}
	//collisionCount += loopCount-tableSize;
	//minListCount = loopCount/tableSize;
	//maxListCount = (loopCount/tableSize)+1;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif


/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

	size = 0;
	loopCount=10;

	//STATISTICS
	addCount=0;
	acqCount=0;
	deleteCount=0;
	maxElementCount=0;
	collisionCount=0;
	minListCount=0;
	maxListCount=0;
	presentElementCount=0;
	//
	//
//#ifdef PAFEE_STATISTICS_ENABLE
//	MapT<string>::STATISTICS statisticsRtn;
//#endif

	//test Pattern 1b (Number Key)
	//Initialize/GetCount/IsEmpty/Set((AddBack is performed.))
	tableSize = 4;
	MapT<string> mptb01;
	mptb01.Initialize(tableSize,NULL);

	for (j=0;j<HASHSIZE;j++)
	{
		collisionarray[j]=0;
	}
	for (i=0;i<loopCount;i++)
	{
		assert(mptb01.Set(i,str));
		addCount++;
		presentElementCount++;
		collisionarray[mptb01.Hash(i)]++;
	}
	maxElementCount = loopCount;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mptb01.GetCount() == loopCount);
	assert(!mptb01.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mptb01.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif


	MapT<string> mptb02= mptb01;

#ifdef PAFEE_STATISTICS_ENABLE
	mptb02.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set((SetAt is performed.))/Get/operator []
	for (i=0;i<loopCount;i++)
	{
		assert(mptb02.Get(i,strOut));
		acqCount++;
		assert(str == strOut);

		strOut = mptb02[i];
		acqCount++;
		assert(str == strOut);
	}

	//operator []((not found))
	strOut = mp[i];
	assert(str != strOut);
	strOut = mp[i+1];
	assert(str != strOut);

#ifdef PAFEE_STATISTICS_ENABLE
	mptb02.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//GetStartPosition/GetNext
	size = mptb02.GetCount();
	assert(size == i);
	MapT<string>::POSITION pos2 = mptb02.GetStartPosition();
	for(i=0;i<size;i++)
	{
		assert(mptb02.GetNext(pos2,strOut));
		assert(str == strOut);
	}
#ifdef PAFEE_STATISTICS_ENABLE
	mptb02.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	i=5;
	mptb02.Remove(i);
	collisionarray[mptb02.Hash(i)]--;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mptb02.GetCount() == (loopCount-1));
	assert(!mptb02.IsEmpty());
	deleteCount++;
	presentElementCount--;
#ifdef PAFEE_STATISTICS_ENABLE
	mptb02.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	i=6;
	mptb02.Remove(i);
	//
	collisionarray[mptb02.Hash(i)]--;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mptb02.GetCount() == (loopCount-2));
	assert(!mptb02.IsEmpty());
	deleteCount++;
	presentElementCount--;
	//minListCount--;
#ifdef PAFEE_STATISTICS_ENABLE
	mptb02.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mptb02.RemoveAll();
	for (j=0;j<HASHSIZE;j++)
	{
		collisionarray[j]=0;
	}
	//
	collisionCount=0;
	assert(!mptb02.GetCount());
	assert(mptb02.IsEmpty());
	deleteCount += presentElementCount;
	minListCount = 0;
	maxListCount = 0;
	presentElementCount = 0;
#ifdef PAFEE_STATISTICS_ENABLE
	mptb02.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set/GetCount
	for (i=0;i<loopCount;i++)
	{
		assert(mptb02.Set(i,str));
		addCount++;
		presentElementCount++;
		collisionarray[mptb02.Hash(i)]++;
	}

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mptb02.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//test Pattern 2 (Character Key)
	//GetCount/IsEmpty/Set((AddBack is performed.))
	for (i=0;i<10;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mptb02.Set(cBuffer,str));
		addCount++;
		collisionCount++;
		presentElementCount++;
		collisionarray[mptb02.Hash(cBuffer)]++;
	}
	maxElementCount = presentElementCount;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mptb02.GetCount() == (loopCount*2));
	assert(!mptb02.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mptb02.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	for (i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';

		assert(mptb02.Set(cBuffer,str2));
		assert(mptb02.Get(cBuffer,strOut));
		acqCount++;
		assert(str2 == strOut);

		strOut = mptb02[cBuffer];
		acqCount++;
		assert(str2 == strOut);
	}

	//operator []((not found))
	cBuffer[0] = (char)(i + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	strOut = mptb02[cBuffer];
	assert(str2 != strOut);
	cBuffer[0] = (char)(i + 50);
	//pSkey = &c;
	cBuffer[1] = '\0';
	strOut = mptb02[cBuffer];
	assert(str2 != strOut);

#ifdef PAFEE_STATISTICS_ENABLE
	mptb02.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//GetStartPosition/GetNext
	size = mptb02.GetCount();
	assert(size == (loopCount*2));
	pos = mptb02.GetStartPosition();
	/*
	for(i=0;i<size;i++)
	{
		assert(mp.GetNext(pos,strOut));
		if((i==3) || (i==4) || (i==8) || (i==9) || (i==10) || (i==13) || (i==14) || (i==15) || (i==18) || (i==19))
		{
			assert(str2 == strOut);
		}
		else
		{
			assert(str == strOut);
		}
	}
	*/
#ifdef PAFEE_STATISTICS_ENABLE
	mptb02.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	i=2;
	cBuffer[0] = (char)(i + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	mptb02.Remove(cBuffer);

	collisionarray[mptb02.Hash(cBuffer)]--;

	assert(mptb02.GetCount() == ((loopCount*2)-1));
	assert(!mptb02.IsEmpty());
	deleteCount++;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	presentElementCount--;
#ifdef PAFEE_STATISTICS_ENABLE
	mptb02.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	i=8;
	cBuffer[0] = (char)(i + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	mptb02.Remove(cBuffer);
	collisionarray[mptb02.Hash(cBuffer)]--;

	assert(mptb02.GetCount() == ((loopCount*2)-2));
	assert(!mptb02.IsEmpty());
	deleteCount++;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}
	presentElementCount--;
#ifdef PAFEE_STATISTICS_ENABLE
	mptb02.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mptb02.RemoveAll();
	for (j=0;j<HASHSIZE;j++)
	{
		collisionarray[j]=0;
	}

	collisionCount=0;

	assert(!mptb02.GetCount());
	assert(mptb02.IsEmpty());
	deleteCount += presentElementCount;
	minListCount = 0;
	maxListCount = 0;
	presentElementCount = 0;
#ifdef PAFEE_STATISTICS_ENABLE
	mptb02.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set/GetCount
	for (i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mptb02.Set(cBuffer,str));
		addCount++;
		presentElementCount++;
		collisionarray[mptb02.Hash(cBuffer)]++;
	}
	//collisionCount += loopCount-tableSize;
	//minListCount = loopCount/tableSize;
	//maxListCount = (loopCount/tableSize)+1;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mptb02.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//test PafeeString
	size = 0;
//	Pafee::String pafeeStr = "123456789";
//	Pafee::String pafeeStr2 = "abcdefghijklmn";
//	Pafee::String pafeeStrOut;
	//STATISTICS
	addCount=0;
	acqCount=0;
	deleteCount=0;
	maxElementCount=0;
	collisionCount=0;
	minListCount=0;
	maxListCount=0;
	presentElementCount=0;
	for (j=0;j<HASHSIZE;j++)
	{
		collisionarray[j]=0;
	}
#ifdef PAFEE_STATISTICS_ENABLE
	MapT<Pafee::String>::STATISTICS pafeestatisticsRtn;
#endif

	//Initialize
	tableSize = 5;
	MapT<Pafee::String> mpstr(tableSize);
	assert(!mp2.Initialize(10,NULL));

	tableSize = 4;
	MapT<Pafee::String> mpts01;
	mpts01.Initialize(tableSize,NULL);
	assert(mpts01.GetCount()==0);
	assert(mpts01.IsEmpty());

#ifdef PAFEE_STATISTICS_ENABLE
	mpts01.GetStatistics(&pafeestatisticsRtn);
	assert(pafeestatisticsRtn.addCount == addCount);
	assert(pafeestatisticsRtn.acqCount == acqCount);
	assert(pafeestatisticsRtn.deleteCount == deleteCount);
	assert(pafeestatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeestatisticsRtn.collisionCount == collisionCount);
	assert(pafeestatisticsRtn.minListCount == minListCount);
	assert(pafeestatisticsRtn.maxListCount == maxListCount);
	assert(pafeestatisticsRtn.presentElementCount == presentElementCount);
#endif

	for (i=0;i<loopCount;i++)
	{
		assert(mpts01.Set(i,pafeeStr));
		addCount++;
		presentElementCount++;
		collisionarray[mp.Hash(i)]++;
	}
	maxElementCount = loopCount;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mpts01.GetCount() == loopCount);
	assert(!mpts01.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mpts01.GetStatistics(&pafeestatisticsRtn);
	assert(pafeestatisticsRtn.addCount == addCount);
	assert(pafeestatisticsRtn.acqCount == acqCount);
	assert(pafeestatisticsRtn.deleteCount == deleteCount);
	assert(pafeestatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeestatisticsRtn.collisionCount == collisionCount);
	assert(pafeestatisticsRtn.minListCount == minListCount);
	assert(pafeestatisticsRtn.maxListCount == maxListCount);
	assert(pafeestatisticsRtn.presentElementCount == presentElementCount);
#endif
	//
//	MapT<Pafee::String> mpts02= mpts01;

	MapT<Pafee::String> mpts02;
	mpts02 = mpts01;
	//
	//Set((SetAt is performed.))/Get/operator []
	for (i=0;i<loopCount;i++)
	{
		assert(mpts02.Get(i,pafeeStrOut));
		acqCount++;
		assert(pafeeStr == pafeeStrOut);

		pafeeStrOut = mpts02[i];
		acqCount++;
		assert(pafeeStr == pafeeStrOut);
	}

	//operator []((not found))
	pafeeStrOut = mpts02[i];
	assert(pafeeStr != pafeeStrOut);
	pafeeStrOut = mpts02[i+1];
	assert(pafeeStr != pafeeStrOut);

#ifdef PAFEE_STATISTICS_ENABLE
	mpts02.GetStatistics(&pafeestatisticsRtn);
	assert(pafeestatisticsRtn.addCount == addCount);
	assert(pafeestatisticsRtn.acqCount == acqCount);
	assert(pafeestatisticsRtn.deleteCount == deleteCount);
	assert(pafeestatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeestatisticsRtn.collisionCount == collisionCount);
	assert(pafeestatisticsRtn.minListCount == minListCount);
	assert(pafeestatisticsRtn.maxListCount == maxListCount);
	assert(pafeestatisticsRtn.presentElementCount == presentElementCount);
#endif

	//GetStartPosition/GetNext
	size = mpts02.GetCount();
	assert(size == i);
	MapT<Pafee::String>::POSITION pafeePosb = mpts02.GetStartPosition();
	for(i=0;i<size;i++)
	{
		assert(mpts02.GetNext(pafeePosb,pafeeStrOut));
		assert(pafeeStr == pafeeStrOut);
	}
#ifdef PAFEE_STATISTICS_ENABLE
	mpts02.GetStatistics(&pafeestatisticsRtn);
	assert(pafeestatisticsRtn.addCount == addCount);
	assert(pafeestatisticsRtn.acqCount == acqCount);
	assert(pafeestatisticsRtn.deleteCount == deleteCount);
	assert(pafeestatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeestatisticsRtn.collisionCount == collisionCount);
	assert(pafeestatisticsRtn.minListCount == minListCount);
	assert(pafeestatisticsRtn.maxListCount == maxListCount);
	assert(pafeestatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	i=5;
	mpts02.Remove(i);
	collisionarray[mpts02.Hash(i)]--;
	assert(mpts02.GetCount() == (loopCount-1));
	assert(!mpts02.IsEmpty());
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	deleteCount++;
	presentElementCount--;
#ifdef PAFEE_STATISTICS_ENABLE
	mpts02.GetStatistics(&pafeestatisticsRtn);
	assert(pafeestatisticsRtn.addCount == addCount);
	assert(pafeestatisticsRtn.acqCount == acqCount);
	assert(pafeestatisticsRtn.deleteCount == deleteCount);
	assert(pafeestatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeestatisticsRtn.collisionCount == collisionCount);
	assert(pafeestatisticsRtn.minListCount == minListCount);
	assert(pafeestatisticsRtn.maxListCount == maxListCount);
	assert(pafeestatisticsRtn.presentElementCount == presentElementCount);
#endif

	i=6;
	mpts02.Remove(i);

	collisionarray[mpts02.Hash(i)]--;

	assert(mpts02.GetCount() == (loopCount-2));
	assert(!mpts02.IsEmpty());
	deleteCount++;
	presentElementCount--;
	//minListCount--;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mpts02.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mpts02.RemoveAll();

	for (j=0;j<HASHSIZE;j++)
	{
		collisionarray[j]=0;
	}

	assert(!mpts02.GetCount());
	assert(mpts02.IsEmpty());
	deleteCount += presentElementCount;
	minListCount = 0;
	maxListCount = 0;
	presentElementCount = 0;
	collisionCount=0;
#ifdef PAFEE_STATISTICS_ENABLE
	mpts02.GetStatistics(&pafeestatisticsRtn);
	assert(pafeestatisticsRtn.addCount == addCount);
	assert(pafeestatisticsRtn.acqCount == acqCount);
	assert(pafeestatisticsRtn.deleteCount == deleteCount);
	assert(pafeestatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeestatisticsRtn.collisionCount == collisionCount);
	assert(pafeestatisticsRtn.minListCount == minListCount);
	assert(pafeestatisticsRtn.maxListCount == maxListCount);
	assert(pafeestatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set/GetCount
	for (i=0;i<loopCount;i++)
	{
		assert(mpts02.Set(i,pafeeStr));
		addCount++;
		presentElementCount++;
		collisionarray[mp.Hash(i)]++;

	}

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mpts02.GetStatistics(&pafeestatisticsRtn);
	assert(pafeestatisticsRtn.addCount == addCount);
	assert(pafeestatisticsRtn.acqCount == acqCount);
	assert(pafeestatisticsRtn.deleteCount == deleteCount);
	assert(pafeestatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeestatisticsRtn.collisionCount == collisionCount);
	assert(pafeestatisticsRtn.minListCount == minListCount);
	assert(pafeestatisticsRtn.maxListCount == maxListCount);
	assert(pafeestatisticsRtn.presentElementCount == presentElementCount);
#endif

	//test Pattern 4 (Character Key)
	//GetCount/IsEmpty/Set((AddBack is performed.))
	for (i=0;i<10;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mpts02.Set(cBuffer,pafeeStr));
		addCount++;
		collisionCount++;
		presentElementCount++;
		collisionarray[mpts02.Hash(cBuffer)]++;
	}
	maxElementCount = presentElementCount;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mpts02.GetCount() == (loopCount*2));
	assert(!mpts02.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mpts02.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set((SetAt is performed.))/Get/operator []
	for (i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';

		assert(mpts02.Set(cBuffer,pafeeStr2));
		assert(mpts02.Get(cBuffer,pafeeStrOut));
		acqCount++;
		assert(pafeeStr2 == pafeeStrOut);

		pafeeStrOut = mpts02[cBuffer];
		acqCount++;
		assert(pafeeStr2 == pafeeStrOut);
	}

	//operator []((not found))
	cBuffer[0] = (char)(i + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	pafeeStrOut = mpts02[cBuffer];
	assert(pafeeStr2 != pafeeStrOut);
	cBuffer[0] = (char)(i + 50);
	//pSkey = &c;
	cBuffer[1] = '\0';
	pafeeStrOut = mpts02[cBuffer];
	assert(pafeeStr2 != pafeeStrOut);

#ifdef PAFEE_STATISTICS_ENABLE
	mpts02.GetStatistics(&pafeestatisticsRtn);
	assert(pafeestatisticsRtn.addCount == addCount);
	assert(pafeestatisticsRtn.acqCount == acqCount);
	assert(pafeestatisticsRtn.deleteCount == deleteCount);
	assert(pafeestatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeestatisticsRtn.collisionCount == collisionCount);
	assert(pafeestatisticsRtn.minListCount == minListCount);
	assert(pafeestatisticsRtn.maxListCount == maxListCount);
	assert(pafeestatisticsRtn.presentElementCount == presentElementCount);
#endif

	//GetStartPosition/GetNext
	size = mpts02.GetCount();
	assert(size == (loopCount*2));
	pafeePos = mpts02.GetStartPosition();
	/*
	for(i=0;i<size;i++)
	{
		assert(mp3.GetNext(pafeePos,pafeeStrOut));
		if((i==3) || (i==4) || (i==8) || (i==9) || (i==10) || (i==13) || (i==14) || (i==15) || (i==18) || (i==19))
		{
			assert(pafeeStr2 == pafeeStrOut);
		}
		else
		{
			assert(pafeeStr == pafeeStrOut);
		}
	}
	*/
#ifdef PAFEE_STATISTICS_ENABLE
	mpts02.GetStatistics(&pafeestatisticsRtn);
	assert(pafeestatisticsRtn.addCount == addCount);
	assert(pafeestatisticsRtn.acqCount == acqCount);
	assert(pafeestatisticsRtn.deleteCount == deleteCount);
	assert(pafeestatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeestatisticsRtn.collisionCount == collisionCount);
	assert(pafeestatisticsRtn.minListCount == minListCount);
	assert(pafeestatisticsRtn.maxListCount == maxListCount);
	assert(pafeestatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	i=2;
	cBuffer[0] = (char)(i + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	mpts02.Remove(cBuffer);
	collisionarray[mp.Hash(cBuffer)]--;
	assert(mpts02.GetCount() == ((loopCount*2)-1));
	assert(!mpts02.IsEmpty());
	deleteCount++;
	//minListCount--;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}


	presentElementCount--;
#ifdef PAFEE_STATISTICS_ENABLE
	mpts02.GetStatistics(&pafeestatisticsRtn);
	assert(pafeestatisticsRtn.addCount == addCount);
	assert(pafeestatisticsRtn.acqCount == acqCount);
	assert(pafeestatisticsRtn.deleteCount == deleteCount);
	assert(pafeestatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeestatisticsRtn.collisionCount == collisionCount);
	assert(pafeestatisticsRtn.minListCount == minListCount);
	assert(pafeestatisticsRtn.maxListCount == maxListCount);
	assert(pafeestatisticsRtn.presentElementCount == presentElementCount);
#endif

	i=8;
	cBuffer[0] = (char)(i + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	mpts02.Remove(cBuffer);
	collisionarray[mp.Hash(cBuffer)]--;
	assert(mpts02.GetCount() == ((loopCount*2)-2));
	assert(!mpts02.IsEmpty());
	deleteCount++;
	//maxListCount--;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	presentElementCount--;
#ifdef PAFEE_STATISTICS_ENABLE
	mpts02.GetStatistics(&pafeestatisticsRtn);
	assert(pafeestatisticsRtn.addCount == addCount);
	assert(pafeestatisticsRtn.acqCount == acqCount);
	assert(pafeestatisticsRtn.deleteCount == deleteCount);
	assert(pafeestatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeestatisticsRtn.collisionCount == collisionCount);
	assert(pafeestatisticsRtn.minListCount == minListCount);
	assert(pafeestatisticsRtn.maxListCount == maxListCount);
	assert(pafeestatisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mpts02.RemoveAll();
	for (j=0;j<HASHSIZE;j++)
	{
		collisionarray[j]=0;
	}

	assert(!mpts02.GetCount());
	assert(mpts02.IsEmpty());
	deleteCount += presentElementCount;
	collisionCount=0;
	minListCount = 0;
	maxListCount = 0;
	presentElementCount = 0;
#ifdef PAFEE_STATISTICS_ENABLE
	mpts02.GetStatistics(&pafeestatisticsRtn);
	assert(pafeestatisticsRtn.addCount == addCount);
	assert(pafeestatisticsRtn.acqCount == acqCount);
	assert(pafeestatisticsRtn.deleteCount == deleteCount);
	assert(pafeestatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeestatisticsRtn.collisionCount == collisionCount);
	assert(pafeestatisticsRtn.minListCount == minListCount);
	assert(pafeestatisticsRtn.maxListCount == maxListCount);
	assert(pafeestatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set/GetCount
	for (i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mpts02.Set(cBuffer,pafeeStr));
		addCount++;
		presentElementCount++;
		collisionarray[mpts02.Hash(cBuffer)]++;
	}

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mpts02.GetStatistics(&pafeestatisticsRtn);
	assert(pafeestatisticsRtn.addCount == addCount);
	assert(pafeestatisticsRtn.acqCount == acqCount);
	assert(pafeestatisticsRtn.deleteCount == deleteCount);
	assert(pafeestatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeestatisticsRtn.collisionCount == collisionCount);
	assert(pafeestatisticsRtn.minListCount == minListCount);
	assert(pafeestatisticsRtn.maxListCount == maxListCount);
	assert(pafeestatisticsRtn.presentElementCount == presentElementCount);
#endif
	return 0;

}
