#include "PafeeMultiMapT.h"
#include "PafeeString.h"
#include <string>

#ifdef PAFEE_UNITTEST
#include <assert.h>
#endif

using namespace Pafee;
using namespace std;

int main()
{
	const int HASHSIZE=4;
	//
	//string
	//
	int i;
	int size = 0;
	string str = "123456789";
	string str2 = "abcdefghijklmn";
	string str3 = "WWWWWXXXXXYYYYYZZZZZ";
	string strOut;
	int tableSize;
	int loopCount=6;
	char cBuffer[2];
	//char *pSkey;

	//STATISTICS
	int addCount=0;
	int acqCount=0;
	int deleteCount=0;
	int maxElementCount=0;
	int collisionCount=0;
	int minListCount=0;
	int maxListCount=0;
	int presentElementCount=0;
	//
	int collisionarray[HASHSIZE];
	int eh;
	//
#ifdef PAFEE_STATISTICS_ENABLE
	MultiMapT<string>::STATISTICS statisticsRtn;
#endif

	//Initialize
	tableSize = 5;
	MultiMapT<string> mp1(tableSize);
	assert(!mp1.Initialize(10,NULL));

	//
	//test Pattern 1
	//test Initialize/GetCount/IsEmpty/Set(int length)
	tableSize = 4;
	MultiMapT<string> mp;
	mp.Initialize(tableSize,NULL);
	assert(mp.GetCount()==0);
	assert(mp.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif
	int jj;
	for (jj=0;jj<HASHSIZE;jj++)
	{
		collisionarray[jj]=0;
	}
	for (i=0;i<loopCount;i++)
	{
		assert(mp.Set(i,str));
		addCount++;
		presentElementCount++;
		maxElementCount++;
		collisionarray[mp.Hash(i)]++;
	}
	//collisionCount = presentElementCount - tableSize;
	//minListCount = presentElementCount / tableSize;
	//maxListCount = (presentElementCount / tableSize)+1;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mp.GetCount() == presentElementCount);
	assert(!mp.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//test Set(int key)
	for (i=0;i<loopCount;i++)
	{
		assert(mp.Set(i,str2));
		addCount++;
		presentElementCount++;
		maxElementCount++;
		collisionarray[mp.Hash(i)]++;
		//collisionCount++;
	}
	for (i=0;i<loopCount;i++)
	{
		assert(mp.Set(i,str3));
		addCount++;
		presentElementCount++;
		maxElementCount++;
		collisionarray[mp.Hash(i)]++;
		//collisionCount++;
	}
	//minListCount = 3;
	//maxListCount = 6;



//	MultiMapT<string> mmpt2=mp;

//	MultiMapT<string> mmpt2;
//	mmpt2=mp;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//GetStartPosition(int key)/GetNext
	i = 5;
	MultiMapT<string>::POSITION pos = mp.GetStartPosition(i);
	assert(mp.GetNext(pos,strOut));
	assert(str == strOut);
	//GetNext
	assert(mp.GetNext(pos,strOut));
	assert(str2 == strOut);
	//GetNext
	assert(mp.GetNext(pos,strOut));
	assert(str3 == strOut);

	//GetStartPosition()/GetNext
	size = mp.GetCount();
	assert(size == presentElementCount);
	pos = mp.GetStartPosition();
	/*
	for(i=0;i<size;i++)
	{
		assert(mp.GetNext(pos,strOut));

		if((i == 0) || (i == 1) || (i == 6) || (i == 7) || (i == 12) || (i == 15))
		{
			assert(str == strOut);
		}
		else if((i == 2) || (i == 3) || (i == 8) || (i == 9) || (i == 13) || (i == 16))
		{
			assert(str2 == strOut);
		}
		else
		{
			assert(str3 == strOut);
		}
	}
	*/
	//GetStartPosition(int key)/GetNext((not found))
	i = 7;
	pos = mp.GetStartPosition(i);
	assert(!(mp.GetNext(pos,strOut)));

#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	i=5;
	mp.Remove(i);
	collisionarray[mp.Hash(i)]--;
	collisionarray[mp.Hash(i)]--;
	collisionarray[mp.Hash(i)]--;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}
	deleteCount+=3;
	presentElementCount-=3;
	assert(mp.GetCount() == presentElementCount);
	assert(!mp.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	i=2;
	mp.Remove(i);
	collisionarray[mp.Hash(i)]--;
	collisionarray[mp.Hash(i)]--;
	collisionarray[mp.Hash(i)]--;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	deleteCount+=3;
	presentElementCount-=3;
	//minListCount -= 3;
	assert(mp.GetCount() == presentElementCount);
	assert(!mp.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	i=0;
	mp.Remove(i);

	collisionarray[mp.Hash(i)]--;
	collisionarray[mp.Hash(i)]--;
	collisionarray[mp.Hash(i)]--;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	deleteCount+=3;
	presentElementCount-=3;
	//maxListCount-=3;
	assert(mp.GetCount() == presentElementCount);
	assert(!mp.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mp.RemoveAll();
	for (jj=0;jj<HASHSIZE;jj++)
	{
		collisionarray[jj]=0;
	}

	assert(!mp.GetCount());
	assert(mp.IsEmpty());
	deleteCount += presentElementCount;
	//minListCount = 0;
	//maxListCount = 0;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}
	presentElementCount = 0;
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set/GetCount
	for(i=0;i<loopCount;i++)
	{
		assert(mp.Set(i,str));
		addCount++;
		presentElementCount++;
		collisionarray[mp.Hash(i)]++;
	}
	//minListCount = presentElementCount / tableSize;
	//maxListCount = (presentElementCount / tableSize)+1;
	//collisionCount = collisionCount + (loopCount-tableSize);

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mp.RemoveAll();
	for (jj=0;jj<HASHSIZE;jj++)
	{
		collisionarray[jj]=0;
	}

	deleteCount += presentElementCount;
	minListCount = 0;
	maxListCount = 0;
	collisionCount = 0;
	presentElementCount = 0;

	//
	//test pattern 2
	//test GetCount/IsEmpty/Set
	assert(mp.GetCount()==0);
	assert(mp.IsEmpty());
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0]  = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mp.Set(cBuffer,str));
		addCount++;
		presentElementCount++;
		collisionarray[mp.Hash(cBuffer)]++;
	}
	//collisionCount += (loopCount/tableSize)+1;
	//minListCount += loopCount/tableSize;
	//maxListCount += (loopCount/tableSize)+1;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mp.GetCount() == presentElementCount);
	assert(!mp.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//test Set(character key)
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';

		assert(mp.Set(cBuffer,str2));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mp.Hash(cBuffer)]++;
	}
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mp.Set(cBuffer,str3));
		addCount++;
		presentElementCount++;
		collisionarray[mp.Hash(cBuffer)]++;
		//collisionCount++;
	}
	//minListCount = 3;
	//maxListCount = 6;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//GetStartPosition(character key)/GetNext
	cBuffer[0] = (char)(1 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	pos = mp.GetStartPosition(cBuffer);
	assert(mp.GetNext(pos,strOut));
	assert(str == strOut);
	//GetNext
	assert(mp.GetNext(pos,strOut));
	assert(str2 == strOut);
	//GetNext
	assert(mp.GetNext(pos,strOut));
	assert(str3 == strOut);

	//GetStartPosition()/GetNext
	size = mp.GetCount();
	assert(size == presentElementCount);
	pos = mp.GetStartPosition();
	/*
	for(i=0;i<size;i++)
	{
		assert(mp.GetNext(pos,strOut));
		if((i == 0) || (i == 3) || (i == 4) || (i == 9) || (i == 10) || (i == 15))
		{
			assert(str == strOut);
		}
		else if((i == 1) || (i == 5) || (i == 6) || (i == 11) || (i == 12) || (i == 16))
		{
			assert(str2 == strOut);
		}
		else
		{
			assert(str3 == strOut);
		}
	}
	*/
	//GetStartPosition(character key)/GetNext ((not found))
	cBuffer[0] = (char)(7 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	pos = mp.GetStartPosition(cBuffer);
	assert(!(mp.GetNext(pos,strOut)));

#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	cBuffer[0] = (char)(1 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	mp.Remove(cBuffer);

	collisionarray[mp.Hash(cBuffer)]--;
	collisionarray[mp.Hash(cBuffer)]--;
	collisionarray[mp.Hash(cBuffer)]--;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}
	deleteCount+=3;
	presentElementCount-=3;

	assert(mp.GetCount() == presentElementCount);
	assert(!mp.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	cBuffer[0] = (char)(2 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	mp.Remove(cBuffer);
	collisionarray[mp.Hash(cBuffer)]--;
	collisionarray[mp.Hash(cBuffer)]--;
	collisionarray[mp.Hash(cBuffer)]--;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	deleteCount+=3;
	//minListCount-=3;
	presentElementCount-=3;
	assert(mp.GetCount() == presentElementCount);
	assert(!mp.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mp.RemoveAll();
	for (jj=0;jj<HASHSIZE;jj++)
	{
		collisionarray[jj]=0;
	}
	collisionCount=0;
	assert(!mp.GetCount());
	assert(mp.IsEmpty());
	deleteCount += presentElementCount;
	minListCount = 0;
	maxListCount = 0;
	presentElementCount = 0;
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//
	//test pattern 3
	//Set(Number Key)
	for(i=0;i<loopCount;i++)
	{
		assert(mp.Set(i,str));
		addCount++;
		presentElementCount++;
		collisionarray[mp.Hash(i)]++;
//		if(i>=tableSize)
//		{
//			collisionCount++;
//		}
	}
	//Set(Character Key)
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mp.Set(cBuffer,str));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mp.Hash(cBuffer)]++;
	}
	//Set(Number Key)
	for(i=0;i<loopCount;i++)
	{
		assert(mp.Set(i,str2));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mp.Hash(i)]++;
	}
	//Set(Character Key)
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mp.Set(cBuffer,str2));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mp.Hash(cBuffer)]++;
	}
	//Set(Number Key)
	for(i=0;i<loopCount;i++)
	{
		assert(mp.Set(i,str3));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mp.Hash(i)]++;
	}
	//Set(Character Key)
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mp.Set(cBuffer,str3));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mp.Hash(cBuffer)]++;
	}
	maxElementCount = presentElementCount;
	//minListCount = 6;
	//maxListCount = 12;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//GetStartPosition(int key)/GetNext
	i = 5;
	pos = mp.GetStartPosition(i);
	assert(mp.GetNext(pos,strOut));

	assert(str == strOut);
	//GetNext
	assert(mp.GetNext(pos,strOut));

	assert(str2 == strOut);
	//GetNext
	assert(mp.GetNext(pos,strOut));

	assert(str3 == strOut);

	//GetStartPosition(character key)/GetNext
	cBuffer[0] = (char)(1 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	pos = mp.GetStartPosition(cBuffer);
	assert(mp.GetNext(pos,strOut));
	assert(str == strOut);
	//GetNext
	assert(mp.GetNext(pos,strOut));
	assert(str2 == strOut);
	//GetNext
	assert(mp.GetNext(pos,strOut));
	assert(str3 == strOut);

	//GetStartPosition()/GetNext
	size = mp.GetCount();
	assert(size == presentElementCount);
	pos = mp.GetStartPosition();
	/*
	for(i=0;i<size;i++)
	{
		assert(mp.GetNext(pos,strOut));
		//strOut = mp.GetNext(pos);
		if((i==0) || (i==1) || (i==2) || (i==9) || (i==10) || (i==11) || (i==12) || (i==21) || (i==22) || (i==23) || (i==30) || (i==31))
		{
			assert(str == strOut);
		}
		else if((i==3) || (i==4) || (i==5) || (i==13) || (i==14) || (i==15) || (i==16) || (i==24) || (i==25) || (i==26) || (i==32) || (i==33))
		{
			assert(str2 == strOut);
		}
		else
		{
			assert(str3 == strOut);
		}
	}
	*/
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	i=5;
	mp.Remove(i);
	//
	collisionarray[mp.Hash(i)]--;
	collisionarray[mp.Hash(i)]--;
	collisionarray[mp.Hash(i)]--;
	//
	deleteCount+=3;
	presentElementCount-=3;
	//maxListCount-=3;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}
	//
	assert(mp.GetCount() == presentElementCount);
	assert(!mp.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	cBuffer[0] = (char)(2 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	mp.Remove(cBuffer);
	collisionarray[mp.Hash(cBuffer)]--;
	collisionarray[mp.Hash(cBuffer)]--;
	collisionarray[mp.Hash(cBuffer)]--;

	deleteCount+=3;
	//minListCount-=3;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}
	presentElementCount-=3;
	assert(mp.GetCount() == presentElementCount);
	assert(!mp.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mp.RemoveAll();
	for (jj=0;jj<HASHSIZE;jj++)
	{
		collisionarray[jj]=0;
	}

	assert(!mp.GetCount());
	assert(mp.IsEmpty());
	deleteCount += presentElementCount;

	collisionCount = 0;
	minListCount = 0;
	maxListCount = 0;
	presentElementCount = 0;
#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set(Number Key)
	for(i=0;i<loopCount;i++)
	{
		assert(mp.Set(i,str));
		addCount++;
		presentElementCount++;
//		if(i>=tableSize)
//		{
//			collisionCount++;
//		}
		collisionarray[mp.Hash(i)]++;
	}
	//Set(Character Key)
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mp.Set(cBuffer,str));
		addCount++;
		presentElementCount++;
//		collisionCount++;
		collisionarray[mp.Hash(cBuffer)]++;
	}
	//minListCount = 2;
	//maxListCount = 4;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//
	//PafeeString 
	//
	size = 0;
	String pafeeStr = "123456789";
	String pafeeStr2 = "abcdefghijklmn";
	String pafeeStr3 = "WWWWWXXXXXYYYYYZZZZZ";
	String pafeeStrOut;

	//STATISTICS
	addCount=0;
	acqCount=0;
	deleteCount=0;
	maxElementCount=0;
	collisionCount=0;
	minListCount=0;
	maxListCount=0;
	presentElementCount=0;
	for (jj=0;jj<HASHSIZE;jj++)
	{
		collisionarray[jj]=0;
	}
#ifdef PAFEE_STATISTICS_ENABLE
	MultiMapT<String>::STATISTICS pafeeStatisticsRtn;
#endif

	//Initialize
	tableSize = 5;
	MultiMapT<String> mmpt2(tableSize);
	assert(!mmpt2.Initialize(10,NULL));

	//
	//test Pattern 1
	//test Initialize/GetCount/IsEmpty/Set(int length)
	tableSize = 4;
	MultiMapT<String> mp3;
	mp3.Initialize(tableSize,NULL);
	assert(mp3.GetCount()==0);
	assert(mp3.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	for(i=0;i<loopCount;i++)
	{
		assert(mp3.Set(i,pafeeStr));
		addCount++;
		presentElementCount++;
		maxElementCount++;

		collisionarray[mp3.Hash(i)]++;


	}
	//collisionCount = presentElementCount - tableSize;
	//minListCount = presentElementCount / tableSize;
	//maxListCount = (presentElementCount / tableSize)+1;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mp3.GetCount() == presentElementCount);
	assert(!mp3.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//test Set(int key)
	for(i=0;i<loopCount;i++)
	{
		assert(mp3.Set(i,pafeeStr2));
		addCount++;
		presentElementCount++;
		maxElementCount++;
		//collisionCount++;
		collisionarray[mp3.Hash(i)]++;

	}
	for(i=0;i<loopCount;i++)
	{
		assert(mp3.Set(i,pafeeStr3));
		addCount++;
		presentElementCount++;
		maxElementCount++;
		//collisionCount++;
		collisionarray[mp3.Hash(i)]++;
	}
	//minListCount = 3;
	//maxListCount = 6;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//GetStartPosition(int key)/GetNext
	i = 5;
	MultiMapT<String>::POSITION pafeePos = mp3.GetStartPosition(i);
	assert(mp3.GetNext(pafeePos,pafeeStrOut));
	assert(pafeeStr == pafeeStrOut);
	//GetNext
	assert(mp3.GetNext(pafeePos,pafeeStrOut));
	assert(pafeeStr2 == pafeeStrOut);
	//GetNext
	assert(mp3.GetNext(pafeePos,pafeeStrOut));
	assert(pafeeStr3 == pafeeStrOut);

	//GetStartPosition()/GetNext
	size = mp3.GetCount();
	assert(size == presentElementCount);
	pafeePos = mp3.GetStartPosition();
	/*
	for(i=0;i<size;i++)
	{
		assert(mp3.GetNext(pafeePos,pafeeStrOut));
		//pafeeStrOut = mp3.GetNext(pafeePos);
		if((i == 0) || (i == 1) || (i == 6) || (i == 7) || (i == 12) || (i == 15))
		{
			assert(pafeeStr == pafeeStrOut);
		}
		else if((i == 2) || (i == 3) || (i == 8) || (i == 9) || (i == 13) || (i == 16))
		{
			assert(pafeeStr2 == pafeeStrOut);
		}
		else
		{
			assert(pafeeStr3 == pafeeStrOut);
		}
	}
	*/
	//GetStartPosition(int key)/GetNext((not found))
	i = 7;
	pafeePos = mp3.GetStartPosition(i);
	assert(!(mp3.GetNext(pafeePos,pafeeStrOut)));

#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	i=5;
	mp3.Remove(i);

	collisionarray[mp3.Hash(i)]--;
	collisionarray[mp3.Hash(i)]--;
	collisionarray[mp3.Hash(i)]--;

	deleteCount+=3;
	presentElementCount-=3;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mp3.GetCount() == presentElementCount);
	assert(!mp3.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	i=2;
	mp3.Remove(i);

	collisionarray[mp3.Hash(i)]--;
	collisionarray[mp3.Hash(i)]--;
	collisionarray[mp3.Hash(i)]--;

	deleteCount+=3;
	presentElementCount-=3;
	//minListCount -= 3;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mp3.GetCount() == presentElementCount);
	assert(!mp3.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	i=0;
	mp3.Remove(i);
	collisionarray[mp3.Hash(i)]--;
	collisionarray[mp3.Hash(i)]--;
	collisionarray[mp3.Hash(i)]--;

	deleteCount+=3;
	presentElementCount-=3;
	//maxListCount-=3;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mp3.GetCount() == presentElementCount);
	assert(!mp3.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mp3.RemoveAll();

	for (jj=0;jj<HASHSIZE;jj++)
	{
		collisionarray[jj]=0;
	}

	assert(!mp3.GetCount());
	assert(mp3.IsEmpty());
	deleteCount += presentElementCount;

	collisionCount = 0;
	minListCount = 0;
	maxListCount = 0;
	presentElementCount = 0;
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set/GetCount
	for(i=0;i<loopCount;i++)
	{
		assert(mp3.Set(i,pafeeStr));
		addCount++;
		presentElementCount++;
		collisionarray[mp3.Hash(i)]++;

	}
	//minListCount = presentElementCount / tableSize;
	//maxListCount = (presentElementCount / tableSize)+1;
	//collisionCount = collisionCount + (loopCount-tableSize);

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mp3.RemoveAll();
	for (jj=0;jj<HASHSIZE;jj++)
	{
		collisionarray[jj]=0;
	}

	deleteCount += presentElementCount;

	collisionCount = 0;
	minListCount = 0;
	maxListCount = 0;
	presentElementCount = 0;

	//
	//test pattern 2
	//test GetCount/IsEmpty/Set
	assert(mp3.GetCount()==0);
	assert(mp3.IsEmpty());
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mp3.Set(cBuffer,pafeeStr));
		addCount++;
		presentElementCount++;
		collisionarray[mp3.Hash(cBuffer)]++;
	}
	//collisionCount += (loopCount/tableSize)+1;
	//minListCount += loopCount/tableSize;
	//maxListCount += (loopCount/tableSize)+1;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mp3.GetCount() == presentElementCount);
	assert(!mp3.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//test Set(character key)
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mp3.Set(cBuffer,pafeeStr2));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mp3.Hash(cBuffer)]++;
	}
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mp3.Set(cBuffer,pafeeStr3));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mp3.Hash(cBuffer)]++;
	}
	//minListCount = 3;
	//maxListCount = 6;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//GetStartPosition(character key)/GetNext
	cBuffer[0] = (char)(1 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	pafeePos = mp3.GetStartPosition(cBuffer);
	assert(mp3.GetNext(pafeePos,pafeeStrOut));
	assert(pafeeStr == pafeeStrOut);
	//GetNext
	assert(mp3.GetNext(pafeePos,pafeeStrOut));
	assert(pafeeStr2 == pafeeStrOut);
	//GetNext
	assert(mp3.GetNext(pafeePos,pafeeStrOut));
	//pafeeStrOut = mp3.GetNext(pafeePos
	assert(pafeeStr3 == pafeeStrOut);

	//GetStartPosition()/GetNext
	size = mp3.GetCount();
	assert(size == presentElementCount);
	pafeePos = mp3.GetStartPosition();
	/*
	for(i=0;i<size;i++)
	{
		assert(mp3.GetNext(pafeePos,pafeeStrOut));
		if((i == 0) || (i == 3) || (i == 4) || (i == 9) || (i == 10) || (i == 15))
		{
			assert(pafeeStr == pafeeStrOut);
		}
		else if((i == 1) || (i == 5) || (i == 6) || (i == 11) || (i == 12) || (i == 16))
		{
			assert(pafeeStr2 == pafeeStrOut);
		}
		else
		{
			assert(pafeeStr3 == pafeeStrOut);
		}
	}
	*/
	//GetStartPosition(character key)/GetNext ((not found))
	cBuffer[0] = (char)(7 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	pafeePos = mp3.GetStartPosition(cBuffer);
	assert(!(mp3.GetNext(pafeePos,pafeeStrOut)));

#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	cBuffer[0] = (char)(1 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	mp3.Remove(cBuffer);

	collisionarray[mp3.Hash(i)]--;
	collisionarray[mp3.Hash(i)]--;
	collisionarray[mp3.Hash(i)]--;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	deleteCount+=3;
	presentElementCount-=3;
	assert(mp3.GetCount() == presentElementCount);
	assert(!mp3.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	cBuffer[0] = (char)(2 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	mp3.Remove(cBuffer);
	collisionarray[mp3.Hash(i)]--;
	collisionarray[mp3.Hash(i)]--;
	collisionarray[mp3.Hash(i)]--;

	collisionCount=0;

	deleteCount+=3;
	minListCount-=3;
	presentElementCount-=3;

	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mp3.GetCount() == presentElementCount);
	assert(!mp3.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mp3.RemoveAll();

	for (jj=0;jj<HASHSIZE;jj++)
	{
		collisionarray[jj]=0;
	}

	assert(!mp3.GetCount());
	assert(mp3.IsEmpty());
	deleteCount += presentElementCount;
	collisionCount = 0;
	minListCount = 0;
	maxListCount = 0;
	presentElementCount = 0;
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//
	//test pattern 3
	//Set(Number Key)
	for(i=0;i<loopCount;i++)
	{
		assert(mp3.Set(i,pafeeStr));
		addCount++;
		presentElementCount++;
//		if(i>=tableSize)
//		{
//			collisionCount++;
//		}
		collisionarray[mp3.Hash(i)]++;
	}
	//Set(Character Key)
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mp3.Set(cBuffer,pafeeStr));
		addCount++;
		presentElementCount++;
//		collisionCount++;
		collisionarray[mp3.Hash(cBuffer)]++;
	}
	//Set(Number Key)
	for(i=0;i<loopCount;i++)
	{
		assert(mp3.Set(i,pafeeStr2));
		addCount++;
		presentElementCount++;
//		collisionCount++;
		collisionarray[mp3.Hash(i)]++;
	}
	//Set(Character Key)
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mp3.Set(cBuffer,pafeeStr2));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mp3.Hash(cBuffer)]++;
	}
	//Set(Number Key)
	for(i=0;i<loopCount;i++)
	{
		assert(mp3.Set(i,pafeeStr3));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mp3.Hash(i)]++;
	}
	//Set(Character Key)
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mp3.Set(cBuffer,pafeeStr3));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mp3.Hash(cBuffer)]++;
	}
	maxElementCount = presentElementCount;
	//minListCount = 6;
	//maxListCount = 12;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}


#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//GetStartPosition(int key)/GetNext
	i = 5;
	pafeePos = mp3.GetStartPosition(i);
	assert(mp3.GetNext(pafeePos,pafeeStrOut));
	assert(pafeeStr == pafeeStrOut);
	//GetNext
	assert(mp3.GetNext(pafeePos,pafeeStrOut));
	assert(pafeeStr2 == pafeeStrOut);
	//GetNext
	assert(mp3.GetNext(pafeePos,pafeeStrOut));
	assert(pafeeStr3 == pafeeStrOut);

	//GetStartPosition(character key)/GetNext
	cBuffer[0] = (char)(1 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	pafeePos = mp3.GetStartPosition(cBuffer);
	assert(mp3.GetNext(pafeePos,pafeeStrOut));
	assert(pafeeStr == pafeeStrOut);
	//GetNext
	assert(mp3.GetNext(pafeePos,pafeeStrOut));
	assert(pafeeStr2 == pafeeStrOut);
	//GetNext
	assert(mp3.GetNext(pafeePos,pafeeStrOut));
	assert(pafeeStr3 == pafeeStrOut);

	//GetStartPosition()/GetNext
	size = mp3.GetCount();
	assert(size == presentElementCount);
	pafeePos = mp3.GetStartPosition();
	/*
	for(i=0;i<size;i++)
	{
		assert(mp3.GetNext(pafeePos,pafeeStrOut));
		if((i==0) || (i==1) || (i==2) || (i==9) || (i==10) || (i==11) || (i==12) || (i==21) || (i==22) || (i==23) || (i==30) || (i==31))
		{
			assert(pafeeStr == pafeeStrOut);
		}
		else if((i==3) || (i==4) || (i==5) || (i==13) || (i==14) || (i==15) || (i==16) || (i==24) || (i==25) || (i==26) || (i==32) || (i==33))
		{
			assert(pafeeStr2 == pafeeStrOut);
		}
		else
		{
			assert(pafeeStr3 == pafeeStrOut);
		}
	}
	*/
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	i=5;
	mp3.Remove(i);

	collisionarray[mp3.Hash(i)]--;
	collisionarray[mp3.Hash(i)]--;
	collisionarray[mp3.Hash(i)]--;

	deleteCount+=3;
	presentElementCount-=3;
	//maxListCount-=3;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mp3.GetCount() == presentElementCount);
	assert(!mp3.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	cBuffer[0] = (char)(2 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	mp3.Remove(cBuffer);

	collisionarray[mp3.Hash(cBuffer)]--;
	collisionarray[mp3.Hash(cBuffer)]--;
	collisionarray[mp3.Hash(cBuffer)]--;

	deleteCount+=3;
	//minListCount-=3;


	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}
	presentElementCount-=3;
	assert(mp3.GetCount() == presentElementCount);
	assert(!mp3.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mp3.RemoveAll();

	for (jj=0;jj<HASHSIZE;jj++)
	{
		collisionarray[jj]=0;
	}

	assert(!mp3.GetCount());
	assert(mp3.IsEmpty());
	deleteCount += presentElementCount;
	minListCount = 0;
	maxListCount = 0;
	presentElementCount = 0;
	collisionCount=0;
#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set(Number Key)
	for(i=0;i<loopCount;i++)
	{
		assert(mp3.Set(i,pafeeStr));
		addCount++;
		presentElementCount++;
//		if(i>=tableSize)
//		{
//			collisionCount++;
//		}

		collisionarray[mp3.Hash(i)]++;
	}
	//Set(Character Key)
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mp3.Set(cBuffer,pafeeStr));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mp3.Hash(cBuffer)]++;
	}
	//minListCount = 2;
	//maxListCount = 4;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif


///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////



	//const int HASHSIZE=4;
	//
	//string
	//
	//int i;
	size = 0;
	//string str = "123456789";
	//string str2 = "abcdefghijklmn";
	//string str3 = "WWWWWXXXXXYYYYYZZZZZ";
	//string strOut;
	//int tableSize;
	//int loopCount=6;
	//char c;
	//char *pSkey;

	//STATISTICS
	addCount=0;
	acqCount=0;
	deleteCount=0;
	maxElementCount=0;
	collisionCount=0;
	minListCount=0;
	maxListCount=0;
	presentElementCount=0;
	//
	//int collisionarray[HASHSIZE];
	//
//#ifdef PAFEE_STATISTICS_ENABLE
//	MultiMapT<string>::STATISTICS statisticsRtn;
//#endif

	//Initialize
	tableSize = 5;
	MultiMapT<string> mmptp1(tableSize);
	assert(!mmptp1.Initialize(10,NULL));



	//
	//test Pattern 1
	//test Initialize/GetCount/IsEmpty/Set(int length)
	tableSize = 4;
	MultiMapT<string> mmmptp;
	mmmptp.Initialize(tableSize,NULL);
	assert(mmmptp.GetCount()==0);
	assert(mmmptp.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	for (jj=0;jj<HASHSIZE;jj++)
	{
		collisionarray[jj]=0;
	}
	for (i=0;i<loopCount;i++)
	{
		assert(mmmptp.Set(i,str));
		addCount++;
		presentElementCount++;
		maxElementCount++;
		collisionarray[mmmptp.Hash(i)]++;
	}
	//collisionCount = presentElementCount - tableSize;
	//minListCount = presentElementCount / tableSize;
	//maxListCount = (presentElementCount / tableSize)+1;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mmmptp.GetCount() == presentElementCount);
	assert(!mmmptp.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif


	//test Set(int key)
	for (i=0;i<loopCount;i++)
	{
		assert(mmmptp.Set(i,str2));
		addCount++;
		presentElementCount++;
		maxElementCount++;
		collisionarray[mmmptp.Hash(i)]++;
		//collisionCount++;
	}
	for (i=0;i<loopCount;i++)
	{
		assert(mmmptp.Set(i,str3));
		addCount++;
		presentElementCount++;
		maxElementCount++;
		collisionarray[mmmptp.Hash(i)]++;
		//collisionCount++;
	}
	//minListCount = 3;
	//maxListCount = 6;




	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif



	MultiMapT<string> mmptp2=mmmptp;














//	MultiMapT<string> mmpt2;
//	mmpt2=mp;





	//GetStartPosition(int key)/GetNext
	i = 5;
	MultiMapT<string>::POSITION pos2 = mmptp2.GetStartPosition(i);
	assert(mmptp2.GetNext(pos2,strOut));
	assert(str == strOut);
	//GetNext
	assert(mmptp2.GetNext(pos2,strOut));
	assert(str2 == strOut);
	//GetNext
	assert(mmptp2.GetNext(pos2,strOut));
	assert(str3 == strOut);

	//GetStartPosition()/GetNext
	size = mmptp2.GetCount();
	assert(size == presentElementCount);
	pos2 = mmptp2.GetStartPosition();
	/*
	for(i=0;i<size;i++)
	{
		assert(mmptp2.GetNext(pos,strOut));

		if((i == 0) || (i == 1) || (i == 6) || (i == 7) || (i == 12) || (i == 15))
		{
			assert(str == strOut);
		}
		else if((i == 2) || (i == 3) || (i == 8) || (i == 9) || (i == 13) || (i == 16))
		{
			assert(str2 == strOut);
		}
		else
		{
			assert(str3 == strOut);
		}
	}
	*/
	//GetStartPosition(int key)/GetNext((not found))
	i = 7;
	pos2 = mmptp2.GetStartPosition(i);
	assert(!(mmptp2.GetNext(pos2,strOut)));

#ifdef PAFEE_STATISTICS_ENABLE
	mmptp2.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	i=5;
	mmptp2.Remove(i);
	collisionarray[mmptp2.Hash(i)]--;
	collisionarray[mmptp2.Hash(i)]--;
	collisionarray[mmptp2.Hash(i)]--;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}
	deleteCount+=3;
	presentElementCount-=3;
	assert(mmptp2.GetCount() == presentElementCount);
	assert(!mmptp2.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mmptp2.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	i=2;
	mmptp2.Remove(i);
	collisionarray[mmptp2.Hash(i)]--;
	collisionarray[mmptp2.Hash(i)]--;
	collisionarray[mmptp2.Hash(i)]--;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	deleteCount+=3;
	presentElementCount-=3;
	//minListCount -= 3;
	assert(mmptp2.GetCount() == presentElementCount);
	assert(!mmptp2.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mmptp2.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	i=0;
	mmptp2.Remove(i);

	collisionarray[mmptp2.Hash(i)]--;
	collisionarray[mmptp2.Hash(i)]--;
	collisionarray[mmptp2.Hash(i)]--;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	deleteCount+=3;
	presentElementCount-=3;
	//maxListCount-=3;
	assert(mmptp2.GetCount() == presentElementCount);
	assert(!mmptp2.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mmptp2.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mmptp2.RemoveAll();
	for (jj=0;jj<HASHSIZE;jj++)
	{
		collisionarray[jj]=0;
	}

	assert(!mmptp2.GetCount());
	assert(mmptp2.IsEmpty());
	deleteCount += presentElementCount;
	//minListCount = 0;
	//maxListCount = 0;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}
	presentElementCount = 0;
#ifdef PAFEE_STATISTICS_ENABLE
	mmptp2.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set/GetCount
	for(i=0;i<loopCount;i++)
	{
		assert(mmptp2.Set(i,str));
		addCount++;
		presentElementCount++;
		collisionarray[mp.Hash(i)]++;
	}
	//minListCount = presentElementCount / tableSize;
	//maxListCount = (presentElementCount / tableSize)+1;
	//collisionCount = collisionCount + (loopCount-tableSize);

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mmptp2.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mmptp2.RemoveAll();
	for (jj=0;jj<HASHSIZE;jj++)
	{
		collisionarray[jj]=0;
	}

	deleteCount += presentElementCount;
	minListCount = 0;
	maxListCount = 0;
	collisionCount = 0;
	presentElementCount = 0;

	//
	//test pattern 2
	//test GetCount/IsEmpty/Set
	assert(mmptp2.GetCount()==0);
	assert(mmptp2.IsEmpty());
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mmptp2.Set(cBuffer,str));
		addCount++;
		presentElementCount++;
		collisionarray[mmptp2.Hash(cBuffer)]++;
	}
	//collisionCount += (loopCount/tableSize)+1;
	//minListCount += loopCount/tableSize;
	//maxListCount += (loopCount/tableSize)+1;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mmptp2.GetCount() == presentElementCount);
	assert(!mmptp2.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mmptp2.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//test Set(character key)
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mmptp2.Set(cBuffer,str2));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mmptp2.Hash(cBuffer)]++;
	}
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mmptp2.Set(cBuffer,str3));
		addCount++;
		presentElementCount++;
		collisionarray[mmptp2.Hash(cBuffer)]++;
		//collisionCount++;
	}
	//minListCount = 3;
	//maxListCount = 6;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mmptp2.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//GetStartPosition(character key)/GetNext
	cBuffer[0] = (char)(1 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	pos2 = mmptp2.GetStartPosition(cBuffer);
	assert(mmptp2.GetNext(pos2,strOut));
	assert(str == strOut);
	//GetNext
	assert(mmptp2.GetNext(pos2,strOut));
	assert(str2 == strOut);
	//GetNext
	assert(mmptp2.GetNext(pos2,strOut));
	assert(str3 == strOut);

	//GetStartPosition()/GetNext
	size = mmptp2.GetCount();
	assert(size == presentElementCount);
	pos2 = mmptp2.GetStartPosition();
	/*
	for(i=0;i<size;i++)
	{
		assert(mp.GetNext(pos2,strOut));
		if((i == 0) || (i == 3) || (i == 4) || (i == 9) || (i == 10) || (i == 15))
		{
			assert(str == strOut);
		}
		else if((i == 1) || (i == 5) || (i == 6) || (i == 11) || (i == 12) || (i == 16))
		{
			assert(str2 == strOut);
		}
		else
		{
			assert(str3 == strOut);
		}
	}
	*/
	//GetStartposition(character key)/GetNext ((not found))
	cBuffer[0] = (char)(7 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	pos2 = mmptp2.GetStartPosition(cBuffer);
	assert(!(mmptp2.GetNext(pos2,strOut)));

#ifdef PAFEE_STATISTICS_ENABLE
	mmptp2.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	cBuffer[0] = (char)(1 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	mmptp2.Remove(cBuffer);

	collisionarray[mmptp2.Hash(cBuffer)]--;
	collisionarray[mmptp2.Hash(cBuffer)]--;
	collisionarray[mmptp2.Hash(cBuffer)]--;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}
	deleteCount+=3;
	presentElementCount-=3;

	assert(mmptp2.GetCount() == presentElementCount);
	assert(!mmptp2.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mmptp2.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	cBuffer[0] = (char)(2 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	mmptp2.Remove(cBuffer);
	collisionarray[mmptp2.Hash(cBuffer)]--;
	collisionarray[mmptp2.Hash(cBuffer)]--;
	collisionarray[mmptp2.Hash(cBuffer)]--;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	deleteCount+=3;
	//minListCount-=3;
	presentElementCount-=3;
	assert(mmptp2.GetCount() == presentElementCount);
	assert(!mmptp2.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mmptp2.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mmptp2.RemoveAll();
	for (jj=0;jj<HASHSIZE;jj++)
	{
		collisionarray[jj]=0;
	}
	collisionCount=0;
	assert(!mmptp2.GetCount());
	assert(mmptp2.IsEmpty());
	deleteCount += presentElementCount;
	minListCount = 0;
	maxListCount = 0;
	presentElementCount = 0;
#ifdef PAFEE_STATISTICS_ENABLE
	mmptp2.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//
	//test pattern 3
	//Set(Number Key)
	for(i=0;i<loopCount;i++)
	{
		assert(mmptp2.Set(i,str));
		addCount++;
		presentElementCount++;
		collisionarray[mmptp2.Hash(i)]++;
//		if(i>=tableSize)
//		{
//			collisionCount++;
//		}
	}
	//Set(Character Key)
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mmptp2.Set(cBuffer,str));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mmptp2.Hash(cBuffer)]++;
	}
	//Set(Number Key)
	for(i=0;i<loopCount;i++)
	{
		assert(mmptp2.Set(i,str2));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mmptp2.Hash(i)]++;
	}
	//Set(Character Key)
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mmptp2.Set(cBuffer,str2));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mmptp2.Hash(cBuffer)]++;
	}
	//Set(Number Key)
	for(i=0;i<loopCount;i++)
	{
		assert(mmptp2.Set(i,str3));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mmptp2.Hash(i)]++;
	}
	//Set(Character Key)
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mmptp2.Set(cBuffer,str3));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mmptp2.Hash(cBuffer)]++;
	}
	maxElementCount = presentElementCount;
	//minListCount = 6;
	//maxListCount = 12;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mmptp2.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//GetStartPosition(int key)/GetNext
	i = 5;
	pos2 = mmptp2.GetStartPosition(i);
	assert(mmptp2.GetNext(pos2,strOut));

	assert(str == strOut);
	//GetNext
	assert(mmptp2.GetNext(pos2,strOut));

	assert(str2 == strOut);
	//GetNext
	assert(mmptp2.GetNext(pos2,strOut));

	assert(str3 == strOut);

	//GetStartPosition(character key)/GetNext
	cBuffer[0] = (char)(1 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	pos2 = mmptp2.GetStartPosition(cBuffer);
	assert(mmptp2.GetNext(pos2,strOut));
	assert(str == strOut);
	//GetNext
	assert(mmptp2.GetNext(pos2,strOut));
	assert(str2 == strOut);
	//GetNext
	assert(mmptp2.GetNext(pos2,strOut));
	assert(str3 == strOut);

	//GetStartPosition()/GetNext
	size = mmptp2.GetCount();
	assert(size == presentElementCount);
	pos2 = mmptp2.GetStartPosition();
	/*
	for(i=0;i<size;i++)
	{
		assert(mp.GetNext(pos2,strOut));
		//strOut = mp.GetNext(pos2);
		if((i==0) || (i==1) || (i==2) || (i==9) || (i==10) || (i==11) || (i==12) || (i==21) || (i==22) || (i==23) || (i==30) || (i==31))
		{
			assert(str == strOut);
		}
		else if((i==3) || (i==4) || (i==5) || (i==13) || (i==14) || (i==15) || (i==16) || (i==24) || (i==25) || (i==26) || (i==32) || (i==33))
		{
			assert(str2 == strOut);
		}
		else
		{
			assert(str3 == strOut);
		}
	}
	*/
#ifdef PAFEE_STATISTICS_ENABLE
	mmptp2.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	i=5;
	mmptp2.Remove(i);
	//
	collisionarray[mmptp2.Hash(i)]--;
	collisionarray[mmptp2.Hash(i)]--;
	collisionarray[mmptp2.Hash(i)]--;
	//
	deleteCount+=3;
	presentElementCount-=3;
	//maxListCount-=3;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}
	//
	assert(mmptp2.GetCount() == presentElementCount);
	assert(!mmptp2.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mmptp2.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	cBuffer[0] = (char)(2 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	mmptp2.Remove(cBuffer);
	collisionarray[mmptp2.Hash(cBuffer)]--;
	collisionarray[mmptp2.Hash(cBuffer)]--;
	collisionarray[mmptp2.Hash(cBuffer)]--;

	deleteCount+=3;
	//minListCount-=3;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}
	presentElementCount-=3;
	assert(mmptp2.GetCount() == presentElementCount);
	assert(!mmptp2.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mmptp2.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mmptp2.RemoveAll();
	for (jj=0;jj<HASHSIZE;jj++)
	{
		collisionarray[jj]=0;
	}

	assert(!mmptp2.GetCount());
	assert(mmptp2.IsEmpty());
	deleteCount += presentElementCount;

	collisionCount = 0;
	minListCount = 0;
	maxListCount = 0;
	presentElementCount = 0;
#ifdef PAFEE_STATISTICS_ENABLE
	mmptp2.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set(Number Key)
	for(i=0;i<loopCount;i++)
	{
		assert(mmptp2.Set(i,str));
		addCount++;
		presentElementCount++;
//		if(i>=tableSize)
//		{
//			collisionCount++;
//		}
		collisionarray[mmptp2.Hash(i)]++;
	}
	//Set(Character Key)
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mmptp2.Set(cBuffer,str));
		addCount++;
		presentElementCount++;
//		collisionCount++;
		collisionarray[mmptp2.Hash(cBuffer)]++;
	}
	//minListCount = 2;
	//maxListCount = 4;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mmptp2.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.acqCount == acqCount);
	assert(statisticsRtn.deleteCount == deleteCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.collisionCount == collisionCount);
	assert(statisticsRtn.minListCount == minListCount);
	assert(statisticsRtn.maxListCount == maxListCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//
	//PafeeString 
	//
	size = 0;
//	String pafeeStr = "123456789";
//	String pafeeStr2 = "abcdefghijklmn";
//	String pafeeStr3 = "WWWWWXXXXXYYYYYZZZZZ";
//	String pafeeStrOut;

	//STATISTICS
	addCount=0;
	acqCount=0;
	deleteCount=0;
	maxElementCount=0;
	collisionCount=0;
	minListCount=0;
	maxListCount=0;
	presentElementCount=0;
	for (jj=0;jj<HASHSIZE;jj++)
	{
		collisionarray[jj]=0;
	}
//#ifdef PAFEE_STATISTICS_ENABLE
//	MultiMapT<String>::STATISTICS pafeeStatisticsRtn;
//#endif

	//Initialize
	tableSize = 5;
	MultiMapT<String> mmmptp2(tableSize);
	assert(!mmmptp2.Initialize(10,NULL));

	//
	//test Pattern 1
	//test Initialize/GetCount/IsEmpty/Set(int length)
	tableSize = 4;
	MultiMapT<String> mmmptp0;



	mmmptp0.Initialize(tableSize,NULL);
	assert(mmmptp0.GetCount()==0);
	assert(mmmptp0.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp0.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	for(i=0;i<loopCount;i++)
	{
		assert(mmmptp0.Set(i,pafeeStr));
		addCount++;
		presentElementCount++;
		maxElementCount++;
		collisionarray[mmmptp0.Hash(i)]++;

	}
	//collisionCount = presentElementCount - tableSize;
	//minListCount = presentElementCount / tableSize;
	//maxListCount = (presentElementCount / tableSize)+1;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mmmptp0.GetCount() == presentElementCount);
	assert(!mmmptp0.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp0.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//test Set(int key)
	for(i=0;i<loopCount;i++)
	{
		assert(mmmptp0.Set(i,pafeeStr2));
		addCount++;
		presentElementCount++;
		maxElementCount++;
		//collisionCount++;
		collisionarray[mmmptp0.Hash(i)]++;

	}
	for(i=0;i<loopCount;i++)
	{
		assert(mmmptp0.Set(i,pafeeStr3));
		addCount++;
		presentElementCount++;
		maxElementCount++;
		//collisionCount++;
		collisionarray[mmmptp0.Hash(i)]++;
	}
	//minListCount = 3;
	//maxListCount = 6;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp0.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif









	MultiMapT<String> mmmptp3=mmmptp0;








	//GetStartPosition(int key)/GetNext
	i = 5;
	MultiMapT<String>::POSITION pafeePos2 = mmmptp3.GetStartPosition(i);
	assert(mmmptp3.GetNext(pafeePos2,pafeeStrOut));
	assert(pafeeStr == pafeeStrOut);
	//GetNext
	assert(mmmptp3.GetNext(pafeePos2,pafeeStrOut));
	assert(pafeeStr2 == pafeeStrOut);
	//GetNext
	assert(mmmptp3.GetNext(pafeePos2,pafeeStrOut));
	assert(pafeeStr3 == pafeeStrOut);

	//GetStartPosition()/GetNext
	size = mmmptp3.GetCount();
	assert(size == presentElementCount);
	pafeePos2 = mmmptp3.GetStartPosition();
	/*
	for(i=0;i<size;i++)
	{
		assert(mp3.GetNext(pafeePos2,pafeeStrOut));
		//pafeeStrOut = mp3.GetNext(pafeePos2);
		if((i == 0) || (i == 1) || (i == 6) || (i == 7) || (i == 12) || (i == 15))
		{
			assert(pafeeStr == pafeeStrOut);
		}
		else if((i == 2) || (i == 3) || (i == 8) || (i == 9) || (i == 13) || (i == 16))
		{
			assert(pafeeStr2 == pafeeStrOut);
		}
		else
		{
			assert(pafeeStr3 == pafeeStrOut);
		}
	}
	*/
	//GetStartPosition(int key)/GetNext((not found))
	i = 7;
	pafeePos2 = mmmptp3.GetStartPosition(i);
	assert(!(mmmptp3.GetNext(pafeePos2,pafeeStrOut)));

#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	i=5;
	mmmptp3.Remove(i);

	collisionarray[mmmptp3.Hash(i)]--;
	collisionarray[mmmptp3.Hash(i)]--;
	collisionarray[mmmptp3.Hash(i)]--;

	deleteCount+=3;
	presentElementCount-=3;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mmmptp3.GetCount() == presentElementCount);
	assert(!mmmptp3.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	i=2;
	mmmptp3.Remove(i);

	collisionarray[mmmptp3.Hash(i)]--;
	collisionarray[mmmptp3.Hash(i)]--;
	collisionarray[mmmptp3.Hash(i)]--;

	deleteCount+=3;
	presentElementCount-=3;
	//minListCount -= 3;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mmmptp3.GetCount() == presentElementCount);
	assert(!mmmptp3.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	i=0;
	mmmptp3.Remove(i);
	collisionarray[mmmptp3.Hash(i)]--;
	collisionarray[mmmptp3.Hash(i)]--;
	collisionarray[mmmptp3.Hash(i)]--;

	deleteCount+=3;
	presentElementCount-=3;
	//maxListCount-=3;
	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mmmptp3.GetCount() == presentElementCount);
	assert(!mmmptp3.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mmmptp3.RemoveAll();

	for (jj=0;jj<HASHSIZE;jj++)
	{
		collisionarray[jj]=0;
	}

	assert(!mmmptp3.GetCount());
	assert(mmmptp3.IsEmpty());
	deleteCount += presentElementCount;

	collisionCount = 0;
	minListCount = 0;
	maxListCount = 0;
	presentElementCount = 0;
#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set/GetCount
	for(i=0;i<loopCount;i++)
	{
		assert(mmmptp3.Set(i,pafeeStr));
		addCount++;
		presentElementCount++;
		collisionarray[mmmptp3.Hash(i)]++;

	}
	//minListCount = presentElementCount / tableSize;
	//maxListCount = (presentElementCount / tableSize)+1;
	//collisionCount = collisionCount + (loopCount-tableSize);

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mmmptp3.RemoveAll();
	for (jj=0;jj<HASHSIZE;jj++)
	{
		collisionarray[jj]=0;
	}

	deleteCount += presentElementCount;

	collisionCount = 0;
	minListCount = 0;
	maxListCount = 0;
	presentElementCount = 0;

	//
	//test pattern 2
	//test GetCount/IsEmpty/Set
	assert(mmmptp3.GetCount()==0);
	assert(mmmptp3.IsEmpty());
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mmmptp3.Set(cBuffer,pafeeStr));
		addCount++;
		presentElementCount++;
		collisionarray[mmmptp3.Hash(cBuffer)]++;
	}
	//collisionCount += (loopCount/tableSize)+1;
	//minListCount += loopCount/tableSize;
	//maxListCount += (loopCount/tableSize)+1;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mmmptp3.GetCount() == presentElementCount);
	assert(!mmmptp3.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//test Set(character key)
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mmmptp3.Set(cBuffer,pafeeStr2));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mmmptp3.Hash(cBuffer)]++;
	}
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mmmptp3.Set(cBuffer,pafeeStr3));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mmmptp3.Hash(cBuffer)]++;
	}
	//minListCount = 3;
	//maxListCount = 6;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//GetStartPosition(character key)/GetNext
	cBuffer[0] = (char)(1 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	pafeePos2 = mmmptp3.GetStartPosition(cBuffer);
	assert(mmmptp3.GetNext(pafeePos2,pafeeStrOut));
	assert(pafeeStr == pafeeStrOut);
	//GetNext
	assert(mmmptp3.GetNext(pafeePos2,pafeeStrOut));
	assert(pafeeStr2 == pafeeStrOut);
	//GetNext
	assert(mmmptp3.GetNext(pafeePos2,pafeeStrOut));
	//pafeeStrOut = mp3.GetNext(pafeePos2
	assert(pafeeStr3 == pafeeStrOut);

	//GetStartPosition()/GetNext
	size = mmmptp3.GetCount();
	assert(size == presentElementCount);
	pafeePos2 = mmmptp3.GetStartPosition();
	/*
	for(i=0;i<size;i++)
	{
		assert(mp3.GetNext(pafeePos2,pafeeStrOut));
		if((i == 0) || (i == 3) || (i == 4) || (i == 9) || (i == 10) || (i == 15))
		{
			assert(pafeeStr == pafeeStrOut);
		}
		else if((i == 1) || (i == 5) || (i == 6) || (i == 11) || (i == 12) || (i == 16))
		{
			assert(pafeeStr2 == pafeeStrOut);
		}
		else
		{
			assert(pafeeStr3 == pafeeStrOut);
		}
	}
	*/
	//GetStartPosition(character key)/GetNext ((not found))
	cBuffer[0] = (char)(7 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	pafeePos2 = mmmptp3.GetStartPosition(cBuffer);
	assert(!(mmmptp3.GetNext(pafeePos2,pafeeStrOut)));

#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	cBuffer[0] = (char)(1 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	mmmptp3.Remove(cBuffer);

	collisionarray[mmmptp3.Hash(i)]--;
	collisionarray[mmmptp3.Hash(i)]--;
	collisionarray[mmmptp3.Hash(i)]--;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	deleteCount+=3;
	presentElementCount-=3;
	assert(mmmptp3.GetCount() == presentElementCount);
	assert(!mmmptp3.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	cBuffer[0] = (char)(2 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	mmmptp3.Remove(cBuffer);
	collisionarray[mmmptp3.Hash(i)]--;
	collisionarray[mmmptp3.Hash(i)]--;
	collisionarray[mmmptp3.Hash(i)]--;

	collisionCount=0;

	deleteCount+=3;
	minListCount-=3;
	presentElementCount-=3;

	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mmmptp3.GetCount() == presentElementCount);
	assert(!mmmptp3.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mmmptp3.RemoveAll();

	for (jj=0;jj<HASHSIZE;jj++)
	{
		collisionarray[jj]=0;
	}

	assert(!mmmptp3.GetCount());
	assert(mmmptp3.IsEmpty());
	deleteCount += presentElementCount;
	collisionCount = 0;
	minListCount = 0;
	maxListCount = 0;
	presentElementCount = 0;
#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//
	//test pattern 3
	//Set(Number Key)
	for(i=0;i<loopCount;i++)
	{
		assert(mmmptp3.Set(i,pafeeStr));
		addCount++;
		presentElementCount++;
//		if(i>=tableSize)
//		{
//			collisionCount++;
//		}
		collisionarray[mmmptp3.Hash(i)]++;
	}
	//Set(Character Key)
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mmmptp3.Set(cBuffer,pafeeStr));
		addCount++;
		presentElementCount++;
//		collisionCount++;
		collisionarray[mmmptp3.Hash(cBuffer)]++;
	}
	//Set(Number Key)
	for(i=0;i<loopCount;i++)
	{
		assert(mmmptp3.Set(i,pafeeStr2));
		addCount++;
		presentElementCount++;
//		collisionCount++;
		collisionarray[mmmptp3.Hash(i)]++;
	}
	//Set(Character Key)
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mmmptp3.Set(cBuffer,pafeeStr2));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mmmptp3.Hash(cBuffer)]++;
	}
	//Set(Number Key)
	for(i=0;i<loopCount;i++)
	{
		assert(mmmptp3.Set(i,pafeeStr3));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mmmptp3.Hash(i)]++;
	}
	//Set(Character Key)
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mmmptp3.Set(cBuffer,pafeeStr3));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mmmptp3.Hash(cBuffer)]++;
	}
	maxElementCount = presentElementCount;
	//minListCount = 6;
	//maxListCount = 12;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}


#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//GetStartPosition(int key)/GetNext
	i = 5;
	pafeePos2 = mmmptp3.GetStartPosition(i);
	assert(mmmptp3.GetNext(pafeePos2,pafeeStrOut));
	assert(pafeeStr == pafeeStrOut);
	//GetNext
	assert(mmmptp3.GetNext(pafeePos2,pafeeStrOut));
	assert(pafeeStr2 == pafeeStrOut);
	//GetNext
	assert(mmmptp3.GetNext(pafeePos2,pafeeStrOut));
	assert(pafeeStr3 == pafeeStrOut);

	//GetStartPosition(character key)/GetNext
	cBuffer[0] = (char)(1 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	pafeePos2 = mmmptp3.GetStartPosition(cBuffer);
	assert(mmmptp3.GetNext(pafeePos2,pafeeStrOut));
	assert(pafeeStr == pafeeStrOut);
	//GetNext
	assert(mmmptp3.GetNext(pafeePos2,pafeeStrOut));
	assert(pafeeStr2 == pafeeStrOut);
	//GetNext
	assert(mmmptp3.GetNext(pafeePos2,pafeeStrOut));
	assert(pafeeStr3 == pafeeStrOut);

	//GetStartPosition()/GetNext
	size = mmmptp3.GetCount();
	assert(size == presentElementCount);
	pafeePos2 = mmmptp3.GetStartPosition();
	/*
	for(i=0;i<size;i++)
	{
		assert(mp3.GetNext(pafeePos2,pafeeStrOut));
		if((i==0) || (i==1) || (i==2) || (i==9) || (i==10) || (i==11) || (i==12) || (i==21) || (i==22) || (i==23) || (i==30) || (i==31))
		{
			assert(pafeeStr == pafeeStrOut);
		}
		else if((i==3) || (i==4) || (i==5) || (i==13) || (i==14) || (i==15) || (i==16) || (i==24) || (i==25) || (i==26) || (i==32) || (i==33))
		{
			assert(pafeeStr2 == pafeeStrOut);
		}
		else
		{
			assert(pafeeStr3 == pafeeStrOut);
		}
	}
	*/
#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	i=5;
	mmmptp3.Remove(i);

	collisionarray[mmmptp3.Hash(i)]--;
	collisionarray[mmmptp3.Hash(i)]--;
	collisionarray[mmmptp3.Hash(i)]--;

	deleteCount+=3;
	presentElementCount-=3;
	//maxListCount-=3;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

	assert(mmmptp3.GetCount() == presentElementCount);
	assert(!mmmptp3.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Remove
	cBuffer[0] = (char)(2 + 49);
	//pSkey = &c;
	cBuffer[1] = '\0';
	mmmptp3.Remove(cBuffer);

	collisionarray[mmmptp3.Hash(cBuffer)]--;
	collisionarray[mmmptp3.Hash(cBuffer)]--;
	collisionarray[mmmptp3.Hash(cBuffer)]--;

	deleteCount+=3;
	//minListCount-=3;


	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}
	presentElementCount-=3;
	assert(mmmptp3.GetCount() == presentElementCount);
	assert(!mmmptp3.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//RemoveAll
	mmmptp3.RemoveAll();

	for (jj=0;jj<HASHSIZE;jj++)
	{
		collisionarray[jj]=0;
	}

	assert(!mmmptp3.GetCount());
	assert(mmmptp3.IsEmpty());
	deleteCount += presentElementCount;
	minListCount = 0;
	maxListCount = 0;
	presentElementCount = 0;
	collisionCount=0;
#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif

	//Set(Number Key)
	for(i=0;i<loopCount;i++)
	{
		assert(mmmptp3.Set(i,pafeeStr));
		addCount++;
		presentElementCount++;
//		if(i>=tableSize)
//		{
//			collisionCount++;
//		}

		collisionarray[mmmptp3.Hash(i)]++;
	}
	//Set(Character Key)
	for(i=0;i<loopCount;i++)
	{
		cBuffer[0] = (char)(i + 49);
		//pSkey = &c;
		cBuffer[1] = '\0';
		assert(mmmptp3.Set(cBuffer,pafeeStr));
		addCount++;
		presentElementCount++;
		//collisionCount++;
		collisionarray[mmmptp3.Hash(cBuffer)]++;
	}
	//minListCount = 2;
	//maxListCount = 4;

	collisionCount=0;
	minListCount=INT_MAX;
	maxListCount=0;
	for (eh=0;eh<HASHSIZE;eh++)
	{
		if ( collisionarray[eh] >= 1 )
		{
			collisionCount+=collisionarray[eh]-1;
		}
		if ( minListCount > collisionarray[eh] )
		{
			minListCount = collisionarray[eh];
		}
		if ( maxListCount < collisionarray[eh] )
		{
			maxListCount = collisionarray[eh];
		}
	}

#ifdef PAFEE_STATISTICS_ENABLE
	mmmptp3.GetStatistics(&pafeeStatisticsRtn);
	assert(pafeeStatisticsRtn.addCount == addCount);
	assert(pafeeStatisticsRtn.acqCount == acqCount);
	assert(pafeeStatisticsRtn.deleteCount == deleteCount);
	assert(pafeeStatisticsRtn.maxElementCount == maxElementCount);
	assert(pafeeStatisticsRtn.collisionCount == collisionCount);
	assert(pafeeStatisticsRtn.minListCount == minListCount);
	assert(pafeeStatisticsRtn.maxListCount == maxListCount);
	assert(pafeeStatisticsRtn.presentElementCount == presentElementCount);
#endif
	return 0;

}
