#ifdef ENV_WIN32
#pragma warning(disable:4996)
#endif
#include <assert.h>
#include <stdio.h>
#include "PafeePriorityQueueT.h"
#include "PafeeString.h"
#include "pafee_string.h"
#include "pafee_stdio.h"
#include <string>
int main()
{
	int i;
	int getdata;
	int pr;
	Pafee::PriorityQueueT<int>  pq;
	//Normality system
	assert(pq.GetCount() == 0);
	assert(pq.IsEmpty());
	assert(pq.Initialize(3));
	int Counti=0;

	//STATISTICS
	int addCount=0;
	int maxElementCount=0;
	int presentElementCount=0;

#ifdef PAFEE_STATISTICS_ENABLE
	Pafee::PriorityQueueT<int>::STATISTICS statisticsRtn;
#endif

#ifdef PAFEE_STATISTICS_ENABLE
	pq.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif
	//Enqueue Test
	for(i=0;i<12;i++)
	{
		assert(pq.GetCount() == i);
		assert(pq.Enqueue (i%3, i));
		//
		addCount++;
		maxElementCount++;
		presentElementCount++;
		//
		assert(pq.GetCount() == i+1);
		assert(!pq.IsEmpty());
	}
#ifdef PAFEE_STATISTICS_ENABLE
	pq.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	Counti = i;

	for(i=0;i<4;i++)
	{
		assert( pq.Peek(&pr, getdata));
		assert(pq.GetCount() == Counti);
		assert(getdata==i*3);
		assert(pr==0);
		assert(pq.Dequeue (&pr, getdata)==true);
		//
//		addCount++;
		//maxElementCount;
		presentElementCount--;
		//

		Counti--;
		assert(pq.GetCount() == Counti);
		assert(getdata==i*3);
		assert(pr==0);
	}

#ifdef PAFEE_STATISTICS_ENABLE
	pq.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif
	for(i=0;i<4;i++)
	{
		assert( pq.Peek(&pr, getdata)==true);
		assert(pq.GetCount() == Counti);
		assert(getdata==i*3+pr);
		assert(pr==1);
		assert(pq.Dequeue (&pr, getdata)==true);
		//
//		addCount++;
		//maxElementCount;
		presentElementCount--;
		//
		Counti--;
		assert(pq.GetCount() == Counti);
		assert(getdata==i*3+pr);
		assert(pr==1);

	}
#ifdef PAFEE_STATISTICS_ENABLE
	pq.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif
	for(i=0;i<4;i++)
	{
		assert( pq.Peek(&pr, getdata)==true);
		assert(pq.GetCount() == Counti);
		assert(getdata==i*3+pr);
		assert(pr==2);
		assert(pq.Dequeue (&pr, getdata)==true);
		//
//		addCount++;
		//maxElementCount;
		presentElementCount--;
		//
		Counti--;
		assert(pq.GetCount() == Counti);
		assert(getdata==i*3+pr);
		assert(pr==2);

	}
#ifdef PAFEE_STATISTICS_ENABLE
	pq.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif
	assert(pq.GetCount() == 0);
	assert(!pq.Dequeue (&pr, getdata));

	//RemoveFront Test

	Counti = 0;
	for(i=0;i<12;i++)
	{
		assert(pq.Enqueue (i%3, i));
		//
		addCount++;
		//maxElementCount;
		presentElementCount++;
		//
		Counti++;		
	}
#ifdef PAFEE_STATISTICS_ENABLE
	pq.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif
	for(i=0;i<12;i++)
	{
		pq.RemoveFront();
		//
		//addCount++;
		//maxElementCount;
		presentElementCount--;
		//
		Counti--;
		assert(pq.GetCount() == Counti);
	}
#ifdef PAFEE_STATISTICS_ENABLE
	pq.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif
	//RemoveALL Test
	for(i=0;i<12;i++)
	{
		assert(pq.GetCount() == i);
		assert(pq.Enqueue (i%3, i));
		//
		addCount++;
		//maxElementCount;
		presentElementCount++;
		//
		assert(pq.GetCount() == i+1);
		assert(!pq.IsEmpty());	
	}
	pq.RemoveAll();
	presentElementCount=0;
#ifdef PAFEE_STATISTICS_ENABLE
	pq.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.presentElementCount == 0);
#endif

	assert(pq.GetCount() == 0);


	Pafee::PriorityQueueT<Pafee::String>  ppqs;
	//STATISTICS
	int addCountp=0;
	int maxElementCountp=0;
	int presentElementCountp=0;

#ifdef PAFEE_STATISTICS_ENABLE
	Pafee::PriorityQueueT<Pafee::String>::STATISTICS statisticsSTRp;
#endif

#ifdef PAFEE_STATISTICS_ENABLE
	ppqs.GetStatistics(&statisticsSTRp);
	assert(statisticsSTRp.addCount == addCountp);
	assert(statisticsSTRp.maxElementCount == maxElementCountp);
	assert(statisticsSTRp.presentElementCount == presentElementCountp);
#endif


	//Normality system
	assert(ppqs.GetCount() == 0);
	assert(ppqs.IsEmpty());
	assert(ppqs.Initialize(3));
	Counti=0;
	//Enqueue Test
	for(i=0;i<12;i++)
	{
		assert(ppqs.GetCount() == i);
		char idata[10];
		pafee_sprintf(idata,"A%d",i);
		Pafee::String st = idata;
		assert(ppqs.Enqueue (i%3, st));
		//
		addCountp++;
		maxElementCountp++;
		presentElementCountp++;
		//

		assert(ppqs.GetCount() == i+1);
		assert(!ppqs.IsEmpty());
	}

#ifdef PAFEE_STATISTICS_ENABLE
	ppqs.GetStatistics(&statisticsSTRp);
	assert(statisticsSTRp.addCount == addCountp);
	assert(statisticsSTRp.maxElementCount == maxElementCountp);
	assert(statisticsSTRp.presentElementCount == presentElementCountp);
#endif

	Counti = i;
	Pafee::String getdata2;
	for(i=0;i<4;i++)
	{
		assert( ppqs.Peek(&pr, getdata2));
		assert(ppqs.GetCount() == Counti);
		char idata[10];
		pafee_sprintf(idata,"A%d",i*3);
		assert(getdata2==idata);
		assert(pr==0);
		assert(ppqs.Dequeue (&pr, getdata2)==true);
		//
		//addCount++;
		//maxElementCount++;
		presentElementCountp--;
		//
		Counti--;
		assert(ppqs.GetCount() == Counti);
		assert(getdata2==idata);
		assert(pr==0);

	}
#ifdef PAFEE_STATISTICS_ENABLE
	ppqs.GetStatistics(&statisticsSTRp);
	assert(statisticsSTRp.addCount == addCountp);
	assert(statisticsSTRp.maxElementCount == maxElementCountp);
	assert(statisticsSTRp.presentElementCount == presentElementCountp);
#endif
	for(i=0;i<4;i++)
	{
		assert( ppqs.Peek(&pr, getdata2)==true);
		assert(ppqs.GetCount() == Counti);
		char idata[10];
		pafee_sprintf(idata,"A%d",i*3+pr);
		assert(getdata2==idata);
		assert(pr==1);
		assert(ppqs.Dequeue (&pr, getdata2)==true);
		Counti--;
		assert(ppqs.GetCount() == Counti);
		assert(getdata2==idata);
		assert(pr==1);

	}
	for(i=0;i<4;i++)
	{
		assert( ppqs.Peek(&pr, getdata2)==true);
		assert(ppqs.GetCount() == Counti);
		char idata[10];
		pafee_sprintf(idata,"A%d",i*3+pr);
		assert(getdata2==idata);
		assert(pr==2);
		assert(ppqs.Dequeue (&pr, getdata2)==true);
		Counti--;
		assert(ppqs.GetCount() == Counti);
		assert(getdata2==idata);
		assert(pr==2);

	}

////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////

//	int i;
//	int getdata;
//	int pr;
	Pafee::PriorityQueueT<int>  pq1(12);
	//Normality system
	addCount=0;
	maxElementCount=0;
	presentElementCount=0;

#ifdef PAFEE_STATISTICS_ENABLE
	pq1.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

	//Enqueue Test
	for(i=0;i<12;i++)
	{
		assert(pq1.GetCount() == i);
		assert(pq1.Enqueue (i%3, i));
		//
		addCount++;
		maxElementCount++;
		presentElementCount++;
		//
		assert(pq1.GetCount() == i+1);
		assert(!pq1.IsEmpty());
	}

#ifdef PAFEE_STATISTICS_ENABLE
	pq1.GetStatistics(&statisticsRtn);
	assert(statisticsRtn.addCount == addCount);
	assert(statisticsRtn.maxElementCount == maxElementCount);
	assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

#ifdef PAFEE_STATISTICS_ENABLE
	Pafee::PriorityQueueT<int>::STATISTICS statisticsRtn2;
#endif

	int Counti2 = i;
	int addCount2=addCount;
	int maxElementCount2=maxElementCount;
	int presentElementCount2=presentElementCount;

	Pafee::PriorityQueueT<int>  pq2=pq1;
	pq2.GetStatistics(&statisticsRtn2);
	assert(statisticsRtn2.addCount == addCount2);

	for(i=0;i<4;i++)
	{
		assert( pq2.Peek(&pr, getdata));
		assert(pq2.GetCount() == Counti2);
		assert(getdata==i*3);
		assert(pr==0);
		assert(pq2.Dequeue (&pr, getdata)==true);
		//
		//addCount2++;
		//maxElementCount;
		presentElementCount2--;
		//

		Counti2--;
		assert(pq2.GetCount() == Counti2);
		assert(getdata==i*3);
		assert(pr==0);
	}

#ifdef PAFEE_STATISTICS_ENABLE
	pq2.GetStatistics(&statisticsRtn2);
	assert(statisticsRtn2.addCount == addCount2);
	assert(statisticsRtn2.maxElementCount == maxElementCount2);
	assert(statisticsRtn2.presentElementCount == presentElementCount2);
#endif
	for(i=0;i<4;i++)
	{
		assert( pq2.Peek(&pr, getdata)==true);
		assert(pq2.GetCount() == Counti2);
		assert(getdata==i*3+pr);
		assert(pr==1);
		assert(pq2.Dequeue (&pr, getdata)==true);
		//
//		addCount++;
		//maxElementCount;
		presentElementCount2--;
		//
		Counti2--;
		assert(pq2.GetCount() == Counti2);
		assert(getdata==i*3+pr);
		assert(pr==1);

	}
#ifdef PAFEE_STATISTICS_ENABLE
	pq2.GetStatistics(&statisticsRtn2);
	assert(statisticsRtn2.addCount == addCount2);
	assert(statisticsRtn2.maxElementCount == maxElementCount2);
	assert(statisticsRtn2.presentElementCount == presentElementCount2);
#endif
	for(i=0;i<4;i++)
	{
		assert( pq2.Peek(&pr, getdata)==true);
		assert(pq2.GetCount() == Counti2);
		assert(getdata==i*3+pr);
		assert(pr==2);
		assert(pq2.Dequeue (&pr, getdata)==true);
		//
//		addCount++;
		//maxElementCount;
		presentElementCount2--;
		//
		Counti2--;
		assert(pq2.GetCount() == Counti2);
		assert(getdata==i*3+pr);
		assert(pr==2);

	}
#ifdef PAFEE_STATISTICS_ENABLE
	pq2.GetStatistics(&statisticsRtn2);
	assert(statisticsRtn2.addCount == addCount2);
	assert(statisticsRtn2.maxElementCount == maxElementCount2);
	assert(statisticsRtn2.presentElementCount == presentElementCount2);
#endif
	assert(pq2.GetCount() == 0);
	assert(!pq2.Dequeue (&pr, getdata));

	//RemoveFront Test

	Counti2 = 0;
	for(i=0;i<12;i++)
	{
		assert(pq2.Enqueue (i%3, i));
		//
		addCount2++;
		//maxElementCount;
		presentElementCount2++;
		//
		Counti2++;		
	}
#ifdef PAFEE_STATISTICS_ENABLE
	pq2.GetStatistics(&statisticsRtn2);
	assert(statisticsRtn2.addCount == addCount2);
	assert(statisticsRtn2.maxElementCount == maxElementCount2);
	assert(statisticsRtn2.presentElementCount == presentElementCount2);
#endif
	for(i=0;i<12;i++)
	{
		pq2.RemoveFront();
		//
		//addCount++;
		//maxElementCount;
		presentElementCount2--;
		//
		Counti2--;
		assert(pq2.GetCount() == Counti2);
	}
#ifdef PAFEE_STATISTICS_ENABLE
	pq2.GetStatistics(&statisticsRtn2);
	assert(statisticsRtn2.addCount == addCount2);
	assert(statisticsRtn2.maxElementCount == maxElementCount2);
	assert(statisticsRtn2.presentElementCount == presentElementCount2);
#endif
	//RemoveALL Test
	for(i=0;i<12;i++)
	{
		assert(pq2.GetCount() == i);
		assert(pq2.Enqueue (i%3, i));
		//
		addCount2++;
		//maxElementCount;
		presentElementCount2++;
		//
		assert(pq2.GetCount() == i+1);
		assert(!pq2.IsEmpty());
	}
	pq2.RemoveAll();
#ifdef PAFEE_STATISTICS_ENABLE
	pq2.GetStatistics(&statisticsRtn2);
	assert(statisticsRtn2.addCount == addCount2);
	assert(statisticsRtn2.maxElementCount == maxElementCount2);
	assert(statisticsRtn2.presentElementCount == 0);
#endif

	assert(pq2.GetCount() == 0);

	Pafee::PriorityQueueT<Pafee::String>  ppqs2;
	//STATISTICS
	addCount2=0;
	maxElementCount2=0;
	presentElementCount2=0;

#ifdef PAFEE_STATISTICS_ENABLE
	Pafee::PriorityQueueT<Pafee::String>::STATISTICS statisticsSTR2;
#endif

#ifdef PAFEE_STATISTICS_ENABLE
	ppqs2.GetStatistics(&statisticsSTR2);
	assert(statisticsSTR2.addCount == addCount2);
	assert(statisticsSTR2.maxElementCount == maxElementCount2);
	assert(statisticsSTR2.presentElementCount == presentElementCount2);
#endif


	//Normality system
	assert(ppqs2.GetCount() == 0);
	assert(ppqs2.IsEmpty());
	assert(ppqs2.Initialize(3));
	Counti2=0;
	//Enqueue Test
	for(i=0;i<12;i++)
	{
		assert(ppqs2.GetCount() == i);
		char idata[10];
		pafee_sprintf(idata,"A%d",i);
		Pafee::String st = idata;
		assert(ppqs2.Enqueue (i%3, st));
		//
		addCount2++;
		maxElementCount2++;
		presentElementCount2++;
		//

		assert(ppqs2.GetCount() == i+1);
		assert(!ppqs2.IsEmpty());
	}

#ifdef PAFEE_STATISTICS_ENABLE
	ppqs2.GetStatistics(&statisticsSTR2);
	assert(statisticsSTR2.addCount == addCount2);
	assert(statisticsSTR2.maxElementCount == maxElementCount2);
	assert(statisticsSTR2.presentElementCount == presentElementCount2);
#endif

	Counti2 = i;
	for(i=0;i<4;i++)
	{
		assert( ppqs2.Peek(&pr, getdata2));
		assert(ppqs2.GetCount() == Counti2);
		char idata[10];
		pafee_sprintf(idata,"A%d",i*3);
		assert(getdata2==idata);
		assert(pr==0);
		assert(ppqs2.Dequeue (&pr, getdata2)==true);
		//
		//addCount++;
		//maxElementCount++;
		presentElementCount2--;
		//
		Counti2--;
		assert(ppqs2.GetCount() == Counti2);
		assert(getdata2==idata);
		assert(pr==0);

	}
#ifdef PAFEE_STATISTICS_ENABLE
	ppqs2.GetStatistics(&statisticsSTR2);
	assert(statisticsSTR2.addCount == addCount2);
	assert(statisticsSTR2.maxElementCount == maxElementCount2);
	assert(statisticsSTR2.presentElementCount == presentElementCount2);
#endif
	for(i=0;i<4;i++)
	{
		assert( ppqs2.Peek(&pr, getdata2)==true);
		assert(ppqs2.GetCount() == Counti2);
		char idata[10];
		pafee_sprintf(idata,"A%d",i*3+pr);
		assert(getdata2==idata);
		assert(pr==1);
		assert(ppqs2.Dequeue (&pr, getdata2)==true);
		Counti2--;
		assert(ppqs2.GetCount() == Counti2);
		assert(getdata2==idata);
		assert(pr==1);

	}
	for(i=0;i<4;i++)
	{
		assert( ppqs2.Peek(&pr, getdata2)==true);
		assert(ppqs2.GetCount() == Counti2);
		char idata[10];
		pafee_sprintf(idata,"A%d",i*3+pr);
		assert(getdata2==idata);
		assert(pr==2);
		assert(ppqs2.Dequeue (&pr, getdata2)==true);
		Counti2--;
		assert(ppqs2.GetCount() == Counti2);
		assert(getdata2==idata);
		assert(pr==2);

	}

	return 0;
}
