#ifdef ENV_WIN32
#pragma warning (disable:4996) 
#endif

#include <stdio.h>
#include <string>
#include "PafeeString.h"
#include "PafeeRingBufferT.h"
#include "pafee_stdlib.h"
#include "pafee_stdio.h"
#include "pafee_string.h"

#include <assert.h>

using namespace Pafee;

int main()
{
	{
		const int TEST_RING_BUFFER_CAPACITY=10;
		int pData;
		int	i;
		int GetData;
		int PeekData;
		//test GetCount/IsEmpty/Peek/Enqueue/Dequeue
		{
			//STATISTICS
			int additionalFrequency=0;
			int maximumElements=0;
			int overFlowFrequency=0;
			int presentNumber=0;
#ifdef PAFEE_STATISTICS_ENABLE
		RingBufferT<int>::STATISTICS statisticsRtn;
#endif// PAFEE_STATISTICS_ENABLE

			RingBufferT<int> buffer(TEST_RING_BUFFER_CAPACITY);
			assert(buffer.IsEmpty() == true);
			assert(buffer.GetCount() == 0);
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			assert(buffer.Dequeue(GetData) == false);
			//Enqueue test
			for(i=0; i<TEST_RING_BUFFER_CAPACITY; i++)
			{
				assert(buffer.Enqueue(i) == true);
				additionalFrequency++;
				maximumElements++;
				presentNumber++;
			}
			assert(!buffer.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			//Enqueue
			assert(buffer.Enqueue(i) == false);
			overFlowFrequency++;
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			// Dequeue test
			for(i = 0; i<TEST_RING_BUFFER_CAPACITY; i++)
			{
				assert(buffer.Peek(PeekData));
				assert(PeekData == i);
				assert(buffer.Dequeue(GetData));
				assert(PeekData == GetData);
				presentNumber--;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			assert(buffer.IsEmpty());
			assert(buffer.Dequeue(GetData) == false);
			// Enqueue and Dequeue test
			for(i = 0; i < TEST_RING_BUFFER_CAPACITY; i++)
			{
				assert(buffer.Enqueue(i) == true);
				additionalFrequency++;
				presentNumber++;
			}
			assert(!buffer.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			//Enqueue
			assert(buffer.Enqueue(i) == false);
			overFlowFrequency++;
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			//Dequeue
			for(i = 0; i < (TEST_RING_BUFFER_CAPACITY / 2); i++)
			{
				assert(buffer.Peek(PeekData));
				assert(PeekData == i);
				assert(buffer.Dequeue(GetData) == true);
				assert(PeekData == GetData);
				presentNumber--;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			assert(!buffer.IsEmpty());
			for(i = 0; i < (TEST_RING_BUFFER_CAPACITY / 2); i++)
			{
				assert(buffer.Enqueue(i) == true);
				additionalFrequency++;
				presentNumber++;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			assert(!buffer.IsEmpty());
			pData=0;
			assert(buffer.Enqueue(pData) == false);
			overFlowFrequency++;
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			//Dequeue
			for(i = 0; i < TEST_RING_BUFFER_CAPACITY; i++)
			{
				assert(buffer.Dequeue(GetData) == true);
				presentNumber--;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			assert(buffer.IsEmpty());
			assert(buffer.Dequeue(GetData) == false);
			//test	void ClearAll(void);
			for(i=0; i<TEST_RING_BUFFER_CAPACITY; i++)
			{
				assert(buffer.Enqueue(i) == true);
				additionalFrequency++;
				presentNumber++;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			buffer.ClearAll();
			presentNumber=0;
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			assert(buffer.IsEmpty());
			assert(buffer.Dequeue(GetData) == false);

			for(i = 0; i < TEST_RING_BUFFER_CAPACITY; i++)//1
			{
				assert(buffer.Enqueue(i) == true);
				additionalFrequency++;
				presentNumber++;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			assert(buffer.Enqueue(i) == false);
			overFlowFrequency++;
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
		}
		//test GetCount/IsEmpty/Peek/Enqueue/Dequeue
		{
			//STATISTICS
			int additionalFrequency=0;
			int maximumElements=0;
			int overFlowFrequency=0;
			int presentNumber=0;
#ifdef PAFEE_STATISTICS_ENABLE
			RingBufferT<String>::STATISTICS statisticsRtnstr;
#endif// PAFEE_STATISTICS_ENABLE

			String GetDatastr;
			String SetDatastr;

			RingBufferT<String> bufferstr(TEST_RING_BUFFER_CAPACITY);
			assert(bufferstr.IsEmpty() == true);
			assert(bufferstr.GetCount() == 0);
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			assert(bufferstr.Dequeue(GetDatastr) == false);
			//Enqueue test
			for(i=0; i<TEST_RING_BUFFER_CAPACITY; i++)
			{
				char strbuffer[32];
				pafee_sprintf(strbuffer,"ABC%d", i);
				SetDatastr = strbuffer;
				assert(bufferstr.Enqueue(SetDatastr) == true);
				additionalFrequency++;
				maximumElements++;
				presentNumber++;
			}
			assert(!bufferstr.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			//Enqueue
			assert(bufferstr.Enqueue(SetDatastr) == false);
			overFlowFrequency++;
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			// Dequeue test
			for(i = 0; i<TEST_RING_BUFFER_CAPACITY; i++)
			{
				char strbuffer[32];
				String PeekDatastr;
				pafee_sprintf(strbuffer,"ABC%d", i);
				SetDatastr = strbuffer;
				assert(bufferstr.Peek(PeekDatastr));
				assert(PeekDatastr == SetDatastr);
				assert(bufferstr.Dequeue(GetDatastr));
				assert(PeekDatastr == GetDatastr);
				presentNumber--;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			assert(bufferstr.IsEmpty());
			assert(bufferstr.Dequeue(GetDatastr) == false);
			// Enqueue and Dequeue test
			for(i = 0; i < TEST_RING_BUFFER_CAPACITY; i++)
			{
				char strbuffer[32];
				pafee_sprintf(strbuffer,"ABC%d", i);
				SetDatastr = strbuffer;
				assert(bufferstr.Enqueue(SetDatastr) == true);
				additionalFrequency++;
				presentNumber++;
			}
			assert(!bufferstr.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			//Enqueue
			assert(bufferstr.Enqueue(SetDatastr) == false);
			overFlowFrequency++;
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			//Dequeue
			for(i = 0; i < (TEST_RING_BUFFER_CAPACITY / 2); i++)
			{
				char strbuffer[32];
				String PeekDatastr;
				pafee_sprintf(strbuffer,"ABC%d", i);
				SetDatastr = strbuffer;
				assert(bufferstr.Peek(PeekDatastr));
				assert(PeekDatastr == SetDatastr);
				assert(bufferstr.Dequeue(GetDatastr) == true);
				assert(PeekDatastr == GetDatastr);
				presentNumber--;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			assert(!bufferstr.IsEmpty());
			for(i = 0; i < (TEST_RING_BUFFER_CAPACITY / 2); i++)
			{
				char strbuffer[32];
				pafee_sprintf(strbuffer,"ABC%d", i);
				SetDatastr = strbuffer;
				assert(bufferstr.Enqueue(SetDatastr) == true);
				additionalFrequency++;
				presentNumber++;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			assert(!bufferstr.IsEmpty());
			pData=0;
			assert(bufferstr.Enqueue(SetDatastr) == false);
			overFlowFrequency++;
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			//Dequeue
			for(i = 0; i < TEST_RING_BUFFER_CAPACITY; i++)
			{
				char strbuffer[32];
				String PeekDatastr;
				pafee_sprintf(strbuffer,"ABC%d", i);
				SetDatastr = strbuffer;
				assert(bufferstr.Dequeue(GetDatastr) == true);
				presentNumber--;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			assert(bufferstr.IsEmpty());
			assert(bufferstr.Dequeue(GetDatastr) == false);
			//test	void ClearAll(void);
			for(i=0; i<TEST_RING_BUFFER_CAPACITY; i++)
			{
				char strbuffer[32];
				pafee_sprintf(strbuffer,"ABC%d", i);
				SetDatastr = strbuffer;
				assert(bufferstr.Enqueue(SetDatastr) == true);
				additionalFrequency++;
				presentNumber++;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			bufferstr.ClearAll();
			presentNumber=0;
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			assert(bufferstr.IsEmpty());
			assert(bufferstr.Dequeue(GetDatastr) == false);

			for(i = 0; i < TEST_RING_BUFFER_CAPACITY; i++)//1
			{
				char strbuffer[32];
				pafee_sprintf(strbuffer,"ABC%d", i);
				SetDatastr = strbuffer;
				assert(bufferstr.Enqueue(SetDatastr) == true);
				additionalFrequency++;
				presentNumber++;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			assert(bufferstr.Enqueue(SetDatastr) == false);
			overFlowFrequency++;
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
		}
	}

//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////

	{
		const int TEST_RING_BUFFER_CAPACITY=10;
		int pData;
		int	i;
		int GetData;
		int PeekData;
		//test GetCount/IsEmpty/Peek/Enqueue/Dequeue
		{
			//STATISTICS
			int additionalFrequency=0;
			int maximumElements=0;
			int overFlowFrequency=0;
			int presentNumber=0;
#ifdef PAFEE_STATISTICS_ENABLE
			RingBufferT<int>::STATISTICS statisticsRtn;
#endif// PAFEE_STATISTICS_ENABLE

			RingBufferT<int> buffer0c(TEST_RING_BUFFER_CAPACITY);
			assert(buffer0c.IsEmpty() == true);
			assert(buffer0c.GetCount() == 0);
#ifdef PAFEE_STATISTICS_ENABLE
			buffer0c.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			assert(buffer0c.Dequeue(GetData) == false);
			//Enqueue test
			for(i=0; i<TEST_RING_BUFFER_CAPACITY; i++)
			{
				assert(buffer0c.Enqueue(i) == true);
				additionalFrequency++;
				maximumElements++;
				presentNumber++;
			}
			assert(!buffer0c.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
			buffer0c.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			//Enqueue
			assert(buffer0c.Enqueue(i) == false);
			overFlowFrequency++;
#ifdef PAFEE_STATISTICS_ENABLE
			buffer0c.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			//
			//
			//
			//
			//
			RingBufferT<int> buffer=buffer0c;
			//
			//
			//
			//
			//
			//
			// Dequeue test
			for(i = 0; i<TEST_RING_BUFFER_CAPACITY; i++)
			{
				assert(buffer.Peek(PeekData));
				assert(PeekData == i);
				assert(buffer.Dequeue(GetData));
				assert(PeekData == GetData);
				presentNumber--;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			assert(buffer.IsEmpty());
			assert(buffer.Dequeue(GetData) == false);
			// Enqueue and Dequeue test
			for(i = 0; i < TEST_RING_BUFFER_CAPACITY; i++)
			{
				assert(buffer.Enqueue(i) == true);
				additionalFrequency++;
				presentNumber++;
			}
			assert(!buffer.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			//Enqueue
			assert(buffer.Enqueue(i) == false);
			overFlowFrequency++;
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			//Dequeue
			for(i = 0; i < (TEST_RING_BUFFER_CAPACITY / 2); i++)
			{
				assert(buffer.Peek(PeekData));
				assert(PeekData == i);
				assert(buffer.Dequeue(GetData) == true);
				assert(PeekData == GetData);
				presentNumber--;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			assert(!buffer.IsEmpty());
			for(i = 0; i < (TEST_RING_BUFFER_CAPACITY / 2); i++)
			{
				assert(buffer.Enqueue(i) == true);
				additionalFrequency++;
				presentNumber++;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			assert(!buffer.IsEmpty());
			pData=0;
			assert(buffer.Enqueue(pData) == false);
			overFlowFrequency++;
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			//Dequeue
			for(i = 0; i < TEST_RING_BUFFER_CAPACITY; i++)
			{
				assert(buffer.Dequeue(GetData) == true);
				presentNumber--;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			assert(buffer.IsEmpty());
			assert(buffer.Dequeue(GetData) == false);
			//test	void ClearAll(void);
			for(i=0; i<TEST_RING_BUFFER_CAPACITY; i++)
			{
				assert(buffer.Enqueue(i) == true);
				additionalFrequency++;
				presentNumber++;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			buffer.ClearAll();
			presentNumber=0;
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			assert(buffer.IsEmpty());
			assert(buffer.Dequeue(GetData) == false);

			for(i = 0; i < TEST_RING_BUFFER_CAPACITY; i++)//1
			{
				assert(buffer.Enqueue(i) == true);
				additionalFrequency++;
				presentNumber++;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
			assert(buffer.Enqueue(i) == false);
			overFlowFrequency++;
#ifdef PAFEE_STATISTICS_ENABLE
			buffer.GetStatistics(&statisticsRtn);
			assert(statisticsRtn.additionalFrequency == additionalFrequency);
			assert(statisticsRtn.maximumElements == maximumElements);
			assert(statisticsRtn.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtn.presentNumber == presentNumber);
#endif
		}
		//test GetCount/IsEmpty/Peek/Enqueue/Dequeue
		{
			//STATISTICS
			int additionalFrequency=0;
			int maximumElements=0;
			int overFlowFrequency=0;
			int presentNumber=0;
#ifdef PAFEE_STATISTICS_ENABLE
			RingBufferT<String>::STATISTICS statisticsRtnstr;
#endif// PAFEE_STATISTICS_ENABLE

			String GetDatastr;
			String SetDatastr;

			RingBufferT<String> bufferstr0xc(TEST_RING_BUFFER_CAPACITY);
			assert(bufferstr0xc.IsEmpty() == true);
			assert(bufferstr0xc.GetCount() == 0);
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr0xc.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			assert(bufferstr0xc.Dequeue(GetDatastr) == false);
			//Enqueue test
			for(i=0; i<TEST_RING_BUFFER_CAPACITY; i++)
			{
				char strbuffer[32];
				pafee_sprintf(strbuffer,"ABC%d", i);
				SetDatastr = strbuffer;
				assert(bufferstr0xc.Enqueue(SetDatastr) == true);
				additionalFrequency++;
				maximumElements++;
				presentNumber++;
			}
			assert(!bufferstr0xc.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr0xc.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			//Enqueue
			assert(bufferstr0xc.Enqueue(SetDatastr) == false);
			overFlowFrequency++;
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr0xc.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			//
			//
			//
			//
			//RingBufferT<String> bufferstr=bufferstr0xc;
			RingBufferT<String> bufferstr;
			bufferstr=bufferstr0xc;
			//
			//
			//
			//
			// Dequeue test
			for(i = 0; i<TEST_RING_BUFFER_CAPACITY; i++)
			{
				char strbuffer[32];
				String PeekDatastr;
				pafee_sprintf(strbuffer,"ABC%d", i);
				SetDatastr = strbuffer;
				assert(bufferstr.Peek(PeekDatastr));
				assert(PeekDatastr == SetDatastr);
				assert(bufferstr.Dequeue(GetDatastr));
				assert(PeekDatastr == GetDatastr);
				presentNumber--;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			assert(bufferstr.IsEmpty());
			assert(bufferstr.Dequeue(GetDatastr) == false);
			// Enqueue and Dequeue test
			for(i = 0; i < TEST_RING_BUFFER_CAPACITY; i++)
			{
				char strbuffer[32];
				pafee_sprintf(strbuffer,"ABC%d", i);
				SetDatastr = strbuffer;
				assert(bufferstr.Enqueue(SetDatastr) == true);
				additionalFrequency++;
				presentNumber++;
			}
			assert(!bufferstr.IsEmpty());
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			//Enqueue
			assert(bufferstr.Enqueue(SetDatastr) == false);
			overFlowFrequency++;
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			//Dequeue
			for(i = 0; i < (TEST_RING_BUFFER_CAPACITY / 2); i++)
			{
				char strbuffer[32];
				String PeekDatastr;
				pafee_sprintf(strbuffer,"ABC%d", i);
				SetDatastr = strbuffer;
				assert(bufferstr.Peek(PeekDatastr));
				assert(PeekDatastr == SetDatastr);
				assert(bufferstr.Dequeue(GetDatastr) == true);
				assert(PeekDatastr == GetDatastr);
				presentNumber--;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			assert(!bufferstr.IsEmpty());
			for(i = 0; i < (TEST_RING_BUFFER_CAPACITY / 2); i++)
			{
				char strbuffer[32];
				pafee_sprintf(strbuffer,"ABC%d", i);
				SetDatastr = strbuffer;
				assert(bufferstr.Enqueue(SetDatastr) == true);
				additionalFrequency++;
				presentNumber++;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			assert(!bufferstr.IsEmpty());
			pData=0;
			assert(bufferstr.Enqueue(SetDatastr) == false);
			overFlowFrequency++;
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			//Dequeue
			for(i = 0; i < TEST_RING_BUFFER_CAPACITY; i++)
			{
				char strbuffer[32];
				String PeekDatastr;
				pafee_sprintf(strbuffer,"ABC%d", i);
				SetDatastr = strbuffer;
				assert(bufferstr.Dequeue(GetDatastr) == true);
				presentNumber--;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			assert(bufferstr.IsEmpty());
			assert(bufferstr.Dequeue(GetDatastr) == false);
			//test	void ClearAll(void);
			for(i=0; i<TEST_RING_BUFFER_CAPACITY; i++)
			{
				char strbuffer[32];
				pafee_sprintf(strbuffer,"ABC%d", i);
				SetDatastr = strbuffer;
				assert(bufferstr.Enqueue(SetDatastr) == true);
				additionalFrequency++;
				presentNumber++;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			bufferstr.ClearAll();
			presentNumber=0;
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			assert(bufferstr.IsEmpty());
			assert(bufferstr.Dequeue(GetDatastr) == false);

			for(i = 0; i < TEST_RING_BUFFER_CAPACITY; i++)//1
			{
				char strbuffer[32];
				pafee_sprintf(strbuffer,"ABC%d", i);
				SetDatastr = strbuffer;
				assert(bufferstr.Enqueue(SetDatastr) == true);
				additionalFrequency++;
				presentNumber++;
			}
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
			assert(bufferstr.Enqueue(SetDatastr) == false);
			overFlowFrequency++;
#ifdef PAFEE_STATISTICS_ENABLE
			bufferstr.GetStatistics(&statisticsRtnstr);
			assert(statisticsRtnstr.additionalFrequency == additionalFrequency);
			assert(statisticsRtnstr.maximumElements == maximumElements);
			assert(statisticsRtnstr.overFlowFrequency == overFlowFrequency);
			assert(statisticsRtnstr.presentNumber == presentNumber);
#endif
		}
	}
	return 0;
}
