#include <stdio.h>
#include <list>
#include <assert.h>
#include "PafeeStackT.h"

int main()
{
	{
		//STATISTICS
		int addCount=0;
		int deleteCount=0;
		int maxElementCount=0;
		int presentElementCount=0;
#ifdef PAFEE_STATISTICS_ENABLE
		Pafee::StackT<int>::STATISTICS statisticsRtn;
#endif
		int a,b;
		Pafee::StackT<int> stk;
		int i;
		assert(stk.IsEmpty());
		assert(stk.GetCount()==0);
		for(i=0;i<10;i++)
		{
			assert(stk.GetCount()==i);
			assert( stk.Push(i) );
			//
			addCount++;
			maxElementCount++;
			presentElementCount++;
			//

			assert(stk.GetCount()==i+1);
		}
#ifdef PAFEE_STATISTICS_ENABLE
		stk.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif
//		int addCount2=addCount;
//		int deleteCount2=deleteCount;
//		int maxElementCount2=maxElementCount;
//		int presentElementCount2=presentElementCount;
		int j;
		for( j=0;j<10;j++)
		{
			assert( stk.Peek(a) );
			assert(a==i-1);
			assert(stk.GetCount()==i);
			i--;
			assert( stk.Pop(b) );
			//
			deleteCount++;
			presentElementCount--;
			//
			assert(stk.GetCount()==i);
			assert(b==i);
		}
		assert( stk.Peek(b) == false);
		assert( stk.Pop(b) == false);

#ifdef PAFEE_STATISTICS_ENABLE
		stk.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif
		for(i=0;i<10;i++)
		{
			assert(stk.GetCount()==i);
			stk.Push(i);
			//
			addCount++;
			presentElementCount++;
			//
			assert(stk.GetCount()==i+1);
		}
#ifdef PAFEE_STATISTICS_ENABLE
		stk.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif
		for(j=0;j<10;j++)
		{
			stk.Peek(a);
			assert(a==i-1);
			assert(stk.GetCount()==i);
			stk.RemoveFront();
			i--;
			//
			deleteCount++;
			presentElementCount--;
			//
			if ( i == 0 ) break;
			assert (stk.Peek(a));
			assert(a==i-1);
			assert(stk.GetCount()==i);
		}
		assert (stk.Peek(a)==false);
#ifdef PAFEE_STATISTICS_ENABLE
		stk.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif
		assert(stk.IsEmpty());
		assert(stk.GetCount()==0);
		for(i=0;i<10;i++)
		{
			assert(stk.GetCount()==i);
			stk.Push(i);
			//
			addCount++;
			presentElementCount++;
			//
			assert(stk.GetCount()==i+1);
		}
		stk.RemoveAll();
		deleteCount+=10;
		presentElementCount-=10;
#ifdef PAFEE_STATISTICS_ENABLE
		stk.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif
		assert(stk.IsEmpty());
		assert(stk.GetCount()==0);

	}
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

	{
		//STATISTICS
		int addCount=0;
		int deleteCount=0;
		int maxElementCount=0;
		int presentElementCount=0;
#ifdef PAFEE_STATISTICS_ENABLE
		Pafee::StackT<int>::STATISTICS statisticsRtn;
#endif
		int a,b;
		Pafee::StackT<int> stk0c;
		int i;
		assert(stk0c.IsEmpty());
		assert(stk0c.GetCount()==0);
		for(i=0;i<10;i++)
		{
			assert( stk0c.GetCount()==i);
			assert( stk0c.Push(i) );
			//
			addCount++;
			maxElementCount++;
			presentElementCount++;
			//

			assert(stk0c.GetCount()==i+1);
		}
#ifdef PAFEE_STATISTICS_ENABLE
		stk0c.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif

		//Pafee::StackT<int> stk = stk0c;
		Pafee::StackT<int> stk;
		stk = stk0c;
		int j;
		for( j=0;j<10;j++)
		{
			assert( stk.Peek(a) );
			assert(a==i-1);
			assert(stk.GetCount()==i);
			i--;
			assert( stk.Pop(b) );
			//
			deleteCount++;
			presentElementCount--;
			//
			assert(stk.GetCount()==i);
			assert(b==i);
		}
		assert( stk.Peek(b) == false);
		assert( stk.Pop(b) == false);

#ifdef PAFEE_STATISTICS_ENABLE
		stk.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif
		for(i=0;i<10;i++)
		{
			assert(stk.GetCount()==i);
			stk.Push(i);
			//
			addCount++;
			presentElementCount++;
			//
			assert(stk.GetCount()==i+1);
		}
#ifdef PAFEE_STATISTICS_ENABLE
		stk.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif
		for(j=0;j<10;j++)
		{
			stk.Peek(a);
			assert(a==i-1);
			assert(stk.GetCount()==i);
			stk.RemoveFront();
			i--;
			//
			deleteCount++;
			presentElementCount--;
			//
			if ( i == 0 ) break;
			assert (stk.Peek(a));
			assert(a==i-1);
			assert(stk.GetCount()==i);
		}
		assert (stk.Peek(a)==false);
#ifdef PAFEE_STATISTICS_ENABLE
		stk.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif
		assert(stk.IsEmpty());
		assert(stk.GetCount()==0);
		for(i=0;i<10;i++)
		{
			assert(stk.GetCount()==i);
			stk.Push(i);
			//
			addCount++;
			presentElementCount++;
			//
			assert(stk.GetCount()==i+1);
		}
		stk.RemoveAll();
		deleteCount+=10;
		presentElementCount-=10;
#ifdef PAFEE_STATISTICS_ENABLE
		stk.GetStatistics(&statisticsRtn);
		assert(statisticsRtn.addCount == addCount);
		assert(statisticsRtn.deleteCount == deleteCount);
		assert(statisticsRtn.maxElementCount == maxElementCount);
		assert(statisticsRtn.presentElementCount == presentElementCount);
#endif
		assert(stk.IsEmpty());
		assert(stk.GetCount()==0);

	}
	return 0;
}
