#ifdef PAFEE_OS_WINDOWS
#include <windows.h>
#endif

#ifdef PAFEE_OS_LINUX
#include <unistd.h>
#endif

#ifdef PAFEE_OS_ITRON
#include "kernel_id.h"
#endif

#include "PafeeMutex.h"
#include "PafeeTask.h"
using namespace Pafee;

int pafeeCount1 = 0;
int pafeeCount2 = 0;
int pafeeCount3 = 0;

PafeeMutex pafeeMutex1;
PafeeMutex pafeeMutex2;
PafeeMutex pafeeMutex3;

class TaskMutex1 : public PafeeTask
{
public:
	void* TaskProcedure(
		void* pParam
	);
};

class TaskMutex2 : public PafeeTask
{
public:
	void* TaskProcedure(
		void* pParam
	);
};

class TaskMutex3 : public PafeeTask
{
public:
	void* TaskProcedure(
		void* pParam
	);
};

class TaskMutex4 : public PafeeTask
{
public:
	void* TaskProcedure(
		void* pParam
	);
};

class TaskMutex5 : public PafeeTask
{
public:
	void* TaskProcedure(
		void* pParam
	);
};

class TaskMutex6 : public PafeeTask
{
public:
	void* TaskProcedure(
		void* pParam
	);
};

class TaskMutex7 : public PafeeTask
{
public:
	void* TaskProcedure(
		void* pParam
	);
};

void pafeeSeep(unsigned long time);

#if 0
int main(int argc, char* argv[])
#else
int main(void* arg)
#endif
{
	TaskMutex1 task1; // access mutex1,mutex2,mutex3
	TaskMutex2 task2; // access mutex1 at Lock
	TaskMutex3 task3; // access mutex2 at AsyncLock
	TaskMutex4 task4; // access mutex3 at TimedLock
	TaskMutex5 task5; // access mutex1 at Lock
	TaskMutex6 task6; // access mutex2 at AsyncLock
	TaskMutex7 task7; // access mutex3 at TimedLock
//	PafeeTask::TASK_ID id1;
//	PafeeTask::TASK_ID id2;
//	PafeeTask::TASK_ID id3;
//	PafeeTask::TASK_ID id4;
	bool returnCode;
	PafeeMutex::MUTEX_ERROR errorCode;

	pafeeSeep(10);
	/* None Mutex access test */
	errorCode = pafeeMutex1.GetLastError();
	MUTEX_DEBUG(("ErrorCode:Start %d\n", errorCode));
	pafeeMutex1.Delete();
	errorCode = pafeeMutex1.GetLastError();
	MUTEX_DEBUG(("ErrorCode:Delete %d\n", errorCode));
	pafeeMutex1.Lock();
	errorCode = pafeeMutex1.GetLastError();
	MUTEX_DEBUG(("ErrorCode:Lock %d\n", errorCode));
	pafeeMutex1.AsyncLock();
	errorCode = pafeeMutex1.GetLastError();
	MUTEX_DEBUG(("ErrorCode:AsyncLock %d\n", errorCode));
	pafeeMutex1.TimedLock(50);
	errorCode = pafeeMutex1.GetLastError();
	MUTEX_DEBUG(("ErrorCode:TimedLock %d\n", errorCode));
	pafeeMutex1.Unlock();
	errorCode = pafeeMutex1.GetLastError();
	MUTEX_DEBUG(("ErrorCode:Unlock %d\n", errorCode));

	/* Attach1 Test */
//	returnCode = pafeeMutex1.Create();
	returnCode = pafeeMutex1.Attach(SEM1);
	if(returnCode == true)
	{
		MUTEX_DEBUG(("Attach1 success on main\n"));
	}
	else
	{
		MUTEX_DEBUG(("Attach1 failed on main\n"));
	}
	errorCode = pafeeMutex1.GetLastError();
	MUTEX_DEBUG(("ErrorCode:Attach1 %d\n", errorCode));

	/* Attach2 Test */
//	returnCode = pafeeMutex2.Create();
	returnCode = pafeeMutex2.Attach(SEM2);
	if(returnCode == true)
	{
		MUTEX_DEBUG(("Attach2 success on main\n"));
	}
	else
	{
		MUTEX_DEBUG(("Attach2 failed on main\n"));
	}
	errorCode = pafeeMutex2.GetLastError();
	MUTEX_DEBUG(("ErrorCode:Attach2 %d\n", errorCode));

	/* Attach3 Test */
//	returnCode = pafeeMutex3.Create();
	returnCode = pafeeMutex3.Attach(SEM3);
	if(returnCode == true)
	{
		MUTEX_DEBUG(("Attach3 success on main\n"));
	}
	else
	{
		MUTEX_DEBUG(("Attach3 failed on main\n"));
	}
	errorCode = pafeeMutex3.GetLastError();
	MUTEX_DEBUG(("ErrorCode:Attach3 %d\n", errorCode));

	/* Double craete Test */
//	returnCode = pafeeMutex1.Create();
	returnCode = pafeeMutex1.Attach(SEM1);
	if(returnCode == true)
	{
		MUTEX_DEBUG(("Create1 success on main\n"));
	}
	else
	{
		MUTEX_DEBUG(("Create1 failed on main\n"));
	}
	errorCode = pafeeMutex1.GetLastError();
	MUTEX_DEBUG(("ErrorCode:Attach1 %d\n", errorCode));

	/* Delete Test */
	returnCode = pafeeMutex1.Delete();
	if(returnCode == true)
	{
		MUTEX_DEBUG(("Delete1 success on main\n"));
	}
	else
	{
		MUTEX_DEBUG(("Delete1 failed on main\n"));
	}

	/* Recraete Test */
//	returnCode = pafeeMutex1.Create();
	returnCode = pafeeMutex1.Attach(SEM1);
	if(returnCode == true)
	{
		MUTEX_DEBUG(("Create success on main\n"));
	}
	else
	{
		MUTEX_DEBUG(("Create failed on main\n"));
	}

//	task1.Create(&id1, 1, 0, 0, NULL, true);
//	task2.Create(&id2, 1, 0, 0, NULL, true);
//	task3.Create(&id3, 1, 0, 0, NULL, true);
//	task4.Create(&id4, 1, 0, 0, NULL, true);
	dly_tsk(100);
	task1.Attach(1);
//	task2.Attach(2);
	task3.Attach(3);
//	task4.Attach(4);
//	task5.Attach(5);
	task6.Attach(6);
//	task7.Attach(7);

	pafeeSeep(200);

	/* Delete Test while use mutex */
#if 0
	returnCode = pafeeMutex1.Delete();
	if(returnCode == true)
	{
		MUTEX_DEBUG(("Delete success on main\n"));
	}
	else
	{
		MUTEX_DEBUG(("Delete failed on main\n"));
	}
#endif
	while(1)
		dly_tsk(100000);

	return 0;
}

/* Task1 */
void * TaskMutex1::TaskProcedure(
	void* pParam
)
{
	int	i;
	bool locked;
	while(1){
		locked = pafeeMutex1.Lock(); //mutex Ԃ͑̃XbhϐύXłȂ
		MUTEX_DEBUG(("pafeeCount1:"));
		for(i=0;i<10;i++){
			MUTEX_DEBUG(("%d:",pafeeCount1));
			pafeeCount1++;
			pafeeSeep(1);
		}
		MUTEX_DEBUG(("\n"));
		locked = pafeeMutex1.Unlock();

		locked = pafeeMutex2.Lock(); //mutex Ԃ͑̃XbhϐύXłȂ
		MUTEX_DEBUG(("pafeeCount2:"));
		for(i=0;i<10;i++){
			MUTEX_DEBUG(("%d:",pafeeCount2));
			pafeeCount2++;
			pafeeSeep(1);
		}
		MUTEX_DEBUG(("\n"));
		locked = pafeeMutex2.Unlock();

		locked = pafeeMutex3.Lock(); //mutex Ԃ͑̃XbhϐύXłȂ
		MUTEX_DEBUG(("pafeeCount3:"));
		for(i=0;i<10;i++){
			MUTEX_DEBUG(("%d:",pafeeCount3));
			pafeeCount3++;
			pafeeSeep(1);
		}
		MUTEX_DEBUG(("\n"));
		locked = pafeeMutex3.Unlock();
	}
}

/* Task2 */
void * TaskMutex2::TaskProcedure(
	void* pParam
)
{
	bool locked;
	PafeeMutex::MUTEX_ERROR errorCode;
	while(1){
		locked = pafeeMutex1.Lock();
		if(locked == true)
		{
			MUTEX_DEBUG(("Task2:Lock OK\n"));
			pafeeCount1=0;
		}
		else
		{
			MUTEX_DEBUG(("Task2:Lock NG\n"));
			errorCode = pafeeMutex1.GetLastError();
			MUTEX_DEBUG(("ErrorCode:Task2 %d\n", errorCode));
		}

		if(locked == true)
		{
			pafeeSeep(2);
			locked = pafeeMutex1.Unlock();
			if(locked == true)
			{
				MUTEX_DEBUG(("Task2:Unlock OK\n"));
			}
			else
			{
				MUTEX_DEBUG(("Task2:Unlockock NG\n"));
				errorCode = pafeeMutex1.GetLastError();
				MUTEX_DEBUG(("ErrorCode:Task2 %d\n", errorCode));
			}
		}
		pafeeSeep(4);
	}
}

/* Task3 */
void * TaskMutex3::TaskProcedure(
	void* pParam
)
{
	bool locked;
	PafeeMutex::MUTEX_ERROR errorCode;
	while(1){
		locked = pafeeMutex2.AsyncLock();
		if(locked == true)
		{
			MUTEX_DEBUG(("Task3:AsyncLock OK\n"));
			pafeeCount2=0;
		}
		else
		{
			MUTEX_DEBUG(("Task3:AsyncLock NG\n"));
			errorCode = pafeeMutex2.GetLastError();
			MUTEX_DEBUG(("ErrorCode:Task3 %d\n", errorCode));
		}

		if(locked == true)
		{
			pafeeSeep(2);
			locked = pafeeMutex2.Unlock();
			if(locked == true)
			{
				MUTEX_DEBUG(("Task3:UnLock OK\n"));
			}
			else
			{
				MUTEX_DEBUG(("Task3:UnLock NG\n"));
			}
		}
		pafeeSeep(4);
	}
}

/* Task4 */
void * TaskMutex4::TaskProcedure(
	void* pParam
)
{
	bool locked;
	PafeeMutex::MUTEX_ERROR errorCode;
	while(1){
		locked = pafeeMutex3.TimedLock(4);
		if(locked == true)
		{
			MUTEX_DEBUG(("Task4:TimedLock OK\n"));
			pafeeCount3=0;
		}
		else
		{
			MUTEX_DEBUG(("Task4:TimedLock NG\n"));
			errorCode = pafeeMutex3.GetLastError();
			MUTEX_DEBUG(("ErrorCode:Task4 %d\n", errorCode));
		}

		if(locked == true)
		{
			pafeeSeep(2);
			locked = pafeeMutex3.Unlock();
			if(locked == true)
			{
				MUTEX_DEBUG(("Task4:UnLock OK\n"));
			}
			else
			{
				MUTEX_DEBUG(("Task4:UnLock NG\n"));
			}
		}
		pafeeSeep(4);
	}
}

/* Task5 */
void * TaskMutex5::TaskProcedure(
	void* pParam
)
{
	bool locked;
	PafeeMutex::MUTEX_ERROR errorCode;
	while(1){
		locked = pafeeMutex1.Lock();
		if(locked == true)
		{
			MUTEX_DEBUG(("Task5:Lock OK\n"));
			pafeeCount1=0;
		}
		else
		{
			MUTEX_DEBUG(("Task5:Lock NG\n"));
			errorCode = pafeeMutex1.GetLastError();
			MUTEX_DEBUG(("ErrorCode:Task5 %d\n", errorCode));
		}

		if(locked == true)
		{
			pafeeSeep(2);
			locked = pafeeMutex1.Unlock();
			if(locked == true)
			{
				MUTEX_DEBUG(("Task5:Unlock OK\n"));
			}
			else
			{
				MUTEX_DEBUG(("Task5:Unlockock NG\n"));
				errorCode = pafeeMutex1.GetLastError();
				MUTEX_DEBUG(("ErrorCode:Task5 %d\n", errorCode));
			}
		}
		pafeeSeep(4);
	}
}

/* Task6 */
void * TaskMutex6::TaskProcedure(
	void* pParam
)
{
	bool locked;
	PafeeMutex::MUTEX_ERROR errorCode;
	while(1){
		locked = pafeeMutex2.AsyncLock();
		if(locked == true)
		{
			MUTEX_DEBUG(("Task6:AsyncLock OK\n"));
			pafeeCount2=0;
		}
		else
		{
			MUTEX_DEBUG(("Task6:AsyncLock NG\n"));
			errorCode = pafeeMutex2.GetLastError();
			MUTEX_DEBUG(("ErrorCode:Task6 %d\n", errorCode));
		}

		if(locked == true)
		{
			pafeeSeep(2);
			locked = pafeeMutex2.Unlock();
			if(locked == true)
			{
				MUTEX_DEBUG(("Task6:UnLock OK\n"));
			}
			else
			{
				MUTEX_DEBUG(("Task6:UnLock NG\n"));
			}
		}
		pafeeSeep(4);
	}
}

/* Task7 */
void * TaskMutex7::TaskProcedure(
	void* pParam
)
{
	bool locked;
	PafeeMutex::MUTEX_ERROR errorCode;
	while(1){
		locked = pafeeMutex3.TimedLock(4);
		if(locked == true)
		{
			MUTEX_DEBUG(("Task7:TimedLock OK\n"));
			pafeeCount3=0;
		}
		else
		{
			MUTEX_DEBUG(("Task7:TimedLock NG\n"));
			errorCode = pafeeMutex3.GetLastError();
			MUTEX_DEBUG(("ErrorCode:Task7 %d\n", errorCode));
		}

		if(locked == true)
		{
			pafeeSeep(2);
			locked = pafeeMutex3.Unlock();
			if(locked == true)
			{
				MUTEX_DEBUG(("Task7:UnLock OK\n"));
			}
			else
			{
				MUTEX_DEBUG(("Task7:UnLock NG\n"));
			}
		}
		pafeeSeep(4);
	}
}

void pafeeSeep(unsigned long time)
{
#ifdef PAFEE_OS_WINDOWS
	Sleep(time*1000);
#endif
#ifdef PAFEE_OS_LINUX
	sleep(time);
#endif
#ifdef PAFEE_OS_ITRON
	dly_tsk(time*100);
#endif
}