// osabst.cpp : R\[ AvP[Vp̃Gg |Cg̒`
//

#include "SemaphoreTestITR.h"
#include "PafeeSemaphore.h"
#include "PafeeTask.h"
#include "t_syslog.h"

using namespace Pafee;

PafeeSemaphore sem;
PafeeSemaphore::SEM_ERROR error;

#if 0
typedef struct tagARGPARAM
{
	char output;
} ARGPARAM_T;
#endif
ARGPARAM_T fParamA = {'A'};
ARGPARAM_T fParamB = {'B'};
ARGPARAM_T fParamC = {'C'};
ARGPARAM_T fParam1 = {'1'};
ARGPARAM_T fParam2 = {'2'};
ARGPARAM_T fParam3 = {'3'};

TASK_ENTRY_PARAM EntryParamA = {TASK1, &fParamA};
TASK_ENTRY_PARAM EntryParamB = {TASK2, &fParamB};
TASK_ENTRY_PARAM EntryParamC = {TASK3, &fParamC};
TASK_ENTRY_PARAM EntryParam1 = {TASK4, &fParam1};
TASK_ENTRY_PARAM EntryParam2 = {TASK5, &fParam2};
TASK_ENTRY_PARAM EntryParam3 = {TASK6, &fParam3};

void func0(void*);
void func1(void*);
void func2(void*);
void func3(void*);

class RealTask0 : public PafeeTask
{
public:
	~RealTask0()
	{
		/* do nothing */
	}

	void* TaskProcedure(void* param)
	{
		func0(param);
		return(param);
	}
};
class RealTask1 : public PafeeTask
{
public:
	~RealTask1()
	{
		/* do nothing */
	}

	void* TaskProcedure(void* param)
	{
		func1(param);
		return(param);
	}
};
class RealTask2 : public PafeeTask
{
public:
	~RealTask2()
	{
		/* do nothing */
	}

	void* TaskProcedure(void* param)
	{
		func2(param);
		return(param);
	}
};
class RealTask3 : public PafeeTask
{
public:
	~RealTask3()
	{
		/* do nothing */
	}

	void* TaskProcedure(void* param)
	{
		func3(param);
		return(param);
	}
};

void mainSleep(int count)
{
	unsigned int i, j;
	while(count--)
	{
		i=65535;
		j=6553;
//		while(i)
		{
			while(j)
			{
				j--;
			}
			i--;
		}
	}
}

void func0(
	void*	pParam
)
{
	char i = 0;
	ARGPARAM_T* pFuncParam = (ARGPARAM_T*)pParam;

	for(i = 1; i<10; i++)
	{
		syslog(LOG_NOTICE, "%c", pFuncParam->output);
	}
	syslog(LOG_NOTICE, "\n");
}
void func1(
	void*	pParam
)
{
	char i = 0;
	char count = 0;
	ARGPARAM_T* pFuncParam = (ARGPARAM_T*)pParam;

	while(count < 5)
	{
		if(sem.AsyncTake() == true)
		{
			for(i = 1; i<10; i++)
			{
				syslog(LOG_NOTICE, "%c", pFuncParam->output);
				mainSleep(100);
			}
			sem.Release();
			break;
		}
		else
		{
			error = sem.GetLastError();
			count++;
			syslog(LOG_NOTICE, "func1error:%3d\n", error);
			mainSleep(100);
		}
	}
	syslog(LOG_NOTICE, "\n");
}

void func2(
	void*	pParam
)
{
	char i = 0;
	ARGPARAM_T* pFuncParam = (ARGPARAM_T*)pParam;

	if(sem.Take() == true)
	{
		syslog(LOG_NOTICE, "func2:go!");
		for(i = 1; i<10; i++)
		{
			syslog(LOG_NOTICE, "%c", pFuncParam->output);
			mainSleep(100);
		}
		sem.Release();
	}
	else
	{
		error = sem.GetLastError();
		syslog(LOG_NOTICE, "func2error:%3d\n", error);
	}
	syslog(LOG_NOTICE, "\n");
}

void func3(
	void*	pParam
)
{
	char i = 0;
	ARGPARAM_T* pFuncParam = (ARGPARAM_T*)pParam;


	if(sem.TimedTake(200) == true)
	{
		syslog(LOG_NOTICE, "func3:2sec");
	}
	else
	{
		error = sem.GetLastError();
		syslog(LOG_NOTICE, "func3error:%3d\n", error);
		return;
	}
	for(i = 1; i<10; i++)
	{
		syslog(LOG_NOTICE, "%c", pFuncParam->output);
		mainSleep(100);
	}
	syslog(LOG_NOTICE, "\n");
	sem.Release();
}


//int main(int argc, char* argv[])
int testmain(void *exinf)
{

	RealTask0 threadA, threadB, threadC;
	RealTask1 thread1;
	RealTask2 thread2;
	RealTask3 thread3;
	PafeeTask::TASK_ERROR errcodeT;
	PafeeSemaphore::SEM_ERROR errcodeS;
	bool retval = false;

#if 0
	ARGPARAM_T fParamA = {'A'};
	ARGPARAM_T fParamB = {'B'};
	ARGPARAM_T fParamC = {'C'};
	ARGPARAM_T fParam1 = {'1'};
	ARGPARAM_T fParam2 = {'2'};
	ARGPARAM_T fParam3 = {'3'};
#endif

	retval = threadA.Start();
	errcodeT = threadA.GetLastError();
	syslog(LOG_NOTICE, "threadA.Start retval = %d, error? = %d\n", retval, errcodeT);
	mainSleep(1000);
	retval = threadB.Stop();
	errcodeT = threadB.GetLastError();
	syslog(LOG_NOTICE, "threadB.Stop retval = %d, error? = %d\n", retval, errcodeT);
	mainSleep(1000);
#if 0
	retval = threadC.Delete();
	errcodeT = threadC.GetLastError();
	printf("threadC.Delete retval = %d, error? = %d\n", retval, errcodeT);
	retval = threadA.Delete();
	errcodeT = threadA.GetLastError();
	printf("threadA.Delete retval = %d, error? = %d\n", retval, errcodeT);
#endif
#if 0
	retval = threadA.Create(&tidA, THREAD_PRIORITY_HIGHEST, 0, 0xff, &fParamA, false);
	errcodeT = threadA.GetLastError();
	printf("threadA.Create retval = %d, error? = %d\n", retval, errcodeT);
	retval = threadB.Create(&tidB, 800, 0, 0xff, &fParamB, true);
	errcodeT = threadB.GetLastError();
	printf("threadB.Create retval = %d, error? = %d\n", retval, errcodeT);
	retval = threadB.Create(&tidB, THREAD_PRIORITY_NORMAL, 0, 0xff, &fParamB, true);
	errcodeT = threadB.GetLastError();
	printf("threadB.Create retval = %d, error? = %d\n", retval, errcodeT);
	retval = threadC.Create(&tidC, THREAD_PRIORITY_NORMAL, 0, 0xff, &fParamC, false);
	errcodeT = threadC.GetLastError();
	printf("threadC.Create retval = %d, error? = %d\n", retval, errcodeT);
#else
	retval = threadA.Attach(TASK1);
	errcodeT = threadA.GetLastError();
	syslog(LOG_NOTICE, "threadA.Attach retval = %d, error? = %d\n", retval, errcodeT);
	mainSleep(1000);
	retval = threadB.Attach(TASK2);
	errcodeT = threadB.GetLastError();
	syslog(LOG_NOTICE, "threadB.Attach retval = %d, error? = %d\n", retval, errcodeT);
	mainSleep(1000);
	retval = threadC.Attach(TASK3);
	errcodeT = threadC.GetLastError();
	syslog(LOG_NOTICE, "threadC.Attach retval = %d, error? = %d\n", retval, errcodeT);
	mainSleep(1000);
#endif

	retval = threadA.Start();
	errcodeT = threadA.GetLastError();
	syslog(LOG_NOTICE, "threadA.Start retval = %d, error? = %d\n", retval, errcodeT);
	mainSleep(1000);
	retval = threadB.Stop();
	errcodeT = threadB.GetLastError();
	syslog(LOG_NOTICE, "threadB.Stop retval = %d, error? = %d\n", retval, errcodeT);
	mainSleep(1000);
#if 0
	retval = threadC.Delete();
	errcodeT = threadC.GetLastError();
	printf("threadC.Delete retval = %d, error? = %d\n", retval, errcodeT);
	retval = threadA.Delete();
	errcodeT = threadA.GetLastError();
	printf("threadA.Delete retval = %d, error? = %d\n", retval, errcodeT);
#endif
	retval = threadB.Stop();
	errcodeT = threadB.GetLastError();
	syslog(LOG_NOTICE, "threadB.Stop retval = %d, error? = %d\n", retval, errcodeT);
	mainSleep(1000);
#if 0
	retval = threadC.Delete();
	errcodeT = threadC.GetLastError();
	printf("threadC.Delete retval = %d, error? = %d\n", retval, errcodeT);
	retval = threadA.Delete();
	errcodeT = threadA.GetLastError();
	printf("threadA.Delete retval = %d, error? = %d\n", retval, errcodeT);
#endif
	retval = threadB.Start();
	errcodeT = threadB.GetLastError();
	syslog(LOG_NOTICE, "threadB.Start retval = %d, error? = %d\n", retval, errcodeT);
	mainSleep(1000);
	retval = threadC.Start();
	errcodeT = threadC.GetLastError();
	syslog(LOG_NOTICE, "threadC.Start retval = %d, error? = %d\n", retval, errcodeT);
	mainSleep(1000);


	syslog(LOG_NOTICE, "\n\n\n");

#if 0
	retval = thread1.Create(&tid1, THREAD_PRIORITY_HIGHEST, 0, 0, &fParam1, true);
	errcodeT = thread1.GetLastError();
	printf("thread1.Create retval = %d, error? = %d\n", retval, errcodeT);
	retval = thread2.Create(&tid2, THREAD_PRIORITY_NORMAL, 0, 0, &fParam2, true);
	errcodeT = thread2.GetLastError();
	printf("thread2.Create retval = %d, error? = %d\n", retval, errcodeT);
	retval = thread3.Create(&tid3, THREAD_PRIORITY_NORMAL, 0, 0, &fParam3, true);
	errcodeT = thread3.GetLastError();
	printf("thread3.Create retval = %d, error? = %d\n", retval, errcodeT);
#endif

	mainSleep(1000);
	mainSleep(1000);
	mainSleep(1000);
	mainSleep(1000);

#if 0
	retval = thread1.Delete();
	errcodeT = thread1.GetLastError();
	printf("thread1.Delete retval = %d, error? = %d\n", retval, errcodeT);
	retval = thread2.Delete();
	errcodeT = thread2.GetLastError();
	printf("thread2.Delete retval = %d, error? = %d\n", retval, errcodeT);
	retval = thread3.Delete();
	errcodeT = thread3.GetLastError();
	printf("thread3.Delete retval = %d, error? = %d\n", retval, errcodeT);
#endif

	retval = sem.Release();
	errcodeS = sem.GetLastError();
	syslog(LOG_NOTICE, "sem.Release retval = %d, error? = %d\n", retval, errcodeS);
	retval = sem.Delete();
	errcodeS = sem.GetLastError();
	syslog(LOG_NOTICE, "sem.Delete retval = %d, error? = %d\n", retval, errcodeS);
#if 0
	retval = sem.Create(2);
	errcodeS = sem.GetLastError();
	printf("sem.Create retval = %d, error? = %d\n", retval, errcodeS);
#else
	retval = sem.Attach(SEM1);
	errcodeS = sem.GetLastError();
	syslog(LOG_NOTICE, "sem.Attach retval = %d, error? = %d\n", retval, errcodeS);
#endif
#if 0
	retval = sem.Delete();
	errcodeS = sem.GetLastError();
	syslog(LOG_NOTICE,"sem.Delete retval = %d, error? = %d\n", retval, errcodeS);
	retval = sem.Create(1);
	errcodeS = sem.GetLastError();
	printf("sem.Create retval = %d, error? = %d\n", retval, errcodeS);
#else
	retval = sem.Attach(SEM1);
	errcodeS = sem.GetLastError();
	syslog(LOG_NOTICE,"sem.Attach retval = %d, error? = %d\n", retval, errcodeS);
#endif

#if 0
	retval = thread1.Create(&tid1, THREAD_PRIORITY_HIGHEST, 0, 0, &fParam1, true);
	errcodeT = thread1.GetLastError();
	printf("thread1.Create retval = %d, error? = %d\n", retval, errcodeT);
	retval = thread2.Create(&tid2, THREAD_PRIORITY_NORMAL, 0, 0, &fParam2, true);
	errcodeT = thread2.GetLastError();
	printf("thread2.Create retval = %d, error? = %d\n", retval, errcodeT);
	retval = thread3.Create(&tid3, THREAD_PRIORITY_NORMAL, 0, 0, &fParam3, true);
	errcodeT = thread3.GetLastError();
	printf("thread3.Create retval = %d, error? = %d\n", retval, errcodeT);
#else
	retval = thread1.Attach(TASK4);
	errcodeT = thread1.GetLastError();
	syslog(LOG_NOTICE,"thread1.Attach retval = %d, error? = %d\n", retval, errcodeT);
	retval = thread2.Attach(TASK5);
	errcodeT = thread2.GetLastError();
	syslog(LOG_NOTICE,"thread2.Attach retval = %d, error? = %d\n", retval, errcodeT);
	retval = thread3.Attach(TASK6);
	errcodeT = thread3.GetLastError();
	syslog(LOG_NOTICE,"thread3.Attach retval = %d, error? = %d\n", retval, errcodeT);
#endif

	dly_tsk(50000);

#if 0
	retval = thread1.Delete();
	errcodeT = thread1.GetLastError();
	printf("thread1.Delete retval = %d, error? = %d\n", retval, errcodeT);
	retval = thread2.Delete();
	errcodeT = thread2.GetLastError();
	printf("thread2.Delete retval = %d, error? = %d\n", retval, errcodeT);
	retval = thread3.Delete();
	errcodeT = thread3.GetLastError();
	printf("thread3.Delete retval = %d, error? = %d\n", retval, errcodeT);
#else
	retval = thread1.Stop();
	errcodeT = thread1.GetLastError();
	syslog(LOG_NOTICE,"thread1.Stop retval = %d, error? = %d\n", retval, errcodeT);
	retval = thread2.Stop();
	errcodeT = thread2.GetLastError();
	syslog(LOG_NOTICE,"thread2.Stop retval = %d, error? = %d\n", retval, errcodeT);
	retval = thread3.Stop();
	errcodeT = thread3.GetLastError();
	syslog(LOG_NOTICE,"thread3.Stop retval = %d, error? = %d\n", retval, errcodeT);
#endif

	retval = sem.Delete();
	errcodeS = sem.GetLastError();
	syslog(LOG_NOTICE,"sem.Delete retval = %d, error? = %d\n", retval, errcodeS);

	syslog(LOG_NOTICE,"Hello World!\n");
	return 0;
}
