// osabst.cpp : R\[ AvP[Vp̃Gg |Cg̒`
//

#include <stdio.h>
//#include <process.h>
#include "PafeeSemaphore.h"
#include "PafeeTask.h"

using namespace Pafee;

PafeeSemaphore sem;
PafeeSemaphore::SEM_ERROR error;

void func1(void*);
void func2(void*);
void func3(void*);

class RealTask1 : public PafeeTask
{
public:
	~RealTask1()
	{
		/* do nothing */
	}

	void* TaskProcedure(void*)
	{
		void* param = 0;
		func1(param);
		return(param);
	}
};
class RealTask2 : public PafeeTask
{
public:
	~RealTask2()
	{
		/* do nothing */
	}

	void* TaskProcedure(void*)
	{
		void* param = 0;
		func2(param);
		return(param);
	}
};
class RealTask3 : public PafeeTask
{
public:
	~RealTask3()
	{
		/* do nothing */
	}

	void* TaskProcedure(void*)
	{
		void* param = 0;
		func3(param);
		return(param);
	}
};

void func1(
	void*	pParam
)
{
	char i = 0;
	while(1)
	{
		if(sem.AsyncTake() == true)
		{
			break;
		}
		else
		{
			error = sem.GetLastError();
			printf("func1error:%3d\n", error);
		}
	}
	for(i = 1; i<40; i++)
	{
		printf("#");
	}
	printf("\n");
	sem.Release();
}

void func2(
	void*	pParam
)
{
	char i = 0;
	if(sem.Take() == true)
	{
		printf("func2:go!");
	}
	else
	{
		error = sem.GetLastError();
		printf("func2error:%3d\n", error);
	}
	for(i = 1; i<40; i++)
	{
		printf("$");
	}
	printf("\n");
	sem.Release();
}

void func3(
	void*	pParam
)
{
	char i = 0;
	if(sem.TimedTake(500) == true)
	{
		printf("func3:0.5sec");
	}
	else
	{
		error = sem.GetLastError();
		printf("func3error:%3d\n", error);
		return;
	}
	for(i = 1; i<40; i++)
	{
		printf("@");
	}
	printf("\n");
	sem.Release();
}

void mainSleep(int count)
{
	unsigned int i, j;
	while(count--)
	{
		i=65535;
		j=65535;
		while(i)
		{
			while(j)
			{
				j--;
			}
			i--;
		}
	}
}

int main(int argc, char* argv[])
{
#if 0
	HANDLE	hThread[6];
	sem.Create(1);
	hThread[0] = (HANDLE)_beginthread(func1,0,NULL);
	hThread[1] = (HANDLE)_beginthread(func2,0,NULL);
	hThread[2] = (HANDLE)_beginthread(func3,0,NULL);
	hThread[3] = (HANDLE)_beginthread(func1,0,NULL);
	hThread[4] = (HANDLE)_beginthread(func2,0,NULL);
	hThread[5] = (HANDLE)_beginthread(func3,0,NULL);

	WaitForMultipleObjects(6,hThread,TRUE,INFINITE);
	
	sem.Delete();
#endif

	RealTask1 thread1, thread4;
	RealTask2 thread2, thread5;
	RealTask3 thread3, thread6;

	TASK_ID tid1, tid2, tid3, tid4, tid5, tid6;

	sem.Create(1);

	thread1.Create(&tid1, 4, 0, 0, NULL, false);
	thread2.Create(&tid2, 4, 0, 0, NULL, false);
	thread3.Create(&tid3, 4, 0, 0, NULL, false);
	thread4.Create(&tid4, 4, 0, 0, NULL, false);
	thread5.Create(&tid5, 4, 0, 0, NULL, false);
	thread6.Create(&tid6, 4, 0, 0, NULL, false);

	printf("all created...\n");

#ifndef PAFEE_OS_LINUX
	thread1.Start();
	thread2.Start();
	thread3.Start();
	thread4.Start();
	thread5.Start();
	thread6.Start();

//	printf("all started...\n");
	mainSleep(3000);

	thread1.Stop();
	thread2.Stop();
	thread3.Stop();
//	thread4.Stop();
//	thread5.Stop();
//	thread6.Stop();

//	printf("all stopped...\n");
//	mainSleep(1000);

	thread1.Start();
	thread2.Start();
	thread3.Start();
//	thread4.Start();
//	thread5.Start();
//	thread6.Start();
#endif
//	printf("all resumed...\n");

	mainSleep(5000);

	thread1.Delete();
	thread2.Delete();
	thread3.Delete();
	thread4.Delete();
	thread5.Delete();
	thread6.Delete();

	sem.Delete();
	printf("Hello World!\n");
	return 0;
}

