// osabst.cpp : R\[ AvP[Vp̃Gg |Cg̒`
//

#include <stdio.h>
//#include <process.h>
#include "PafeeSemaphore.h"
#include "PafeeTask.h"

using namespace Pafee;

PafeeSemaphore sem;
PafeeSemaphore::SEM_ERROR error;

typedef struct tagARGPARAM
{
	char output;
} ARGPARAM_T;

void func0(void*);
void func1(void*);
void func2(void*);
void func3(void*);

class RealTask0 : public PafeeTask
{
public:
	~RealTask0()
	{
		/* do nothing */
	}

	void* TaskProcedure(void* param)
	{
		func0(param);
		return(param);
	}
};
class RealTask1 : public PafeeTask
{
public:
	~RealTask1()
	{
		/* do nothing */
	}

	void* TaskProcedure(void* param)
	{
		func1(param);
		return(param);
	}
};
class RealTask2 : public PafeeTask
{
public:
	~RealTask2()
	{
		/* do nothing */
	}

	void* TaskProcedure(void* param)
	{
		func2(param);
		return(param);
	}
};
class RealTask3 : public PafeeTask
{
public:
	~RealTask3()
	{
		/* do nothing */
	}

	void* TaskProcedure(void* param)
	{
		func3(param);
		return(param);
	}
};

void mainSleep(int count)
{
	unsigned int i, j;
	while(count--)
	{
		i=65535;
		j=65535;
		while(i)
		{
			while(j)
			{
				j--;
			}
			i--;
		}
	}
}

void func0(
	void*	pParam
)
{
	char i = 0;
	ARGPARAM_T* pFuncParam = (ARGPARAM_T*)pParam;

	for(i = 1; i<40; i++)
	{
		printf("%c", pFuncParam->output);
	}
	printf("\n");
}
void func1(
	void*	pParam
)
{
	char i = 0;
	char count = 0;
	ARGPARAM_T* pFuncParam = (ARGPARAM_T*)pParam;

	while(count < 5)
	{
		if(sem.AsyncTake() == true)
		{
			for(i = 1; i<40; i++)
			{
				printf("%c", pFuncParam->output);
			}
			sem.Release();
			break;
		}
		else
		{
			error = sem.GetLastError();
			count++;
			printf("func1error:%3d\n", error);
		}
	}
	printf("\n");
}

void func2(
	void*	pParam
)
{
	char i = 0;
	ARGPARAM_T* pFuncParam = (ARGPARAM_T*)pParam;

	if(sem.Take() == true)
	{
		printf("func2:go!");
		for(i = 1; i<40; i++)
		{
			printf("%c", pFuncParam->output);
		}
		sem.Release();
	}
	else
	{
		error = sem.GetLastError();
		printf("func2error:%3d\n", error);
	}
	printf("\n");
}

void func3(
	void*	pParam
)
{
	char i = 0;
	ARGPARAM_T* pFuncParam = (ARGPARAM_T*)pParam;


	if(sem.TimedTake(200) == true)
	{
		printf("func3:200msec");
	}
	else
	{
		error = sem.GetLastError();
		printf("func3error:%3d\n", error);
		return;
	}
	for(i = 1; i<40; i++)
	{
		printf("%c", pFuncParam->output);
	}
	printf("\n");
	sem.Release();
}

int main(int argc, char* argv[])
{

	RealTask0 threadA, threadB, threadC;
	RealTask1 thread1;
	RealTask2 thread2;
	RealTask3 thread3;
	PafeeTask::TASK_ERROR errcodeT;
	PafeeSemaphore::SEM_ERROR errcodeS;
	bool retval = false;

	TASK_ID tidA, tidB, tidC, tid1, tid2, tid3;

	ARGPARAM_T fParamA = {'A'};
	ARGPARAM_T fParamB = {'B'};
	ARGPARAM_T fParamC = {'C'};
	ARGPARAM_T fParam1 = {'1'};
	ARGPARAM_T fParam2 = {'2'};
	ARGPARAM_T fParam3 = {'3'};

	retval = threadA.Start();
	errcodeT = threadA.GetLastError();
	printf("threadA.Start retval = %d, error? = %d\n", retval, errcodeT);
	retval = threadB.Stop();
	errcodeT = threadB.GetLastError();
	printf("threadB.Stop retval = %d, error? = %d\n", retval, errcodeT);
	retval = threadC.Delete();
	errcodeT = threadC.GetLastError();
	printf("threadC.Delete retval = %d, error? = %d\n", retval, errcodeT);
	retval = threadA.Delete();
	errcodeT = threadA.GetLastError();
	printf("threadA.Delete retval = %d, error? = %d\n", retval, errcodeT);

	retval = threadA.Create(&tidA, THREAD_PRIORITY_HIGHEST, 0, 0xff, &fParamA, false);
	errcodeT = threadA.GetLastError();
	printf("threadA.Create retval = %d, error? = %d\n", retval, errcodeT);
	retval = threadB.Create(&tidB, 800, 0, 0xff, &fParamB, true);
	errcodeT = threadB.GetLastError();
	printf("threadB.Create retval = %d, error? = %d\n", retval, errcodeT);
	retval = threadB.Create(&tidB, THREAD_PRIORITY_NORMAL, 0, 0xff, &fParamB, true);
	errcodeT = threadB.GetLastError();
	printf("threadB.Create retval = %d, error? = %d\n", retval, errcodeT);
	retval = threadC.Create(&tidC, THREAD_PRIORITY_NORMAL, 0, 0xff, &fParamC, false);
	errcodeT = threadC.GetLastError();
	printf("threadC.Create retval = %d, error? = %d\n", retval, errcodeT);

	retval = threadA.Start();
	errcodeT = threadA.GetLastError();
	printf("threadA.Start retval = %d, error? = %d\n", retval, errcodeT);
	retval = threadB.Stop();
	errcodeT = threadB.GetLastError();
	printf("threadB.Stop retval = %d, error? = %d\n", retval, errcodeT);
	retval = threadC.Delete();
	errcodeT = threadC.GetLastError();
	printf("threadC.Delete retval = %d, error? = %d\n", retval, errcodeT);
	retval = threadA.Delete();
	errcodeT = threadA.GetLastError();
	printf("threadA.Delete retval = %d, error? = %d\n", retval, errcodeT);
	retval = threadB.Stop();
	errcodeT = threadB.GetLastError();
	printf("threadB.Stop retval = %d, error? = %d\n", retval, errcodeT);
	retval = threadC.Delete();
	errcodeT = threadC.GetLastError();
	printf("threadC.Delete retval = %d, error? = %d\n", retval, errcodeT);
	retval = threadA.Delete();
	errcodeT = threadA.GetLastError();
	printf("threadA.Delete retval = %d, error? = %d\n", retval, errcodeT);
	retval = threadB.Start();
	errcodeT = threadB.GetLastError();
	printf("threadB.Start retval = %d, error? = %d\n", retval, errcodeT);
	retval = threadC.Start();
	errcodeT = threadC.GetLastError();
	printf("threadC.Start retval = %d, error? = %d\n", retval, errcodeT);


	printf("\n\n\n");

	retval = thread1.Create(&tid1, THREAD_PRIORITY_HIGHEST, 0, 0, &fParam1, true);
	errcodeT = thread1.GetLastError();
	printf("thread1.Create retval = %d, error? = %d\n", retval, errcodeT);
	retval = thread2.Create(&tid2, THREAD_PRIORITY_NORMAL, 0, 0, &fParam2, true);
	errcodeT = thread2.GetLastError();
	printf("thread2.Create retval = %d, error? = %d\n", retval, errcodeT);
	retval = thread3.Create(&tid3, THREAD_PRIORITY_NORMAL, 0, 0, &fParam3, true);
	errcodeT = thread3.GetLastError();
	printf("thread3.Create retval = %d, error? = %d\n", retval, errcodeT);

	mainSleep(5000);

	retval = thread1.Delete();
	errcodeT = thread1.GetLastError();
	printf("thread1.Delete retval = %d, error? = %d\n", retval, errcodeT);
	retval = thread2.Delete();
	errcodeT = thread2.GetLastError();
	printf("thread2.Delete retval = %d, error? = %d\n", retval, errcodeT);
	retval = thread3.Delete();
	errcodeT = thread3.GetLastError();
	printf("thread3.Delete retval = %d, error? = %d\n", retval, errcodeT);

	retval = sem.Release();
	errcodeS = sem.GetLastError();
	printf("sem.Release retval = %d, error? = %d\n", retval, errcodeS);
	retval = sem.Delete();
	errcodeS = sem.GetLastError();
	printf("sem.Delete retval = %d, error? = %d\n", retval, errcodeS);
	retval = sem.Create(2);
	errcodeS = sem.GetLastError();
	printf("sem.Create retval = %d, error? = %d\n", retval, errcodeS);
	retval = sem.Delete();
	errcodeS = sem.GetLastError();
	printf("sem.Delete retval = %d, error? = %d\n", retval, errcodeS);
	retval = sem.Create(1);
	errcodeS = sem.GetLastError();
	printf("sem.Create retval = %d, error? = %d\n", retval, errcodeS);


	retval = thread1.Create(&tid1, THREAD_PRIORITY_HIGHEST, 0, 0, &fParam1, true);
	errcodeT = thread1.GetLastError();
	printf("thread1.Create retval = %d, error? = %d\n", retval, errcodeT);
	retval = thread2.Create(&tid2, THREAD_PRIORITY_NORMAL, 0, 0, &fParam2, true);
	errcodeT = thread2.GetLastError();
	printf("thread2.Create retval = %d, error? = %d\n", retval, errcodeT);
	retval = thread3.Create(&tid3, THREAD_PRIORITY_NORMAL, 0, 0, &fParam3, true);
	errcodeT = thread3.GetLastError();
	printf("thread3.Create retval = %d, error? = %d\n", retval, errcodeT);

	mainSleep(8000);

	retval = thread1.Delete();
	errcodeT = thread1.GetLastError();
	printf("thread1.Delete retval = %d, error? = %d\n", retval, errcodeT);
	retval = thread2.Delete();
	errcodeT = thread2.GetLastError();
	printf("thread2.Delete retval = %d, error? = %d\n", retval, errcodeT);
	retval = thread3.Delete();
	errcodeT = thread3.GetLastError();
	printf("thread3.Delete retval = %d, error? = %d\n", retval, errcodeT);

	retval = sem.Delete();
	errcodeS = sem.GetLastError();
	printf("sem.Delete retval = %d, error? = %d\n", retval, errcodeS);

	printf("Hello World!\n");
	return 0;
}
