#ifdef PAFEE_OS_WINDOWS
#include <windows.h>
#endif
#ifdef PAFEE_OS_LINUX
#include <unistd.h>
#endif

#include "PafeeSignal.h"
#include "PafeeTask.h"
using namespace Pafee;

int pafeeCount1 = 0;
int pafeeCount2 = 0;
int pafeeCount3 = 0;

PafeeSignal pafeeSignal1;
PafeeSignal pafeeSignal2;
PafeeSignal pafeeSignal3;

class TaskSignal1 : public PafeeTask
{
public:
	void* TaskProcedure(
		void* pParam
	);
};

class TaskSignal2 : public PafeeTask
{
public:
	void* TaskProcedure(
		void* pParam
	);
};

class TaskSignal3 : public PafeeTask
{
public:
	void* TaskProcedure(
		void* pParam
	);
};

class TaskSignal4 : public PafeeTask
{
public:
	void* TaskProcedure(
		void* pParam
	);
};

class TaskSignal5 : public PafeeTask
{
public:
	void* TaskProcedure(
		void* pParam
	);
};

class TaskSignal6 : public PafeeTask
{
public:
	void* TaskProcedure(
		void* pParam
	);
};

class TaskSignal7 : public PafeeTask
{
public:
	void* TaskProcedure(
		void* pParam
	);
};

void pafeeSeep(unsigned long time);
int main(int argc, char* argv[])
{
	TaskSignal1 task1; // access mutex1,mutex2,mutex3
	TaskSignal2 task2; // access mutex1 at Wait
	TaskSignal3 task3; // access mutex2 at AsyncWait
	TaskSignal4 task4; // access mutex3 at TimedWait
	TaskSignal5 task5; // access mutex1 at Wait
	TaskSignal6 task6; // access mutex2 at AsyncWait
	TaskSignal7 task7; // access mutex3 at TimedWait
	PafeeTask::TASK_ID id1;
	PafeeTask::TASK_ID id2;
	PafeeTask::TASK_ID id3;
	PafeeTask::TASK_ID id4;
	PafeeTask::TASK_ID id5;
	PafeeTask::TASK_ID id6;
	PafeeTask::TASK_ID id7;
	bool returnCode;
	PafeeSignal::SIGNAL_ERROR errorCode;

	/* None Signal access test */
	errorCode = pafeeSignal1.GetLastError();
	SIGNAL_DEBUG(("ErrorCode:Start %d\n", errorCode));
	pafeeSignal1.Delete();
	errorCode = pafeeSignal1.GetLastError();
	SIGNAL_DEBUG(("ErrorCode:Delete %d\n", errorCode));
	pafeeSignal1.Wait();
	errorCode = pafeeSignal1.GetLastError();
	SIGNAL_DEBUG(("ErrorCode:Wait %d\n", errorCode));
	pafeeSignal1.AsyncWait();
	errorCode = pafeeSignal1.GetLastError();
	SIGNAL_DEBUG(("ErrorCode:AsyncWait %d\n", errorCode));
	pafeeSignal1.TimedWait(50);
	errorCode = pafeeSignal1.GetLastError();
	SIGNAL_DEBUG(("ErrorCode:TimedWait %d\n", errorCode));
	pafeeSignal1.Send();
	errorCode = pafeeSignal1.GetLastError();
	SIGNAL_DEBUG(("ErrorCode:Send %d\n", errorCode));

	/* Craete Test */
	returnCode = pafeeSignal1.Create();
	if(returnCode == true)
	{
		SIGNAL_DEBUG(("Create1 success on main\n"));
	}
	else
	{
		SIGNAL_DEBUG(("Create1 failed on main\n"));
	}

	/* Craete Test */
	returnCode = pafeeSignal2.Create();
	if(returnCode == true)
	{
		SIGNAL_DEBUG(("Create2 success on main\n"));
	}
	else
	{
		SIGNAL_DEBUG(("Create2 failed on main\n"));
	}

	/* Craete Test */
	returnCode = pafeeSignal3.Create();
	if(returnCode == true)
	{
		SIGNAL_DEBUG(("Create3 success on main\n"));
	}
	else
	{
		SIGNAL_DEBUG(("Create3 failed on main\n"));
	}

	/* Double craete Test */
	returnCode = pafeeSignal1.Create();
	if(returnCode == true)
	{
		SIGNAL_DEBUG(("Create1 success on main\n"));
	}
	else
	{
		SIGNAL_DEBUG(("Create1 failed on main\n"));
	}

	/* Delete Test */
	returnCode = pafeeSignal1.Delete();
	if(returnCode == true)
	{
		SIGNAL_DEBUG(("Delete1 success on main\n"));
	}
	else
	{
		SIGNAL_DEBUG(("Delete1 failed on main\n"));
	}

	/* Recraete Test */
	returnCode = pafeeSignal1.Create();
	if(returnCode == true)
	{
		SIGNAL_DEBUG(("Create success on main\n"));
	}
	else
	{
		SIGNAL_DEBUG(("Create failed on main\n"));
	}

	task1.Create(&id1, 1, 0, 0, NULL, true);
//	task2.Create(&id2, 1, 0, 0, NULL, true);
//	task3.Create(&id3, 1, 0, 0, NULL, true);
	task4.Create(&id4, 1, 0, 0, NULL, true);
//	task5.Create(&id5, 1, 0, 0, NULL, true);
//	task6.Create(&id6, 1, 0, 0, NULL, true);
	task7.Create(&id7, 1, 0, 0, NULL, true);

	pafeeSeep(200);

	/* Delete Test while use mutex */
#if 0
	returnCode = pafeeSignal1.Delete();
	if(returnCode == true)
	{
		SIGNAL_DEBUG(("Delete success on main\n"));
	}
	else
	{
		SIGNAL_DEBUG(("Delete failed on main\n"));
	}
#endif
	while(1);

	return 0;
}

/* Task1 */
void * TaskSignal1::TaskProcedure(
	void* pParam
)
{
	int	i;
	bool locked;
	while(1){
		SIGNAL_DEBUG(("pafeeCount1:"));
		for(i=0;i<10;i++){
			SIGNAL_DEBUG(("%d:",pafeeCount1));
			pafeeCount1++;
			pafeeSeep(1);
		}
		SIGNAL_DEBUG(("\n"));

		SIGNAL_DEBUG(("pafeeCount2:"));
		for(i=0;i<10;i++){
			SIGNAL_DEBUG(("%d:",pafeeCount2));
			pafeeCount2++;
			pafeeSeep(1);
		}
		SIGNAL_DEBUG(("\n"));

		SIGNAL_DEBUG(("pafeeCount3:"));
		for(i=0;i<10;i++){
			SIGNAL_DEBUG(("%d:",pafeeCount3));
			pafeeCount3++;
			pafeeSeep(1);
		}
		SIGNAL_DEBUG(("\n"));
		locked = pafeeSignal1.Send();
		locked = pafeeSignal2.Send();
		locked = pafeeSignal3.Send();
	}
}

/* Task2 */
void * TaskSignal2::TaskProcedure(
	void* pParam
)
{
	bool locked;
	PafeeSignal::SIGNAL_ERROR errorCode;
	while(1){
		locked = pafeeSignal1.Wait();
		if(locked == true)
		{
			SIGNAL_DEBUG(("Task2:Wait OK\n"));
			pafeeCount1=0;
		}
		else
		{
			SIGNAL_DEBUG(("Task2:Wait NG\n"));
			errorCode = pafeeSignal1.GetLastError();
			SIGNAL_DEBUG(("ErrorCode:Task2 %d\n", errorCode));
		}

		pafeeSeep(4);
	}
}

/* Task3 */
void * TaskSignal3::TaskProcedure(
	void* pParam
)
{
	bool locked;
	PafeeSignal::SIGNAL_ERROR errorCode;
	while(1){
		locked = pafeeSignal2.AsyncWait();
		if(locked == true)
		{
			SIGNAL_DEBUG(("Task3:AsyncWait OK\n"));
			pafeeCount2=0;
		}
		else
		{
			SIGNAL_DEBUG(("Task3:AsyncWait NG\n"));
			errorCode = pafeeSignal2.GetLastError();
			SIGNAL_DEBUG(("ErrorCode:Task3 %d\n", errorCode));
		}

		pafeeSeep(4);
	}
}

/* Task4 */
void * TaskSignal4::TaskProcedure(
	void* pParam
)
{
	bool locked;
	PafeeSignal::SIGNAL_ERROR errorCode;
	while(1){
		locked = pafeeSignal3.TimedWait(100);
		if(locked == true)
		{
			SIGNAL_DEBUG(("Task4:TimedWait OK\n"));
			pafeeCount3=0;
		}
		else
		{
			SIGNAL_DEBUG(("Task4:TimedWait NG\n"));
			errorCode = pafeeSignal3.GetLastError();
			SIGNAL_DEBUG(("ErrorCode:Task4 %d\n", errorCode));
		}

		pafeeSeep(4);
	}
}

/* Task5 */
void * TaskSignal5::TaskProcedure(
	void* pParam
)
{
	bool locked;
	PafeeSignal::SIGNAL_ERROR errorCode;
	while(1){
		locked = pafeeSignal1.Wait();
		if(locked == true)
		{
			SIGNAL_DEBUG(("Task5:Wait OK\n"));
			pafeeCount1=100;
		}
		else
		{
			SIGNAL_DEBUG(("Task5:Wait NG\n"));
			errorCode = pafeeSignal1.GetLastError();
			SIGNAL_DEBUG(("ErrorCode:Task5 %d\n", errorCode));
		}

		pafeeSeep(4);
	}
}

/* Task6 */
void * TaskSignal6::TaskProcedure(
	void* pParam
)
{
	bool locked;
	PafeeSignal::SIGNAL_ERROR errorCode;
	while(1){
		locked = pafeeSignal2.AsyncWait();
		if(locked == true)
		{
			SIGNAL_DEBUG(("Task6:AsyncWait OK\n"));
			pafeeCount2=100;
		}
		else
		{
			SIGNAL_DEBUG(("Task6:AsyncWait NG\n"));
			errorCode = pafeeSignal2.GetLastError();
			SIGNAL_DEBUG(("ErrorCode:Task6 %d\n", errorCode));
		}

		pafeeSeep(4);
	}
}

/* Task7 */
void * TaskSignal7::TaskProcedure(
	void* pParam
)
{
	bool locked;
	PafeeSignal::SIGNAL_ERROR errorCode;
	while(1){
		locked = pafeeSignal3.TimedWait(100);
		if(locked == true)
		{
			SIGNAL_DEBUG(("Task7:TimedWait OK\n"));
			pafeeCount3=100;
		}
		else
		{
			SIGNAL_DEBUG(("Task7:TimedWait NG\n"));
			errorCode = pafeeSignal3.GetLastError();
			SIGNAL_DEBUG(("ErrorCode:Task7 %d\n", errorCode));
		}

		pafeeSeep(4);
	}
}

void pafeeSeep(unsigned long time)
{
#ifdef PAFEE_OS_WINDOWS
	Sleep(time*1000);
#endif
#ifdef PAFEE_OS_LINUX
	sleep(time);
#endif
}